/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Account
    /// </summary>
    [DataContract]
    public partial class Account :  IEquatable<Account>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Account" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected Account() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="Account" /> class.
        /// </summary>
        /// <param name="id">Account id (required).</param>
        /// <param name="firstName">First Name (required).</param>
        /// <param name="lastName">Last Name (required).</param>
        /// <param name="usedQuotaPrivate">Account used private quota (required).</param>
        /// <param name="modifiedDate">Date of last account modification (required).</param>
        /// <param name="usedQuota">Account total used quota (required).</param>
        /// <param name="createdDate">Date when account was created (required).</param>
        /// <param name="quota">Account quota (required).</param>
        /// <param name="groupId">Account group id (required).</param>
        /// <param name="institutionUserId">Account institution user id (required).</param>
        /// <param name="institutionId">Account institution (required).</param>
        /// <param name="email">User email (required).</param>
        /// <param name="usedQuotaPublic">Account public used quota (required).</param>
        /// <param name="pendingQuotaRequest">True if a quota request is pending (required).</param>
        /// <param name="active">Account activity status (required).</param>
        /// <param name="maximumFileSize">Maximum upload size for account (required).</param>
        public Account(long? id = default(long?), string firstName = default(string), string lastName = default(string), long? usedQuotaPrivate = default(long?), string modifiedDate = default(string), long? usedQuota = default(long?), string createdDate = default(string), long? quota = default(long?), long? groupId = default(long?), string institutionUserId = default(string), long? institutionId = default(long?), string email = default(string), long? usedQuotaPublic = default(long?), bool? pendingQuotaRequest = default(bool?), long? active = default(long?), long? maximumFileSize = default(long?))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for Account and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "firstName" is required (not null)
            if (firstName == null)
            {
                throw new InvalidDataException("firstName is a required property for Account and cannot be null");
            }
            else
            {
                this.FirstName = firstName;
            }
            // to ensure "lastName" is required (not null)
            if (lastName == null)
            {
                throw new InvalidDataException("lastName is a required property for Account and cannot be null");
            }
            else
            {
                this.LastName = lastName;
            }
            // to ensure "usedQuotaPrivate" is required (not null)
            if (usedQuotaPrivate == null)
            {
                throw new InvalidDataException("usedQuotaPrivate is a required property for Account and cannot be null");
            }
            else
            {
                this.UsedQuotaPrivate = usedQuotaPrivate;
            }
            // to ensure "modifiedDate" is required (not null)
            if (modifiedDate == null)
            {
                throw new InvalidDataException("modifiedDate is a required property for Account and cannot be null");
            }
            else
            {
                this.ModifiedDate = modifiedDate;
            }
            // to ensure "usedQuota" is required (not null)
            if (usedQuota == null)
            {
                throw new InvalidDataException("usedQuota is a required property for Account and cannot be null");
            }
            else
            {
                this.UsedQuota = usedQuota;
            }
            // to ensure "createdDate" is required (not null)
            if (createdDate == null)
            {
                throw new InvalidDataException("createdDate is a required property for Account and cannot be null");
            }
            else
            {
                this.CreatedDate = createdDate;
            }
            // to ensure "quota" is required (not null)
            if (quota == null)
            {
                throw new InvalidDataException("quota is a required property for Account and cannot be null");
            }
            else
            {
                this.Quota = quota;
            }
            // to ensure "groupId" is required (not null)
            if (groupId == null)
            {
                throw new InvalidDataException("groupId is a required property for Account and cannot be null");
            }
            else
            {
                this.GroupId = groupId;
            }
            // to ensure "institutionUserId" is required (not null)
            if (institutionUserId == null)
            {
                throw new InvalidDataException("institutionUserId is a required property for Account and cannot be null");
            }
            else
            {
                this.InstitutionUserId = institutionUserId;
            }
            // to ensure "institutionId" is required (not null)
            if (institutionId == null)
            {
                throw new InvalidDataException("institutionId is a required property for Account and cannot be null");
            }
            else
            {
                this.InstitutionId = institutionId;
            }
            // to ensure "email" is required (not null)
            if (email == null)
            {
                throw new InvalidDataException("email is a required property for Account and cannot be null");
            }
            else
            {
                this.Email = email;
            }
            // to ensure "usedQuotaPublic" is required (not null)
            if (usedQuotaPublic == null)
            {
                throw new InvalidDataException("usedQuotaPublic is a required property for Account and cannot be null");
            }
            else
            {
                this.UsedQuotaPublic = usedQuotaPublic;
            }
            // to ensure "pendingQuotaRequest" is required (not null)
            if (pendingQuotaRequest == null)
            {
                throw new InvalidDataException("pendingQuotaRequest is a required property for Account and cannot be null");
            }
            else
            {
                this.PendingQuotaRequest = pendingQuotaRequest;
            }
            // to ensure "active" is required (not null)
            if (active == null)
            {
                throw new InvalidDataException("active is a required property for Account and cannot be null");
            }
            else
            {
                this.Active = active;
            }
            // to ensure "maximumFileSize" is required (not null)
            if (maximumFileSize == null)
            {
                throw new InvalidDataException("maximumFileSize is a required property for Account and cannot be null");
            }
            else
            {
                this.MaximumFileSize = maximumFileSize;
            }
        }
        
        /// <summary>
        /// Account id
        /// </summary>
        /// <value>Account id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// First Name
        /// </summary>
        /// <value>First Name</value>
        [DataMember(Name="first_name", EmitDefaultValue=false)]
        public string FirstName { get; set; }

        /// <summary>
        /// Last Name
        /// </summary>
        /// <value>Last Name</value>
        [DataMember(Name="last_name", EmitDefaultValue=false)]
        public string LastName { get; set; }

        /// <summary>
        /// Account used private quota
        /// </summary>
        /// <value>Account used private quota</value>
        [DataMember(Name="used_quota_private", EmitDefaultValue=false)]
        public long? UsedQuotaPrivate { get; set; }

        /// <summary>
        /// Date of last account modification
        /// </summary>
        /// <value>Date of last account modification</value>
        [DataMember(Name="modified_date", EmitDefaultValue=false)]
        public string ModifiedDate { get; set; }

        /// <summary>
        /// Account total used quota
        /// </summary>
        /// <value>Account total used quota</value>
        [DataMember(Name="used_quota", EmitDefaultValue=false)]
        public long? UsedQuota { get; set; }

        /// <summary>
        /// Date when account was created
        /// </summary>
        /// <value>Date when account was created</value>
        [DataMember(Name="created_date", EmitDefaultValue=false)]
        public string CreatedDate { get; set; }

        /// <summary>
        /// Account quota
        /// </summary>
        /// <value>Account quota</value>
        [DataMember(Name="quota", EmitDefaultValue=false)]
        public long? Quota { get; set; }

        /// <summary>
        /// Account group id
        /// </summary>
        /// <value>Account group id</value>
        [DataMember(Name="group_id", EmitDefaultValue=false)]
        public long? GroupId { get; set; }

        /// <summary>
        /// Account institution user id
        /// </summary>
        /// <value>Account institution user id</value>
        [DataMember(Name="institution_user_id", EmitDefaultValue=false)]
        public string InstitutionUserId { get; set; }

        /// <summary>
        /// Account institution
        /// </summary>
        /// <value>Account institution</value>
        [DataMember(Name="institution_id", EmitDefaultValue=false)]
        public long? InstitutionId { get; set; }

        /// <summary>
        /// User email
        /// </summary>
        /// <value>User email</value>
        [DataMember(Name="email", EmitDefaultValue=false)]
        public string Email { get; set; }

        /// <summary>
        /// Account public used quota
        /// </summary>
        /// <value>Account public used quota</value>
        [DataMember(Name="used_quota_public", EmitDefaultValue=false)]
        public long? UsedQuotaPublic { get; set; }

        /// <summary>
        /// True if a quota request is pending
        /// </summary>
        /// <value>True if a quota request is pending</value>
        [DataMember(Name="pending_quota_request", EmitDefaultValue=false)]
        public bool? PendingQuotaRequest { get; set; }

        /// <summary>
        /// Account activity status
        /// </summary>
        /// <value>Account activity status</value>
        [DataMember(Name="active", EmitDefaultValue=false)]
        public long? Active { get; set; }

        /// <summary>
        /// Maximum upload size for account
        /// </summary>
        /// <value>Maximum upload size for account</value>
        [DataMember(Name="maximum_file_size", EmitDefaultValue=false)]
        public long? MaximumFileSize { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Account {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  FirstName: ").Append(FirstName).Append("\n");
            sb.Append("  LastName: ").Append(LastName).Append("\n");
            sb.Append("  UsedQuotaPrivate: ").Append(UsedQuotaPrivate).Append("\n");
            sb.Append("  ModifiedDate: ").Append(ModifiedDate).Append("\n");
            sb.Append("  UsedQuota: ").Append(UsedQuota).Append("\n");
            sb.Append("  CreatedDate: ").Append(CreatedDate).Append("\n");
            sb.Append("  Quota: ").Append(Quota).Append("\n");
            sb.Append("  GroupId: ").Append(GroupId).Append("\n");
            sb.Append("  InstitutionUserId: ").Append(InstitutionUserId).Append("\n");
            sb.Append("  InstitutionId: ").Append(InstitutionId).Append("\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("  UsedQuotaPublic: ").Append(UsedQuotaPublic).Append("\n");
            sb.Append("  PendingQuotaRequest: ").Append(PendingQuotaRequest).Append("\n");
            sb.Append("  Active: ").Append(Active).Append("\n");
            sb.Append("  MaximumFileSize: ").Append(MaximumFileSize).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Account);
        }

        /// <summary>
        /// Returns true if Account instances are equal
        /// </summary>
        /// <param name="input">Instance of Account to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Account input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.FirstName == input.FirstName ||
                    (this.FirstName != null &&
                    this.FirstName.Equals(input.FirstName))
                ) && 
                (
                    this.LastName == input.LastName ||
                    (this.LastName != null &&
                    this.LastName.Equals(input.LastName))
                ) && 
                (
                    this.UsedQuotaPrivate == input.UsedQuotaPrivate ||
                    (this.UsedQuotaPrivate != null &&
                    this.UsedQuotaPrivate.Equals(input.UsedQuotaPrivate))
                ) && 
                (
                    this.ModifiedDate == input.ModifiedDate ||
                    (this.ModifiedDate != null &&
                    this.ModifiedDate.Equals(input.ModifiedDate))
                ) && 
                (
                    this.UsedQuota == input.UsedQuota ||
                    (this.UsedQuota != null &&
                    this.UsedQuota.Equals(input.UsedQuota))
                ) && 
                (
                    this.CreatedDate == input.CreatedDate ||
                    (this.CreatedDate != null &&
                    this.CreatedDate.Equals(input.CreatedDate))
                ) && 
                (
                    this.Quota == input.Quota ||
                    (this.Quota != null &&
                    this.Quota.Equals(input.Quota))
                ) && 
                (
                    this.GroupId == input.GroupId ||
                    (this.GroupId != null &&
                    this.GroupId.Equals(input.GroupId))
                ) && 
                (
                    this.InstitutionUserId == input.InstitutionUserId ||
                    (this.InstitutionUserId != null &&
                    this.InstitutionUserId.Equals(input.InstitutionUserId))
                ) && 
                (
                    this.InstitutionId == input.InstitutionId ||
                    (this.InstitutionId != null &&
                    this.InstitutionId.Equals(input.InstitutionId))
                ) && 
                (
                    this.Email == input.Email ||
                    (this.Email != null &&
                    this.Email.Equals(input.Email))
                ) && 
                (
                    this.UsedQuotaPublic == input.UsedQuotaPublic ||
                    (this.UsedQuotaPublic != null &&
                    this.UsedQuotaPublic.Equals(input.UsedQuotaPublic))
                ) && 
                (
                    this.PendingQuotaRequest == input.PendingQuotaRequest ||
                    (this.PendingQuotaRequest != null &&
                    this.PendingQuotaRequest.Equals(input.PendingQuotaRequest))
                ) && 
                (
                    this.Active == input.Active ||
                    (this.Active != null &&
                    this.Active.Equals(input.Active))
                ) && 
                (
                    this.MaximumFileSize == input.MaximumFileSize ||
                    (this.MaximumFileSize != null &&
                    this.MaximumFileSize.Equals(input.MaximumFileSize))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.FirstName != null)
                    hashCode = hashCode * 59 + this.FirstName.GetHashCode();
                if (this.LastName != null)
                    hashCode = hashCode * 59 + this.LastName.GetHashCode();
                if (this.UsedQuotaPrivate != null)
                    hashCode = hashCode * 59 + this.UsedQuotaPrivate.GetHashCode();
                if (this.ModifiedDate != null)
                    hashCode = hashCode * 59 + this.ModifiedDate.GetHashCode();
                if (this.UsedQuota != null)
                    hashCode = hashCode * 59 + this.UsedQuota.GetHashCode();
                if (this.CreatedDate != null)
                    hashCode = hashCode * 59 + this.CreatedDate.GetHashCode();
                if (this.Quota != null)
                    hashCode = hashCode * 59 + this.Quota.GetHashCode();
                if (this.GroupId != null)
                    hashCode = hashCode * 59 + this.GroupId.GetHashCode();
                if (this.InstitutionUserId != null)
                    hashCode = hashCode * 59 + this.InstitutionUserId.GetHashCode();
                if (this.InstitutionId != null)
                    hashCode = hashCode * 59 + this.InstitutionId.GetHashCode();
                if (this.Email != null)
                    hashCode = hashCode * 59 + this.Email.GetHashCode();
                if (this.UsedQuotaPublic != null)
                    hashCode = hashCode * 59 + this.UsedQuotaPublic.GetHashCode();
                if (this.PendingQuotaRequest != null)
                    hashCode = hashCode * 59 + this.PendingQuotaRequest.GetHashCode();
                if (this.Active != null)
                    hashCode = hashCode * 59 + this.Active.GetHashCode();
                if (this.MaximumFileSize != null)
                    hashCode = hashCode * 59 + this.MaximumFileSize.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
