/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// AccountCreate
    /// </summary>
    [DataContract]
    public partial class AccountCreate :  IEquatable<AccountCreate>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AccountCreate" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected AccountCreate() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="AccountCreate" /> class.
        /// </summary>
        /// <param name="email">Email of account (required).</param>
        /// <param name="firstName">First Name (required) (default to &quot;&quot;).</param>
        /// <param name="lastName">Last Name (default to &quot;&quot;).</param>
        /// <param name="groupId">Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups.</param>
        /// <param name="institutionUserId">Institution user id (default to &quot;&quot;).</param>
        /// <param name="symplecticUserId">Symplectic user id (default to &quot;&quot;).</param>
        /// <param name="quota">Account quota.</param>
        /// <param name="isActive">Is account active.</param>
        public AccountCreate(string email = default(string), string firstName = "", string lastName = "", long? groupId = default(long?), string institutionUserId = "", string symplecticUserId = "", long? quota = default(long?), bool? isActive = default(bool?))
        {
            // to ensure "email" is required (not null)
            if (email == null)
            {
                throw new InvalidDataException("email is a required property for AccountCreate and cannot be null");
            }
            else
            {
                this.Email = email;
            }
            // to ensure "firstName" is required (not null)
            if (firstName == null)
            {
                throw new InvalidDataException("firstName is a required property for AccountCreate and cannot be null");
            }
            else
            {
                this.FirstName = firstName;
            }
            // use default value if no "lastName" provided
            if (lastName == null)
            {
                this.LastName = "";
            }
            else
            {
                this.LastName = lastName;
            }
            this.GroupId = groupId;
            // use default value if no "institutionUserId" provided
            if (institutionUserId == null)
            {
                this.InstitutionUserId = "";
            }
            else
            {
                this.InstitutionUserId = institutionUserId;
            }
            // use default value if no "symplecticUserId" provided
            if (symplecticUserId == null)
            {
                this.SymplecticUserId = "";
            }
            else
            {
                this.SymplecticUserId = symplecticUserId;
            }
            this.Quota = quota;
            this.IsActive = isActive;
        }
        
        /// <summary>
        /// Email of account
        /// </summary>
        /// <value>Email of account</value>
        [DataMember(Name="email", EmitDefaultValue=false)]
        public string Email { get; set; }

        /// <summary>
        /// First Name
        /// </summary>
        /// <value>First Name</value>
        [DataMember(Name="first_name", EmitDefaultValue=false)]
        public string FirstName { get; set; }

        /// <summary>
        /// Last Name
        /// </summary>
        /// <value>Last Name</value>
        [DataMember(Name="last_name", EmitDefaultValue=false)]
        public string LastName { get; set; }

        /// <summary>
        /// Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups
        /// </summary>
        /// <value>Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups</value>
        [DataMember(Name="group_id", EmitDefaultValue=false)]
        public long? GroupId { get; set; }

        /// <summary>
        /// Institution user id
        /// </summary>
        /// <value>Institution user id</value>
        [DataMember(Name="institution_user_id", EmitDefaultValue=false)]
        public string InstitutionUserId { get; set; }

        /// <summary>
        /// Symplectic user id
        /// </summary>
        /// <value>Symplectic user id</value>
        [DataMember(Name="symplectic_user_id", EmitDefaultValue=false)]
        public string SymplecticUserId { get; set; }

        /// <summary>
        /// Account quota
        /// </summary>
        /// <value>Account quota</value>
        [DataMember(Name="quota", EmitDefaultValue=false)]
        public long? Quota { get; set; }

        /// <summary>
        /// Is account active
        /// </summary>
        /// <value>Is account active</value>
        [DataMember(Name="is_active", EmitDefaultValue=false)]
        public bool? IsActive { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AccountCreate {\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("  FirstName: ").Append(FirstName).Append("\n");
            sb.Append("  LastName: ").Append(LastName).Append("\n");
            sb.Append("  GroupId: ").Append(GroupId).Append("\n");
            sb.Append("  InstitutionUserId: ").Append(InstitutionUserId).Append("\n");
            sb.Append("  SymplecticUserId: ").Append(SymplecticUserId).Append("\n");
            sb.Append("  Quota: ").Append(Quota).Append("\n");
            sb.Append("  IsActive: ").Append(IsActive).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AccountCreate);
        }

        /// <summary>
        /// Returns true if AccountCreate instances are equal
        /// </summary>
        /// <param name="input">Instance of AccountCreate to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AccountCreate input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Email == input.Email ||
                    (this.Email != null &&
                    this.Email.Equals(input.Email))
                ) && 
                (
                    this.FirstName == input.FirstName ||
                    (this.FirstName != null &&
                    this.FirstName.Equals(input.FirstName))
                ) && 
                (
                    this.LastName == input.LastName ||
                    (this.LastName != null &&
                    this.LastName.Equals(input.LastName))
                ) && 
                (
                    this.GroupId == input.GroupId ||
                    (this.GroupId != null &&
                    this.GroupId.Equals(input.GroupId))
                ) && 
                (
                    this.InstitutionUserId == input.InstitutionUserId ||
                    (this.InstitutionUserId != null &&
                    this.InstitutionUserId.Equals(input.InstitutionUserId))
                ) && 
                (
                    this.SymplecticUserId == input.SymplecticUserId ||
                    (this.SymplecticUserId != null &&
                    this.SymplecticUserId.Equals(input.SymplecticUserId))
                ) && 
                (
                    this.Quota == input.Quota ||
                    (this.Quota != null &&
                    this.Quota.Equals(input.Quota))
                ) && 
                (
                    this.IsActive == input.IsActive ||
                    (this.IsActive != null &&
                    this.IsActive.Equals(input.IsActive))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Email != null)
                    hashCode = hashCode * 59 + this.Email.GetHashCode();
                if (this.FirstName != null)
                    hashCode = hashCode * 59 + this.FirstName.GetHashCode();
                if (this.LastName != null)
                    hashCode = hashCode * 59 + this.LastName.GetHashCode();
                if (this.GroupId != null)
                    hashCode = hashCode * 59 + this.GroupId.GetHashCode();
                if (this.InstitutionUserId != null)
                    hashCode = hashCode * 59 + this.InstitutionUserId.GetHashCode();
                if (this.SymplecticUserId != null)
                    hashCode = hashCode * 59 + this.SymplecticUserId.GetHashCode();
                if (this.Quota != null)
                    hashCode = hashCode * 59 + this.Quota.GetHashCode();
                if (this.IsActive != null)
                    hashCode = hashCode * 59 + this.IsActive.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Email (string) maxLength
            if(this.Email != null && this.Email.Length > 150)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Email, length must be less than 150.", new [] { "Email" });
            }

            // Email (string) minLength
            if(this.Email != null && this.Email.Length < 3)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Email, length must be greater than 3.", new [] { "Email" });
            }

            // FirstName (string) maxLength
            if(this.FirstName != null && this.FirstName.Length > 30)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FirstName, length must be less than 30.", new [] { "FirstName" });
            }

            // LastName (string) maxLength
            if(this.LastName != null && this.LastName.Length > 30)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for LastName, length must be less than 30.", new [] { "LastName" });
            }

            // InstitutionUserId (string) maxLength
            if(this.InstitutionUserId != null && this.InstitutionUserId.Length > 50)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for InstitutionUserId, length must be less than 50.", new [] { "InstitutionUserId" });
            }

            // SymplecticUserId (string) maxLength
            if(this.SymplecticUserId != null && this.SymplecticUserId.Length > 50)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SymplecticUserId, length must be less than 50.", new [] { "SymplecticUserId" });
            }

            yield break;
        }
    }

}
