/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ArticleConfidentiality
    /// </summary>
    [DataContract]
    public partial class ArticleConfidentiality :  IEquatable<ArticleConfidentiality>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ArticleConfidentiality" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ArticleConfidentiality() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ArticleConfidentiality" /> class.
        /// </summary>
        /// <param name="isConfidential">True if article is confidential (required).</param>
        /// <param name="reason">Reason for confidentiality (required).</param>
        public ArticleConfidentiality(bool? isConfidential = default(bool?), string reason = default(string))
        {
            // to ensure "isConfidential" is required (not null)
            if (isConfidential == null)
            {
                throw new InvalidDataException("isConfidential is a required property for ArticleConfidentiality and cannot be null");
            }
            else
            {
                this.IsConfidential = isConfidential;
            }
            // to ensure "reason" is required (not null)
            if (reason == null)
            {
                throw new InvalidDataException("reason is a required property for ArticleConfidentiality and cannot be null");
            }
            else
            {
                this.Reason = reason;
            }
        }
        
        /// <summary>
        /// True if article is confidential
        /// </summary>
        /// <value>True if article is confidential</value>
        [DataMember(Name="is_confidential", EmitDefaultValue=false)]
        public bool? IsConfidential { get; set; }

        /// <summary>
        /// Reason for confidentiality
        /// </summary>
        /// <value>Reason for confidentiality</value>
        [DataMember(Name="reason", EmitDefaultValue=false)]
        public string Reason { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ArticleConfidentiality {\n");
            sb.Append("  IsConfidential: ").Append(IsConfidential).Append("\n");
            sb.Append("  Reason: ").Append(Reason).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ArticleConfidentiality);
        }

        /// <summary>
        /// Returns true if ArticleConfidentiality instances are equal
        /// </summary>
        /// <param name="input">Instance of ArticleConfidentiality to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ArticleConfidentiality input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.IsConfidential == input.IsConfidential ||
                    (this.IsConfidential != null &&
                    this.IsConfidential.Equals(input.IsConfidential))
                ) && 
                (
                    this.Reason == input.Reason ||
                    (this.Reason != null &&
                    this.Reason.Equals(input.Reason))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.IsConfidential != null)
                    hashCode = hashCode * 59 + this.IsConfidential.GetHashCode();
                if (this.Reason != null)
                    hashCode = hashCode * 59 + this.Reason.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
