/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ArticleEmbargo
    /// </summary>
    [DataContract]
    public partial class ArticleEmbargo :  IEquatable<ArticleEmbargo>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ArticleEmbargo" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ArticleEmbargo() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ArticleEmbargo" /> class.
        /// </summary>
        /// <param name="isEmbargoed">True if embargoed (required).</param>
        /// <param name="embargoTitle">Title for embargo (required).</param>
        /// <param name="embargoReason">Reason for embargo (required).</param>
        /// <param name="embargoOptions">List of embargo permissions that are associated with the article. If the type is logged_in and the group_ids list is empty, then the whole institution can see the article; if there are multiple group_ids, then only users that are under those groups can see the article. (required).</param>
        public ArticleEmbargo(bool? isEmbargoed = default(bool?), string embargoTitle = default(string), string embargoReason = default(string), List<Object> embargoOptions = default(List<Object>))
        {
            // to ensure "isEmbargoed" is required (not null)
            if (isEmbargoed == null)
            {
                throw new InvalidDataException("isEmbargoed is a required property for ArticleEmbargo and cannot be null");
            }
            else
            {
                this.IsEmbargoed = isEmbargoed;
            }
            // to ensure "embargoTitle" is required (not null)
            if (embargoTitle == null)
            {
                throw new InvalidDataException("embargoTitle is a required property for ArticleEmbargo and cannot be null");
            }
            else
            {
                this.EmbargoTitle = embargoTitle;
            }
            // to ensure "embargoReason" is required (not null)
            if (embargoReason == null)
            {
                throw new InvalidDataException("embargoReason is a required property for ArticleEmbargo and cannot be null");
            }
            else
            {
                this.EmbargoReason = embargoReason;
            }
            // to ensure "embargoOptions" is required (not null)
            if (embargoOptions == null)
            {
                throw new InvalidDataException("embargoOptions is a required property for ArticleEmbargo and cannot be null");
            }
            else
            {
                this.EmbargoOptions = embargoOptions;
            }
        }
        
        /// <summary>
        /// True if embargoed
        /// </summary>
        /// <value>True if embargoed</value>
        [DataMember(Name="is_embargoed", EmitDefaultValue=false)]
        public bool? IsEmbargoed { get; set; }

        /// <summary>
        /// Title for embargo
        /// </summary>
        /// <value>Title for embargo</value>
        [DataMember(Name="embargo_title", EmitDefaultValue=false)]
        public string EmbargoTitle { get; set; }

        /// <summary>
        /// Reason for embargo
        /// </summary>
        /// <value>Reason for embargo</value>
        [DataMember(Name="embargo_reason", EmitDefaultValue=false)]
        public string EmbargoReason { get; set; }

        /// <summary>
        /// List of embargo permissions that are associated with the article. If the type is logged_in and the group_ids list is empty, then the whole institution can see the article; if there are multiple group_ids, then only users that are under those groups can see the article.
        /// </summary>
        /// <value>List of embargo permissions that are associated with the article. If the type is logged_in and the group_ids list is empty, then the whole institution can see the article; if there are multiple group_ids, then only users that are under those groups can see the article.</value>
        [DataMember(Name="embargo_options", EmitDefaultValue=false)]
        public List<Object> EmbargoOptions { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ArticleEmbargo {\n");
            sb.Append("  IsEmbargoed: ").Append(IsEmbargoed).Append("\n");
            sb.Append("  EmbargoTitle: ").Append(EmbargoTitle).Append("\n");
            sb.Append("  EmbargoReason: ").Append(EmbargoReason).Append("\n");
            sb.Append("  EmbargoOptions: ").Append(EmbargoOptions).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ArticleEmbargo);
        }

        /// <summary>
        /// Returns true if ArticleEmbargo instances are equal
        /// </summary>
        /// <param name="input">Instance of ArticleEmbargo to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ArticleEmbargo input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.IsEmbargoed == input.IsEmbargoed ||
                    (this.IsEmbargoed != null &&
                    this.IsEmbargoed.Equals(input.IsEmbargoed))
                ) && 
                (
                    this.EmbargoTitle == input.EmbargoTitle ||
                    (this.EmbargoTitle != null &&
                    this.EmbargoTitle.Equals(input.EmbargoTitle))
                ) && 
                (
                    this.EmbargoReason == input.EmbargoReason ||
                    (this.EmbargoReason != null &&
                    this.EmbargoReason.Equals(input.EmbargoReason))
                ) && 
                (
                    this.EmbargoOptions == input.EmbargoOptions ||
                    this.EmbargoOptions != null &&
                    this.EmbargoOptions.SequenceEqual(input.EmbargoOptions)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.IsEmbargoed != null)
                    hashCode = hashCode * 59 + this.IsEmbargoed.GetHashCode();
                if (this.EmbargoTitle != null)
                    hashCode = hashCode * 59 + this.EmbargoTitle.GetHashCode();
                if (this.EmbargoReason != null)
                    hashCode = hashCode * 59 + this.EmbargoReason.GetHashCode();
                if (this.EmbargoOptions != null)
                    hashCode = hashCode * 59 + this.EmbargoOptions.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
