/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ArticlesCreator
    /// </summary>
    [DataContract]
    public partial class ArticlesCreator :  IEquatable<ArticlesCreator>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ArticlesCreator" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ArticlesCreator() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ArticlesCreator" /> class.
        /// </summary>
        /// <param name="articles">List of article ids (required).</param>
        public ArticlesCreator(List<long?> articles = default(List<long?>))
        {
            // to ensure "articles" is required (not null)
            if (articles == null)
            {
                throw new InvalidDataException("articles is a required property for ArticlesCreator and cannot be null");
            }
            else
            {
                this.Articles = articles;
            }
        }
        
        /// <summary>
        /// List of article ids
        /// </summary>
        /// <value>List of article ids</value>
        [DataMember(Name="articles", EmitDefaultValue=false)]
        public List<long?> Articles { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ArticlesCreator {\n");
            sb.Append("  Articles: ").Append(Articles).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ArticlesCreator);
        }

        /// <summary>
        /// Returns true if ArticlesCreator instances are equal
        /// </summary>
        /// <param name="input">Instance of ArticlesCreator to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ArticlesCreator input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Articles == input.Articles ||
                    this.Articles != null &&
                    this.Articles.SequenceEqual(input.Articles)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Articles != null)
                    hashCode = hashCode * 59 + this.Articles.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
