/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// CollectionCompletePrivate
    /// </summary>
    [DataContract]
    public partial class CollectionCompletePrivate : Collection,  IEquatable<CollectionCompletePrivate>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CollectionCompletePrivate" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected CollectionCompletePrivate() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="CollectionCompletePrivate" /> class.
        /// </summary>
        /// <param name="id">Collection id (required).</param>
        /// <param name="title">Collection title (required).</param>
        /// <param name="doi">Collection DOI (required).</param>
        /// <param name="handle">Collection Handle (required).</param>
        /// <param name="url">Api endpoint (required).</param>
        /// <param name="timeline">Various timeline dates (required).</param>
        /// <param name="accountId">ID of the account owning the collection (required).</param>
        /// <param name="funding">Full Collection funding information (required).</param>
        /// <param name="resourceId">Collection resource id (required).</param>
        /// <param name="resourceDoi">Collection resource doi (required).</param>
        /// <param name="resourceTitle">Collection resource title (required).</param>
        /// <param name="resourceLink">Collection resource link (required).</param>
        /// <param name="resourceVersion">Collection resource version (required).</param>
        /// <param name="version">Collection version (required).</param>
        /// <param name="description">Collection description (required).</param>
        /// <param name="categories">List of collection categories (required).</param>
        /// <param name="references">List of collection references (required).</param>
        /// <param name="tags">List of collection tags (required).</param>
        /// <param name="authors">List of collection authors (required).</param>
        /// <param name="institutionId">Collection institution (required).</param>
        /// <param name="groupId">Collection group (required).</param>
        /// <param name="articlesCount">Number of articles in collection (required).</param>
        /// <param name="_public">True if collection is published (required).</param>
        /// <param name="citation">Collection citation (required).</param>
        /// <param name="customFields">Collection custom fields (required).</param>
        /// <param name="modifiedDate">Date when collection was last modified (required).</param>
        /// <param name="createdDate">Date when collection was created (required).</param>
        public CollectionCompletePrivate(long? id = default(long?), string title = default(string), string doi = default(string), string handle = default(string), string url = default(string), Timeline timeline = default(Timeline), long? accountId = default(long?), List<FundingInformation> funding = default(List<FundingInformation>), string resourceId = default(string), string resourceDoi = default(string), string resourceTitle = default(string), string resourceLink = default(string), long? resourceVersion = default(long?), long? version = default(long?), string description = default(string), List<Category> categories = default(List<Category>), List<string> references = default(List<string>), List<string> tags = default(List<string>), List<Author> authors = default(List<Author>), long? institutionId = default(long?), long? groupId = default(long?), long? articlesCount = default(long?), bool? _public = default(bool?), string citation = default(string), List<CustomArticleField> customFields = default(List<CustomArticleField>), string modifiedDate = default(string), string createdDate = default(string)) : base()
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "title" is required (not null)
            if (title == null)
            {
                throw new InvalidDataException("title is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Title = title;
            }
            // to ensure "doi" is required (not null)
            if (doi == null)
            {
                throw new InvalidDataException("doi is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Doi = doi;
            }
            // to ensure "handle" is required (not null)
            if (handle == null)
            {
                throw new InvalidDataException("handle is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Handle = handle;
            }
            // to ensure "url" is required (not null)
            if (url == null)
            {
                throw new InvalidDataException("url is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Url = url;
            }
            // to ensure "timeline" is required (not null)
            if (timeline == null)
            {
                throw new InvalidDataException("timeline is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Timeline = timeline;
            }
            // to ensure "accountId" is required (not null)
            if (accountId == null)
            {
                throw new InvalidDataException("accountId is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.AccountId = accountId;
            }
            // to ensure "funding" is required (not null)
            if (funding == null)
            {
                throw new InvalidDataException("funding is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Funding = funding;
            }
            // to ensure "resourceId" is required (not null)
            if (resourceId == null)
            {
                throw new InvalidDataException("resourceId is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.ResourceId = resourceId;
            }
            // to ensure "resourceDoi" is required (not null)
            if (resourceDoi == null)
            {
                throw new InvalidDataException("resourceDoi is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.ResourceDoi = resourceDoi;
            }
            // to ensure "resourceTitle" is required (not null)
            if (resourceTitle == null)
            {
                throw new InvalidDataException("resourceTitle is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.ResourceTitle = resourceTitle;
            }
            // to ensure "resourceLink" is required (not null)
            if (resourceLink == null)
            {
                throw new InvalidDataException("resourceLink is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.ResourceLink = resourceLink;
            }
            // to ensure "resourceVersion" is required (not null)
            if (resourceVersion == null)
            {
                throw new InvalidDataException("resourceVersion is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.ResourceVersion = resourceVersion;
            }
            // to ensure "version" is required (not null)
            if (version == null)
            {
                throw new InvalidDataException("version is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Version = version;
            }
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new InvalidDataException("description is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Description = description;
            }
            // to ensure "categories" is required (not null)
            if (categories == null)
            {
                throw new InvalidDataException("categories is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Categories = categories;
            }
            // to ensure "references" is required (not null)
            if (references == null)
            {
                throw new InvalidDataException("references is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.References = references;
            }
            // to ensure "tags" is required (not null)
            if (tags == null)
            {
                throw new InvalidDataException("tags is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Tags = tags;
            }
            // to ensure "authors" is required (not null)
            if (authors == null)
            {
                throw new InvalidDataException("authors is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Authors = authors;
            }
            // to ensure "institutionId" is required (not null)
            if (institutionId == null)
            {
                throw new InvalidDataException("institutionId is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.InstitutionId = institutionId;
            }
            // to ensure "groupId" is required (not null)
            if (groupId == null)
            {
                throw new InvalidDataException("groupId is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.GroupId = groupId;
            }
            // to ensure "articlesCount" is required (not null)
            if (articlesCount == null)
            {
                throw new InvalidDataException("articlesCount is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.ArticlesCount = articlesCount;
            }
            // to ensure "_public" is required (not null)
            if (_public == null)
            {
                throw new InvalidDataException("_public is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Public = _public;
            }
            // to ensure "citation" is required (not null)
            if (citation == null)
            {
                throw new InvalidDataException("citation is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.Citation = citation;
            }
            // to ensure "customFields" is required (not null)
            if (customFields == null)
            {
                throw new InvalidDataException("customFields is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.CustomFields = customFields;
            }
            // to ensure "modifiedDate" is required (not null)
            if (modifiedDate == null)
            {
                throw new InvalidDataException("modifiedDate is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.ModifiedDate = modifiedDate;
            }
            // to ensure "createdDate" is required (not null)
            if (createdDate == null)
            {
                throw new InvalidDataException("createdDate is a required property for CollectionCompletePrivate and cannot be null");
            }
            else
            {
                this.CreatedDate = createdDate;
            }
        }
        
        /// <summary>
        /// Collection id
        /// </summary>
        /// <value>Collection id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// Collection title
        /// </summary>
        /// <value>Collection title</value>
        [DataMember(Name="title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// Collection DOI
        /// </summary>
        /// <value>Collection DOI</value>
        [DataMember(Name="doi", EmitDefaultValue=false)]
        public string Doi { get; set; }

        /// <summary>
        /// Collection Handle
        /// </summary>
        /// <value>Collection Handle</value>
        [DataMember(Name="handle", EmitDefaultValue=false)]
        public string Handle { get; set; }

        /// <summary>
        /// Api endpoint
        /// </summary>
        /// <value>Api endpoint</value>
        [DataMember(Name="url", EmitDefaultValue=false)]
        public string Url { get; set; }

        /// <summary>
        /// Various timeline dates
        /// </summary>
        /// <value>Various timeline dates</value>
        [DataMember(Name="timeline", EmitDefaultValue=false)]
        public Timeline Timeline { get; set; }

        /// <summary>
        /// ID of the account owning the collection
        /// </summary>
        /// <value>ID of the account owning the collection</value>
        [DataMember(Name="account_id", EmitDefaultValue=false)]
        public long? AccountId { get; set; }

        /// <summary>
        /// Full Collection funding information
        /// </summary>
        /// <value>Full Collection funding information</value>
        [DataMember(Name="funding", EmitDefaultValue=false)]
        public List<FundingInformation> Funding { get; set; }

        /// <summary>
        /// Collection resource id
        /// </summary>
        /// <value>Collection resource id</value>
        [DataMember(Name="resource_id", EmitDefaultValue=false)]
        public string ResourceId { get; set; }

        /// <summary>
        /// Collection resource doi
        /// </summary>
        /// <value>Collection resource doi</value>
        [DataMember(Name="resource_doi", EmitDefaultValue=false)]
        public string ResourceDoi { get; set; }

        /// <summary>
        /// Collection resource title
        /// </summary>
        /// <value>Collection resource title</value>
        [DataMember(Name="resource_title", EmitDefaultValue=false)]
        public string ResourceTitle { get; set; }

        /// <summary>
        /// Collection resource link
        /// </summary>
        /// <value>Collection resource link</value>
        [DataMember(Name="resource_link", EmitDefaultValue=false)]
        public string ResourceLink { get; set; }

        /// <summary>
        /// Collection resource version
        /// </summary>
        /// <value>Collection resource version</value>
        [DataMember(Name="resource_version", EmitDefaultValue=false)]
        public long? ResourceVersion { get; set; }

        /// <summary>
        /// Collection version
        /// </summary>
        /// <value>Collection version</value>
        [DataMember(Name="version", EmitDefaultValue=false)]
        public long? Version { get; set; }

        /// <summary>
        /// Collection description
        /// </summary>
        /// <value>Collection description</value>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// List of collection categories
        /// </summary>
        /// <value>List of collection categories</value>
        [DataMember(Name="categories", EmitDefaultValue=false)]
        public List<Category> Categories { get; set; }

        /// <summary>
        /// List of collection references
        /// </summary>
        /// <value>List of collection references</value>
        [DataMember(Name="references", EmitDefaultValue=false)]
        public List<string> References { get; set; }

        /// <summary>
        /// List of collection tags
        /// </summary>
        /// <value>List of collection tags</value>
        [DataMember(Name="tags", EmitDefaultValue=false)]
        public List<string> Tags { get; set; }

        /// <summary>
        /// List of collection authors
        /// </summary>
        /// <value>List of collection authors</value>
        [DataMember(Name="authors", EmitDefaultValue=false)]
        public List<Author> Authors { get; set; }

        /// <summary>
        /// Collection institution
        /// </summary>
        /// <value>Collection institution</value>
        [DataMember(Name="institution_id", EmitDefaultValue=false)]
        public long? InstitutionId { get; set; }

        /// <summary>
        /// Collection group
        /// </summary>
        /// <value>Collection group</value>
        [DataMember(Name="group_id", EmitDefaultValue=false)]
        public long? GroupId { get; set; }

        /// <summary>
        /// Number of articles in collection
        /// </summary>
        /// <value>Number of articles in collection</value>
        [DataMember(Name="articles_count", EmitDefaultValue=false)]
        public long? ArticlesCount { get; set; }

        /// <summary>
        /// True if collection is published
        /// </summary>
        /// <value>True if collection is published</value>
        [DataMember(Name="public", EmitDefaultValue=false)]
        public bool? Public { get; set; }

        /// <summary>
        /// Collection citation
        /// </summary>
        /// <value>Collection citation</value>
        [DataMember(Name="citation", EmitDefaultValue=false)]
        public string Citation { get; set; }

        /// <summary>
        /// Collection custom fields
        /// </summary>
        /// <value>Collection custom fields</value>
        [DataMember(Name="custom_fields", EmitDefaultValue=false)]
        public List<CustomArticleField> CustomFields { get; set; }

        /// <summary>
        /// Date when collection was last modified
        /// </summary>
        /// <value>Date when collection was last modified</value>
        [DataMember(Name="modified_date", EmitDefaultValue=false)]
        public string ModifiedDate { get; set; }

        /// <summary>
        /// Date when collection was created
        /// </summary>
        /// <value>Date when collection was created</value>
        [DataMember(Name="created_date", EmitDefaultValue=false)]
        public string CreatedDate { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CollectionCompletePrivate {\n");
            sb.Append("  ").Append(base.ToString().Replace("\n", "\n  ")).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Doi: ").Append(Doi).Append("\n");
            sb.Append("  Handle: ").Append(Handle).Append("\n");
            sb.Append("  Url: ").Append(Url).Append("\n");
            sb.Append("  Timeline: ").Append(Timeline).Append("\n");
            sb.Append("  AccountId: ").Append(AccountId).Append("\n");
            sb.Append("  Funding: ").Append(Funding).Append("\n");
            sb.Append("  ResourceId: ").Append(ResourceId).Append("\n");
            sb.Append("  ResourceDoi: ").Append(ResourceDoi).Append("\n");
            sb.Append("  ResourceTitle: ").Append(ResourceTitle).Append("\n");
            sb.Append("  ResourceLink: ").Append(ResourceLink).Append("\n");
            sb.Append("  ResourceVersion: ").Append(ResourceVersion).Append("\n");
            sb.Append("  Version: ").Append(Version).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Categories: ").Append(Categories).Append("\n");
            sb.Append("  References: ").Append(References).Append("\n");
            sb.Append("  Tags: ").Append(Tags).Append("\n");
            sb.Append("  Authors: ").Append(Authors).Append("\n");
            sb.Append("  InstitutionId: ").Append(InstitutionId).Append("\n");
            sb.Append("  GroupId: ").Append(GroupId).Append("\n");
            sb.Append("  ArticlesCount: ").Append(ArticlesCount).Append("\n");
            sb.Append("  Public: ").Append(Public).Append("\n");
            sb.Append("  Citation: ").Append(Citation).Append("\n");
            sb.Append("  CustomFields: ").Append(CustomFields).Append("\n");
            sb.Append("  ModifiedDate: ").Append(ModifiedDate).Append("\n");
            sb.Append("  CreatedDate: ").Append(CreatedDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public override string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CollectionCompletePrivate);
        }

        /// <summary>
        /// Returns true if CollectionCompletePrivate instances are equal
        /// </summary>
        /// <param name="input">Instance of CollectionCompletePrivate to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CollectionCompletePrivate input)
        {
            if (input == null)
                return false;

            return base.Equals(input) && 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && base.Equals(input) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && base.Equals(input) && 
                (
                    this.Doi == input.Doi ||
                    (this.Doi != null &&
                    this.Doi.Equals(input.Doi))
                ) && base.Equals(input) && 
                (
                    this.Handle == input.Handle ||
                    (this.Handle != null &&
                    this.Handle.Equals(input.Handle))
                ) && base.Equals(input) && 
                (
                    this.Url == input.Url ||
                    (this.Url != null &&
                    this.Url.Equals(input.Url))
                ) && base.Equals(input) && 
                (
                    this.Timeline == input.Timeline ||
                    (this.Timeline != null &&
                    this.Timeline.Equals(input.Timeline))
                ) && base.Equals(input) && 
                (
                    this.AccountId == input.AccountId ||
                    (this.AccountId != null &&
                    this.AccountId.Equals(input.AccountId))
                ) && base.Equals(input) && 
                (
                    this.Funding == input.Funding ||
                    this.Funding != null &&
                    this.Funding.SequenceEqual(input.Funding)
                ) && base.Equals(input) && 
                (
                    this.ResourceId == input.ResourceId ||
                    (this.ResourceId != null &&
                    this.ResourceId.Equals(input.ResourceId))
                ) && base.Equals(input) && 
                (
                    this.ResourceDoi == input.ResourceDoi ||
                    (this.ResourceDoi != null &&
                    this.ResourceDoi.Equals(input.ResourceDoi))
                ) && base.Equals(input) && 
                (
                    this.ResourceTitle == input.ResourceTitle ||
                    (this.ResourceTitle != null &&
                    this.ResourceTitle.Equals(input.ResourceTitle))
                ) && base.Equals(input) && 
                (
                    this.ResourceLink == input.ResourceLink ||
                    (this.ResourceLink != null &&
                    this.ResourceLink.Equals(input.ResourceLink))
                ) && base.Equals(input) && 
                (
                    this.ResourceVersion == input.ResourceVersion ||
                    (this.ResourceVersion != null &&
                    this.ResourceVersion.Equals(input.ResourceVersion))
                ) && base.Equals(input) && 
                (
                    this.Version == input.Version ||
                    (this.Version != null &&
                    this.Version.Equals(input.Version))
                ) && base.Equals(input) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && base.Equals(input) && 
                (
                    this.Categories == input.Categories ||
                    this.Categories != null &&
                    this.Categories.SequenceEqual(input.Categories)
                ) && base.Equals(input) && 
                (
                    this.References == input.References ||
                    this.References != null &&
                    this.References.SequenceEqual(input.References)
                ) && base.Equals(input) && 
                (
                    this.Tags == input.Tags ||
                    this.Tags != null &&
                    this.Tags.SequenceEqual(input.Tags)
                ) && base.Equals(input) && 
                (
                    this.Authors == input.Authors ||
                    this.Authors != null &&
                    this.Authors.SequenceEqual(input.Authors)
                ) && base.Equals(input) && 
                (
                    this.InstitutionId == input.InstitutionId ||
                    (this.InstitutionId != null &&
                    this.InstitutionId.Equals(input.InstitutionId))
                ) && base.Equals(input) && 
                (
                    this.GroupId == input.GroupId ||
                    (this.GroupId != null &&
                    this.GroupId.Equals(input.GroupId))
                ) && base.Equals(input) && 
                (
                    this.ArticlesCount == input.ArticlesCount ||
                    (this.ArticlesCount != null &&
                    this.ArticlesCount.Equals(input.ArticlesCount))
                ) && base.Equals(input) && 
                (
                    this.Public == input.Public ||
                    (this.Public != null &&
                    this.Public.Equals(input.Public))
                ) && base.Equals(input) && 
                (
                    this.Citation == input.Citation ||
                    (this.Citation != null &&
                    this.Citation.Equals(input.Citation))
                ) && base.Equals(input) && 
                (
                    this.CustomFields == input.CustomFields ||
                    this.CustomFields != null &&
                    this.CustomFields.SequenceEqual(input.CustomFields)
                ) && base.Equals(input) && 
                (
                    this.ModifiedDate == input.ModifiedDate ||
                    (this.ModifiedDate != null &&
                    this.ModifiedDate.Equals(input.ModifiedDate))
                ) && base.Equals(input) && 
                (
                    this.CreatedDate == input.CreatedDate ||
                    (this.CreatedDate != null &&
                    this.CreatedDate.Equals(input.CreatedDate))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = base.GetHashCode();
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Doi != null)
                    hashCode = hashCode * 59 + this.Doi.GetHashCode();
                if (this.Handle != null)
                    hashCode = hashCode * 59 + this.Handle.GetHashCode();
                if (this.Url != null)
                    hashCode = hashCode * 59 + this.Url.GetHashCode();
                if (this.Timeline != null)
                    hashCode = hashCode * 59 + this.Timeline.GetHashCode();
                if (this.AccountId != null)
                    hashCode = hashCode * 59 + this.AccountId.GetHashCode();
                if (this.Funding != null)
                    hashCode = hashCode * 59 + this.Funding.GetHashCode();
                if (this.ResourceId != null)
                    hashCode = hashCode * 59 + this.ResourceId.GetHashCode();
                if (this.ResourceDoi != null)
                    hashCode = hashCode * 59 + this.ResourceDoi.GetHashCode();
                if (this.ResourceTitle != null)
                    hashCode = hashCode * 59 + this.ResourceTitle.GetHashCode();
                if (this.ResourceLink != null)
                    hashCode = hashCode * 59 + this.ResourceLink.GetHashCode();
                if (this.ResourceVersion != null)
                    hashCode = hashCode * 59 + this.ResourceVersion.GetHashCode();
                if (this.Version != null)
                    hashCode = hashCode * 59 + this.Version.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.Categories != null)
                    hashCode = hashCode * 59 + this.Categories.GetHashCode();
                if (this.References != null)
                    hashCode = hashCode * 59 + this.References.GetHashCode();
                if (this.Tags != null)
                    hashCode = hashCode * 59 + this.Tags.GetHashCode();
                if (this.Authors != null)
                    hashCode = hashCode * 59 + this.Authors.GetHashCode();
                if (this.InstitutionId != null)
                    hashCode = hashCode * 59 + this.InstitutionId.GetHashCode();
                if (this.GroupId != null)
                    hashCode = hashCode * 59 + this.GroupId.GetHashCode();
                if (this.ArticlesCount != null)
                    hashCode = hashCode * 59 + this.ArticlesCount.GetHashCode();
                if (this.Public != null)
                    hashCode = hashCode * 59 + this.Public.GetHashCode();
                if (this.Citation != null)
                    hashCode = hashCode * 59 + this.Citation.GetHashCode();
                if (this.CustomFields != null)
                    hashCode = hashCode * 59 + this.CustomFields.GetHashCode();
                if (this.ModifiedDate != null)
                    hashCode = hashCode * 59 + this.ModifiedDate.GetHashCode();
                if (this.CreatedDate != null)
                    hashCode = hashCode * 59 + this.CreatedDate.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            foreach(var x in BaseValidate(validationContext)) yield return x;
            yield break;
        }
    }

}
