/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// CommonSearch
    /// </summary>
    [DataContract]
    public partial class CommonSearch :  IEquatable<CommonSearch>, IValidatableObject
    {
        /// <summary>
        /// Direction of ordering
        /// </summary>
        /// <value>Direction of ordering</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum OrderDirectionEnum
        {
            
            /// <summary>
            /// Enum Asc for value: asc
            /// </summary>
            [EnumMember(Value = "asc")]
            Asc = 1,
            
            /// <summary>
            /// Enum Desc for value: desc
            /// </summary>
            [EnumMember(Value = "desc")]
            Desc = 2
        }

        /// <summary>
        /// Direction of ordering
        /// </summary>
        /// <value>Direction of ordering</value>
        [DataMember(Name="order_direction", EmitDefaultValue=false)]
        public OrderDirectionEnum? OrderDirection { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="CommonSearch" /> class.
        /// </summary>
        /// <param name="searchFor">Search term.</param>
        /// <param name="page">Page number. Used for pagination with page_size.</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (default to 10).</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query.</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit.</param>
        /// <param name="orderDirection">Direction of ordering (default to OrderDirectionEnum.Desc).</param>
        /// <param name="institution">only return collections from this institution.</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD.</param>
        /// <param name="modifiedSince">Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD.</param>
        /// <param name="group">only return collections from this group.</param>
        public CommonSearch(string searchFor = default(string), long? page = default(long?), long? pageSize = 10, long? limit = default(long?), long? offset = default(long?), OrderDirectionEnum? orderDirection = OrderDirectionEnum.Desc, int? institution = default(int?), string publishedSince = default(string), string modifiedSince = default(string), int? group = default(int?))
        {
            this.SearchFor = searchFor;
            this.Page = page;
            // use default value if no "pageSize" provided
            if (pageSize == null)
            {
                this.PageSize = 10;
            }
            else
            {
                this.PageSize = pageSize;
            }
            this.Limit = limit;
            this.Offset = offset;
            // use default value if no "orderDirection" provided
            if (orderDirection == null)
            {
                this.OrderDirection = OrderDirectionEnum.Desc;
            }
            else
            {
                this.OrderDirection = orderDirection;
            }
            this.Institution = institution;
            this.PublishedSince = publishedSince;
            this.ModifiedSince = modifiedSince;
            this.Group = group;
        }
        
        /// <summary>
        /// Search term
        /// </summary>
        /// <value>Search term</value>
        [DataMember(Name="search_for", EmitDefaultValue=false)]
        public string SearchFor { get; set; }

        /// <summary>
        /// Page number. Used for pagination with page_size
        /// </summary>
        /// <value>Page number. Used for pagination with page_size</value>
        [DataMember(Name="page", EmitDefaultValue=false)]
        public long? Page { get; set; }

        /// <summary>
        /// The number of results included on a page. Used for pagination with page
        /// </summary>
        /// <value>The number of results included on a page. Used for pagination with page</value>
        [DataMember(Name="page_size", EmitDefaultValue=false)]
        public long? PageSize { get; set; }

        /// <summary>
        /// Number of results included on a page. Used for pagination with query
        /// </summary>
        /// <value>Number of results included on a page. Used for pagination with query</value>
        [DataMember(Name="limit", EmitDefaultValue=false)]
        public long? Limit { get; set; }

        /// <summary>
        /// Where to start the listing(the offset of the first result). Used for pagination with limit
        /// </summary>
        /// <value>Where to start the listing(the offset of the first result). Used for pagination with limit</value>
        [DataMember(Name="offset", EmitDefaultValue=false)]
        public long? Offset { get; set; }


        /// <summary>
        /// only return collections from this institution
        /// </summary>
        /// <value>only return collections from this institution</value>
        [DataMember(Name="institution", EmitDefaultValue=false)]
        public int? Institution { get; set; }

        /// <summary>
        /// Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
        /// </summary>
        /// <value>Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD</value>
        [DataMember(Name="published_since", EmitDefaultValue=false)]
        public string PublishedSince { get; set; }

        /// <summary>
        /// Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
        /// </summary>
        /// <value>Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD</value>
        [DataMember(Name="modified_since", EmitDefaultValue=false)]
        public string ModifiedSince { get; set; }

        /// <summary>
        /// only return collections from this group
        /// </summary>
        /// <value>only return collections from this group</value>
        [DataMember(Name="group", EmitDefaultValue=false)]
        public int? Group { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CommonSearch {\n");
            sb.Append("  SearchFor: ").Append(SearchFor).Append("\n");
            sb.Append("  Page: ").Append(Page).Append("\n");
            sb.Append("  PageSize: ").Append(PageSize).Append("\n");
            sb.Append("  Limit: ").Append(Limit).Append("\n");
            sb.Append("  Offset: ").Append(Offset).Append("\n");
            sb.Append("  OrderDirection: ").Append(OrderDirection).Append("\n");
            sb.Append("  Institution: ").Append(Institution).Append("\n");
            sb.Append("  PublishedSince: ").Append(PublishedSince).Append("\n");
            sb.Append("  ModifiedSince: ").Append(ModifiedSince).Append("\n");
            sb.Append("  Group: ").Append(Group).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as CommonSearch);
        }

        /// <summary>
        /// Returns true if CommonSearch instances are equal
        /// </summary>
        /// <param name="input">Instance of CommonSearch to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CommonSearch input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.SearchFor == input.SearchFor ||
                    (this.SearchFor != null &&
                    this.SearchFor.Equals(input.SearchFor))
                ) && 
                (
                    this.Page == input.Page ||
                    (this.Page != null &&
                    this.Page.Equals(input.Page))
                ) && 
                (
                    this.PageSize == input.PageSize ||
                    (this.PageSize != null &&
                    this.PageSize.Equals(input.PageSize))
                ) && 
                (
                    this.Limit == input.Limit ||
                    (this.Limit != null &&
                    this.Limit.Equals(input.Limit))
                ) && 
                (
                    this.Offset == input.Offset ||
                    (this.Offset != null &&
                    this.Offset.Equals(input.Offset))
                ) && 
                (
                    this.OrderDirection == input.OrderDirection ||
                    (this.OrderDirection != null &&
                    this.OrderDirection.Equals(input.OrderDirection))
                ) && 
                (
                    this.Institution == input.Institution ||
                    (this.Institution != null &&
                    this.Institution.Equals(input.Institution))
                ) && 
                (
                    this.PublishedSince == input.PublishedSince ||
                    (this.PublishedSince != null &&
                    this.PublishedSince.Equals(input.PublishedSince))
                ) && 
                (
                    this.ModifiedSince == input.ModifiedSince ||
                    (this.ModifiedSince != null &&
                    this.ModifiedSince.Equals(input.ModifiedSince))
                ) && 
                (
                    this.Group == input.Group ||
                    (this.Group != null &&
                    this.Group.Equals(input.Group))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.SearchFor != null)
                    hashCode = hashCode * 59 + this.SearchFor.GetHashCode();
                if (this.Page != null)
                    hashCode = hashCode * 59 + this.Page.GetHashCode();
                if (this.PageSize != null)
                    hashCode = hashCode * 59 + this.PageSize.GetHashCode();
                if (this.Limit != null)
                    hashCode = hashCode * 59 + this.Limit.GetHashCode();
                if (this.Offset != null)
                    hashCode = hashCode * 59 + this.Offset.GetHashCode();
                if (this.OrderDirection != null)
                    hashCode = hashCode * 59 + this.OrderDirection.GetHashCode();
                if (this.Institution != null)
                    hashCode = hashCode * 59 + this.Institution.GetHashCode();
                if (this.PublishedSince != null)
                    hashCode = hashCode * 59 + this.PublishedSince.GetHashCode();
                if (this.ModifiedSince != null)
                    hashCode = hashCode * 59 + this.ModifiedSince.GetHashCode();
                if (this.Group != null)
                    hashCode = hashCode * 59 + this.Group.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Page (long?) maximum
            if(this.Page > (long?)5000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Page, must be a value less than or equal to 5000.", new [] { "Page" });
            }

            // Page (long?) minimum
            if(this.Page < (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Page, must be a value greater than or equal to 1.", new [] { "Page" });
            }

            // PageSize (long?) maximum
            if(this.PageSize > (long?)1000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PageSize, must be a value less than or equal to 1000.", new [] { "PageSize" });
            }

            // PageSize (long?) minimum
            if(this.PageSize < (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PageSize, must be a value greater than or equal to 1.", new [] { "PageSize" });
            }

            // Limit (long?) maximum
            if(this.Limit > (long?)1000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Limit, must be a value less than or equal to 1000.", new [] { "Limit" });
            }

            // Limit (long?) minimum
            if(this.Limit < (long?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Limit, must be a value greater than or equal to 1.", new [] { "Limit" });
            }

            // Offset (long?) maximum
            if(this.Offset > (long?)5000)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Offset, must be a value less than or equal to 5000.", new [] { "Offset" });
            }

            // Offset (long?) minimum
            if(this.Offset < (long?)0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Offset, must be a value greater than or equal to 0.", new [] { "Offset" });
            }

            yield break;
        }
    }

}
