/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// FundingInformation
    /// </summary>
    [DataContract]
    public partial class FundingInformation :  IEquatable<FundingInformation>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FundingInformation" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected FundingInformation() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="FundingInformation" /> class.
        /// </summary>
        /// <param name="id">Funding id (required).</param>
        /// <param name="title">The funding name (required).</param>
        /// <param name="grantCode">The grant code (required).</param>
        /// <param name="funderName">Funder&#39;s name (required).</param>
        /// <param name="isUserDefined">Return 1 whether the grant has been introduced manually, 0 otherwise (required).</param>
        /// <param name="url">The grant url (required).</param>
        public FundingInformation(long? id = default(long?), string title = default(string), string grantCode = default(string), string funderName = default(string), long? isUserDefined = default(long?), string url = default(string))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for FundingInformation and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "title" is required (not null)
            if (title == null)
            {
                throw new InvalidDataException("title is a required property for FundingInformation and cannot be null");
            }
            else
            {
                this.Title = title;
            }
            // to ensure "grantCode" is required (not null)
            if (grantCode == null)
            {
                throw new InvalidDataException("grantCode is a required property for FundingInformation and cannot be null");
            }
            else
            {
                this.GrantCode = grantCode;
            }
            // to ensure "funderName" is required (not null)
            if (funderName == null)
            {
                throw new InvalidDataException("funderName is a required property for FundingInformation and cannot be null");
            }
            else
            {
                this.FunderName = funderName;
            }
            // to ensure "isUserDefined" is required (not null)
            if (isUserDefined == null)
            {
                throw new InvalidDataException("isUserDefined is a required property for FundingInformation and cannot be null");
            }
            else
            {
                this.IsUserDefined = isUserDefined;
            }
            // to ensure "url" is required (not null)
            if (url == null)
            {
                throw new InvalidDataException("url is a required property for FundingInformation and cannot be null");
            }
            else
            {
                this.Url = url;
            }
        }
        
        /// <summary>
        /// Funding id
        /// </summary>
        /// <value>Funding id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// The funding name
        /// </summary>
        /// <value>The funding name</value>
        [DataMember(Name="title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// The grant code
        /// </summary>
        /// <value>The grant code</value>
        [DataMember(Name="grant_code", EmitDefaultValue=false)]
        public string GrantCode { get; set; }

        /// <summary>
        /// Funder&#39;s name
        /// </summary>
        /// <value>Funder&#39;s name</value>
        [DataMember(Name="funder_name", EmitDefaultValue=false)]
        public string FunderName { get; set; }

        /// <summary>
        /// Return 1 whether the grant has been introduced manually, 0 otherwise
        /// </summary>
        /// <value>Return 1 whether the grant has been introduced manually, 0 otherwise</value>
        [DataMember(Name="is_user_defined", EmitDefaultValue=false)]
        public long? IsUserDefined { get; set; }

        /// <summary>
        /// The grant url
        /// </summary>
        /// <value>The grant url</value>
        [DataMember(Name="url", EmitDefaultValue=false)]
        public string Url { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class FundingInformation {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  GrantCode: ").Append(GrantCode).Append("\n");
            sb.Append("  FunderName: ").Append(FunderName).Append("\n");
            sb.Append("  IsUserDefined: ").Append(IsUserDefined).Append("\n");
            sb.Append("  Url: ").Append(Url).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as FundingInformation);
        }

        /// <summary>
        /// Returns true if FundingInformation instances are equal
        /// </summary>
        /// <param name="input">Instance of FundingInformation to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(FundingInformation input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && 
                (
                    this.GrantCode == input.GrantCode ||
                    (this.GrantCode != null &&
                    this.GrantCode.Equals(input.GrantCode))
                ) && 
                (
                    this.FunderName == input.FunderName ||
                    (this.FunderName != null &&
                    this.FunderName.Equals(input.FunderName))
                ) && 
                (
                    this.IsUserDefined == input.IsUserDefined ||
                    (this.IsUserDefined != null &&
                    this.IsUserDefined.Equals(input.IsUserDefined))
                ) && 
                (
                    this.Url == input.Url ||
                    (this.Url != null &&
                    this.Url.Equals(input.Url))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.GrantCode != null)
                    hashCode = hashCode * 59 + this.GrantCode.GetHashCode();
                if (this.FunderName != null)
                    hashCode = hashCode * 59 + this.FunderName.GetHashCode();
                if (this.IsUserDefined != null)
                    hashCode = hashCode * 59 + this.IsUserDefined.GetHashCode();
                if (this.Url != null)
                    hashCode = hashCode * 59 + this.Url.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
