/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// GroupEmbargoOptions
    /// </summary>
    [DataContract]
    public partial class GroupEmbargoOptions :  IEquatable<GroupEmbargoOptions>, IValidatableObject
    {
        /// <summary>
        /// Embargo permission type
        /// </summary>
        /// <value>Embargo permission type</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum TypeEnum
        {
            
            /// <summary>
            /// Enum Loggedin for value: logged_in
            /// </summary>
            [EnumMember(Value = "logged_in")]
            Loggedin = 1,
            
            /// <summary>
            /// Enum Iprange for value: ip_range
            /// </summary>
            [EnumMember(Value = "ip_range")]
            Iprange = 2,
            
            /// <summary>
            /// Enum Administrator for value: administrator
            /// </summary>
            [EnumMember(Value = "administrator")]
            Administrator = 3
        }

        /// <summary>
        /// Embargo permission type
        /// </summary>
        /// <value>Embargo permission type</value>
        [DataMember(Name="type", EmitDefaultValue=false)]
        public TypeEnum Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="GroupEmbargoOptions" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected GroupEmbargoOptions() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="GroupEmbargoOptions" /> class.
        /// </summary>
        /// <param name="id">Embargo option id (required).</param>
        /// <param name="type">Embargo permission type (required).</param>
        /// <param name="ipName">IP range name; value appears if type is ip_range (required).</param>
        public GroupEmbargoOptions(long? id = default(long?), TypeEnum type = default(TypeEnum), string ipName = default(string))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for GroupEmbargoOptions and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "type" is required (not null)
            if (type == null)
            {
                throw new InvalidDataException("type is a required property for GroupEmbargoOptions and cannot be null");
            }
            else
            {
                this.Type = type;
            }
            // to ensure "ipName" is required (not null)
            if (ipName == null)
            {
                throw new InvalidDataException("ipName is a required property for GroupEmbargoOptions and cannot be null");
            }
            else
            {
                this.IpName = ipName;
            }
        }
        
        /// <summary>
        /// Embargo option id
        /// </summary>
        /// <value>Embargo option id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }


        /// <summary>
        /// IP range name; value appears if type is ip_range
        /// </summary>
        /// <value>IP range name; value appears if type is ip_range</value>
        [DataMember(Name="ip_name", EmitDefaultValue=false)]
        public string IpName { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class GroupEmbargoOptions {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  IpName: ").Append(IpName).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as GroupEmbargoOptions);
        }

        /// <summary>
        /// Returns true if GroupEmbargoOptions instances are equal
        /// </summary>
        /// <param name="input">Instance of GroupEmbargoOptions to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(GroupEmbargoOptions input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.IpName == input.IpName ||
                    (this.IpName != null &&
                    this.IpName.Equals(input.IpName))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.IpName != null)
                    hashCode = hashCode * 59 + this.IpName.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
