/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// LocationWarnings
    /// </summary>
    [DataContract]
    public partial class LocationWarnings :  IEquatable<LocationWarnings>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="LocationWarnings" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected LocationWarnings() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="LocationWarnings" /> class.
        /// </summary>
        /// <param name="entityId">Figshare ID of the entity (required).</param>
        /// <param name="location">Url for entity (required).</param>
        /// <param name="warnings">Issues encountered during the operation (required).</param>
        public LocationWarnings(long? entityId = default(long?), string location = default(string), List<string> warnings = default(List<string>))
        {
            // to ensure "entityId" is required (not null)
            if (entityId == null)
            {
                throw new InvalidDataException("entityId is a required property for LocationWarnings and cannot be null");
            }
            else
            {
                this.EntityId = entityId;
            }
            // to ensure "location" is required (not null)
            if (location == null)
            {
                throw new InvalidDataException("location is a required property for LocationWarnings and cannot be null");
            }
            else
            {
                this.Location = location;
            }
            // to ensure "warnings" is required (not null)
            if (warnings == null)
            {
                throw new InvalidDataException("warnings is a required property for LocationWarnings and cannot be null");
            }
            else
            {
                this.Warnings = warnings;
            }
        }
        
        /// <summary>
        /// Figshare ID of the entity
        /// </summary>
        /// <value>Figshare ID of the entity</value>
        [DataMember(Name="entity_id", EmitDefaultValue=false)]
        public long? EntityId { get; set; }

        /// <summary>
        /// Url for entity
        /// </summary>
        /// <value>Url for entity</value>
        [DataMember(Name="location", EmitDefaultValue=false)]
        public string Location { get; set; }

        /// <summary>
        /// Issues encountered during the operation
        /// </summary>
        /// <value>Issues encountered during the operation</value>
        [DataMember(Name="warnings", EmitDefaultValue=false)]
        public List<string> Warnings { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class LocationWarnings {\n");
            sb.Append("  EntityId: ").Append(EntityId).Append("\n");
            sb.Append("  Location: ").Append(Location).Append("\n");
            sb.Append("  Warnings: ").Append(Warnings).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as LocationWarnings);
        }

        /// <summary>
        /// Returns true if LocationWarnings instances are equal
        /// </summary>
        /// <param name="input">Instance of LocationWarnings to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(LocationWarnings input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.EntityId == input.EntityId ||
                    (this.EntityId != null &&
                    this.EntityId.Equals(input.EntityId))
                ) && 
                (
                    this.Location == input.Location ||
                    (this.Location != null &&
                    this.Location.Equals(input.Location))
                ) && 
                (
                    this.Warnings == input.Warnings ||
                    this.Warnings != null &&
                    this.Warnings.SequenceEqual(input.Warnings)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.EntityId != null)
                    hashCode = hashCode * 59 + this.EntityId.GetHashCode();
                if (this.Location != null)
                    hashCode = hashCode * 59 + this.Location.GetHashCode();
                if (this.Warnings != null)
                    hashCode = hashCode * 59 + this.Warnings.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
