/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PrivateFile
    /// </summary>
    [DataContract]
    public partial class PrivateFile : PublicFile,  IEquatable<PrivateFile>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PrivateFile" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected PrivateFile() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="PrivateFile" /> class.
        /// </summary>
        /// <param name="id">File id (required).</param>
        /// <param name="name">File name (required).</param>
        /// <param name="size">File size (required).</param>
        /// <param name="isLinkOnly">True if file is hosted somewhere else (required).</param>
        /// <param name="downloadUrl">Url for file download (required).</param>
        /// <param name="suppliedMd5">File supplied md5 (required).</param>
        /// <param name="computedMd5">File computed md5 (required).</param>
        /// <param name="mimetype">MIME Type of the file, it defaults to an empty string.</param>
        /// <param name="viewerType">File viewer type (required).</param>
        /// <param name="previewState">File preview state (required).</param>
        /// <param name="uploadUrl">Upload url for file (required).</param>
        /// <param name="uploadToken">Token for file upload (required).</param>
        /// <param name="isAttachedToPublicVersion">True if the file is attached to a public item version (required).</param>
        public PrivateFile(long? id = default(long?), string name = default(string), long? size = default(long?), bool? isLinkOnly = default(bool?), string downloadUrl = default(string), string suppliedMd5 = default(string), string computedMd5 = default(string), string mimetype = default(string), string viewerType = default(string), string previewState = default(string), string uploadUrl = default(string), string uploadToken = default(string), bool? isAttachedToPublicVersion = default(bool?)) : base()
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for PrivateFile and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "name" is required (not null)
            if (name == null)
            {
                throw new InvalidDataException("name is a required property for PrivateFile and cannot be null");
            }
            else
            {
                this.Name = name;
            }
            // to ensure "size" is required (not null)
            if (size == null)
            {
                throw new InvalidDataException("size is a required property for PrivateFile and cannot be null");
            }
            else
            {
                this.Size = size;
            }
            // to ensure "isLinkOnly" is required (not null)
            if (isLinkOnly == null)
            {
                throw new InvalidDataException("isLinkOnly is a required property for PrivateFile and cannot be null");
            }
            else
            {
                this.IsLinkOnly = isLinkOnly;
            }
            // to ensure "downloadUrl" is required (not null)
            if (downloadUrl == null)
            {
                throw new InvalidDataException("downloadUrl is a required property for PrivateFile and cannot be null");
            }
            else
            {
                this.DownloadUrl = downloadUrl;
            }
            // to ensure "suppliedMd5" is required (not null)
            if (suppliedMd5 == null)
            {
                throw new InvalidDataException("suppliedMd5 is a required property for PrivateFile and cannot be null");
            }
            else
            {
                this.SuppliedMd5 = suppliedMd5;
            }
            // to ensure "computedMd5" is required (not null)
            if (computedMd5 == null)
            {
                throw new InvalidDataException("computedMd5 is a required property for PrivateFile and cannot be null");
            }
            else
            {
                this.ComputedMd5 = computedMd5;
            }
            // to ensure "viewerType" is required (not null)
            if (viewerType == null)
            {
                throw new InvalidDataException("viewerType is a required property for PrivateFile and cannot be null");
            }
            else
            {
                this.ViewerType = viewerType;
            }
            // to ensure "previewState" is required (not null)
            if (previewState == null)
            {
                throw new InvalidDataException("previewState is a required property for PrivateFile and cannot be null");
            }
            else
            {
                this.PreviewState = previewState;
            }
            // to ensure "uploadUrl" is required (not null)
            if (uploadUrl == null)
            {
                throw new InvalidDataException("uploadUrl is a required property for PrivateFile and cannot be null");
            }
            else
            {
                this.UploadUrl = uploadUrl;
            }
            // to ensure "uploadToken" is required (not null)
            if (uploadToken == null)
            {
                throw new InvalidDataException("uploadToken is a required property for PrivateFile and cannot be null");
            }
            else
            {
                this.UploadToken = uploadToken;
            }
            // to ensure "isAttachedToPublicVersion" is required (not null)
            if (isAttachedToPublicVersion == null)
            {
                throw new InvalidDataException("isAttachedToPublicVersion is a required property for PrivateFile and cannot be null");
            }
            else
            {
                this.IsAttachedToPublicVersion = isAttachedToPublicVersion;
            }
            this.Mimetype = mimetype;
        }
        
        /// <summary>
        /// File id
        /// </summary>
        /// <value>File id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// File name
        /// </summary>
        /// <value>File name</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// File size
        /// </summary>
        /// <value>File size</value>
        [DataMember(Name="size", EmitDefaultValue=false)]
        public long? Size { get; set; }

        /// <summary>
        /// True if file is hosted somewhere else
        /// </summary>
        /// <value>True if file is hosted somewhere else</value>
        [DataMember(Name="is_link_only", EmitDefaultValue=false)]
        public bool? IsLinkOnly { get; set; }

        /// <summary>
        /// Url for file download
        /// </summary>
        /// <value>Url for file download</value>
        [DataMember(Name="download_url", EmitDefaultValue=false)]
        public string DownloadUrl { get; set; }

        /// <summary>
        /// File supplied md5
        /// </summary>
        /// <value>File supplied md5</value>
        [DataMember(Name="supplied_md5", EmitDefaultValue=false)]
        public string SuppliedMd5 { get; set; }

        /// <summary>
        /// File computed md5
        /// </summary>
        /// <value>File computed md5</value>
        [DataMember(Name="computed_md5", EmitDefaultValue=false)]
        public string ComputedMd5 { get; set; }

        /// <summary>
        /// MIME Type of the file, it defaults to an empty string
        /// </summary>
        /// <value>MIME Type of the file, it defaults to an empty string</value>
        [DataMember(Name="mimetype", EmitDefaultValue=false)]
        public string Mimetype { get; set; }

        /// <summary>
        /// File viewer type
        /// </summary>
        /// <value>File viewer type</value>
        [DataMember(Name="viewer_type", EmitDefaultValue=false)]
        public string ViewerType { get; set; }

        /// <summary>
        /// File preview state
        /// </summary>
        /// <value>File preview state</value>
        [DataMember(Name="preview_state", EmitDefaultValue=false)]
        public string PreviewState { get; set; }

        /// <summary>
        /// Upload url for file
        /// </summary>
        /// <value>Upload url for file</value>
        [DataMember(Name="upload_url", EmitDefaultValue=false)]
        public string UploadUrl { get; set; }

        /// <summary>
        /// Token for file upload
        /// </summary>
        /// <value>Token for file upload</value>
        [DataMember(Name="upload_token", EmitDefaultValue=false)]
        public string UploadToken { get; set; }

        /// <summary>
        /// True if the file is attached to a public item version
        /// </summary>
        /// <value>True if the file is attached to a public item version</value>
        [DataMember(Name="is_attached_to_public_version", EmitDefaultValue=false)]
        public bool? IsAttachedToPublicVersion { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class PrivateFile {\n");
            sb.Append("  ").Append(base.ToString().Replace("\n", "\n  ")).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Size: ").Append(Size).Append("\n");
            sb.Append("  IsLinkOnly: ").Append(IsLinkOnly).Append("\n");
            sb.Append("  DownloadUrl: ").Append(DownloadUrl).Append("\n");
            sb.Append("  SuppliedMd5: ").Append(SuppliedMd5).Append("\n");
            sb.Append("  ComputedMd5: ").Append(ComputedMd5).Append("\n");
            sb.Append("  Mimetype: ").Append(Mimetype).Append("\n");
            sb.Append("  ViewerType: ").Append(ViewerType).Append("\n");
            sb.Append("  PreviewState: ").Append(PreviewState).Append("\n");
            sb.Append("  UploadUrl: ").Append(UploadUrl).Append("\n");
            sb.Append("  UploadToken: ").Append(UploadToken).Append("\n");
            sb.Append("  IsAttachedToPublicVersion: ").Append(IsAttachedToPublicVersion).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public override string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as PrivateFile);
        }

        /// <summary>
        /// Returns true if PrivateFile instances are equal
        /// </summary>
        /// <param name="input">Instance of PrivateFile to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PrivateFile input)
        {
            if (input == null)
                return false;

            return base.Equals(input) && 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && base.Equals(input) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && base.Equals(input) && 
                (
                    this.Size == input.Size ||
                    (this.Size != null &&
                    this.Size.Equals(input.Size))
                ) && base.Equals(input) && 
                (
                    this.IsLinkOnly == input.IsLinkOnly ||
                    (this.IsLinkOnly != null &&
                    this.IsLinkOnly.Equals(input.IsLinkOnly))
                ) && base.Equals(input) && 
                (
                    this.DownloadUrl == input.DownloadUrl ||
                    (this.DownloadUrl != null &&
                    this.DownloadUrl.Equals(input.DownloadUrl))
                ) && base.Equals(input) && 
                (
                    this.SuppliedMd5 == input.SuppliedMd5 ||
                    (this.SuppliedMd5 != null &&
                    this.SuppliedMd5.Equals(input.SuppliedMd5))
                ) && base.Equals(input) && 
                (
                    this.ComputedMd5 == input.ComputedMd5 ||
                    (this.ComputedMd5 != null &&
                    this.ComputedMd5.Equals(input.ComputedMd5))
                ) && base.Equals(input) && 
                (
                    this.Mimetype == input.Mimetype ||
                    (this.Mimetype != null &&
                    this.Mimetype.Equals(input.Mimetype))
                ) && base.Equals(input) && 
                (
                    this.ViewerType == input.ViewerType ||
                    (this.ViewerType != null &&
                    this.ViewerType.Equals(input.ViewerType))
                ) && base.Equals(input) && 
                (
                    this.PreviewState == input.PreviewState ||
                    (this.PreviewState != null &&
                    this.PreviewState.Equals(input.PreviewState))
                ) && base.Equals(input) && 
                (
                    this.UploadUrl == input.UploadUrl ||
                    (this.UploadUrl != null &&
                    this.UploadUrl.Equals(input.UploadUrl))
                ) && base.Equals(input) && 
                (
                    this.UploadToken == input.UploadToken ||
                    (this.UploadToken != null &&
                    this.UploadToken.Equals(input.UploadToken))
                ) && base.Equals(input) && 
                (
                    this.IsAttachedToPublicVersion == input.IsAttachedToPublicVersion ||
                    (this.IsAttachedToPublicVersion != null &&
                    this.IsAttachedToPublicVersion.Equals(input.IsAttachedToPublicVersion))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = base.GetHashCode();
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Size != null)
                    hashCode = hashCode * 59 + this.Size.GetHashCode();
                if (this.IsLinkOnly != null)
                    hashCode = hashCode * 59 + this.IsLinkOnly.GetHashCode();
                if (this.DownloadUrl != null)
                    hashCode = hashCode * 59 + this.DownloadUrl.GetHashCode();
                if (this.SuppliedMd5 != null)
                    hashCode = hashCode * 59 + this.SuppliedMd5.GetHashCode();
                if (this.ComputedMd5 != null)
                    hashCode = hashCode * 59 + this.ComputedMd5.GetHashCode();
                if (this.Mimetype != null)
                    hashCode = hashCode * 59 + this.Mimetype.GetHashCode();
                if (this.ViewerType != null)
                    hashCode = hashCode * 59 + this.ViewerType.GetHashCode();
                if (this.PreviewState != null)
                    hashCode = hashCode * 59 + this.PreviewState.GetHashCode();
                if (this.UploadUrl != null)
                    hashCode = hashCode * 59 + this.UploadUrl.GetHashCode();
                if (this.UploadToken != null)
                    hashCode = hashCode * 59 + this.UploadToken.GetHashCode();
                if (this.IsAttachedToPublicVersion != null)
                    hashCode = hashCode * 59 + this.IsAttachedToPublicVersion.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            foreach(var x in BaseValidate(validationContext)) yield return x;
            yield break;
        }
    }

}
