/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PrivateLink
    /// </summary>
    [DataContract]
    public partial class PrivateLink :  IEquatable<PrivateLink>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PrivateLink" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected PrivateLink() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="PrivateLink" /> class.
        /// </summary>
        /// <param name="id">Private link id (required).</param>
        /// <param name="isActive">True if private link is active (required).</param>
        /// <param name="expiresDate">Date when link will expire (required).</param>
        /// <param name="htmlLocation">HTML url for private link (required).</param>
        public PrivateLink(string id = default(string), bool? isActive = default(bool?), string expiresDate = default(string), string htmlLocation = default(string))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for PrivateLink and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "isActive" is required (not null)
            if (isActive == null)
            {
                throw new InvalidDataException("isActive is a required property for PrivateLink and cannot be null");
            }
            else
            {
                this.IsActive = isActive;
            }
            // to ensure "expiresDate" is required (not null)
            if (expiresDate == null)
            {
                throw new InvalidDataException("expiresDate is a required property for PrivateLink and cannot be null");
            }
            else
            {
                this.ExpiresDate = expiresDate;
            }
            // to ensure "htmlLocation" is required (not null)
            if (htmlLocation == null)
            {
                throw new InvalidDataException("htmlLocation is a required property for PrivateLink and cannot be null");
            }
            else
            {
                this.HtmlLocation = htmlLocation;
            }
        }
        
        /// <summary>
        /// Private link id
        /// </summary>
        /// <value>Private link id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// True if private link is active
        /// </summary>
        /// <value>True if private link is active</value>
        [DataMember(Name="is_active", EmitDefaultValue=false)]
        public bool? IsActive { get; set; }

        /// <summary>
        /// Date when link will expire
        /// </summary>
        /// <value>Date when link will expire</value>
        [DataMember(Name="expires_date", EmitDefaultValue=false)]
        public string ExpiresDate { get; set; }

        /// <summary>
        /// HTML url for private link
        /// </summary>
        /// <value>HTML url for private link</value>
        [DataMember(Name="html_location", EmitDefaultValue=false)]
        public string HtmlLocation { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class PrivateLink {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  IsActive: ").Append(IsActive).Append("\n");
            sb.Append("  ExpiresDate: ").Append(ExpiresDate).Append("\n");
            sb.Append("  HtmlLocation: ").Append(HtmlLocation).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as PrivateLink);
        }

        /// <summary>
        /// Returns true if PrivateLink instances are equal
        /// </summary>
        /// <param name="input">Instance of PrivateLink to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PrivateLink input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.IsActive == input.IsActive ||
                    (this.IsActive != null &&
                    this.IsActive.Equals(input.IsActive))
                ) && 
                (
                    this.ExpiresDate == input.ExpiresDate ||
                    (this.ExpiresDate != null &&
                    this.ExpiresDate.Equals(input.ExpiresDate))
                ) && 
                (
                    this.HtmlLocation == input.HtmlLocation ||
                    (this.HtmlLocation != null &&
                    this.HtmlLocation.Equals(input.HtmlLocation))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.IsActive != null)
                    hashCode = hashCode * 59 + this.IsActive.GetHashCode();
                if (this.ExpiresDate != null)
                    hashCode = hashCode * 59 + this.ExpiresDate.GetHashCode();
                if (this.HtmlLocation != null)
                    hashCode = hashCode * 59 + this.HtmlLocation.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
