/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PrivateLinkResponse
    /// </summary>
    [DataContract]
    public partial class PrivateLinkResponse :  IEquatable<PrivateLinkResponse>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PrivateLinkResponse" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected PrivateLinkResponse() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="PrivateLinkResponse" /> class.
        /// </summary>
        /// <param name="location">Url for private link (required).</param>
        /// <param name="htmlLocation">HTML url for private link (required).</param>
        /// <param name="token">Token for private link (required).</param>
        public PrivateLinkResponse(string location = default(string), string htmlLocation = default(string), string token = default(string))
        {
            // to ensure "location" is required (not null)
            if (location == null)
            {
                throw new InvalidDataException("location is a required property for PrivateLinkResponse and cannot be null");
            }
            else
            {
                this.Location = location;
            }
            // to ensure "htmlLocation" is required (not null)
            if (htmlLocation == null)
            {
                throw new InvalidDataException("htmlLocation is a required property for PrivateLinkResponse and cannot be null");
            }
            else
            {
                this.HtmlLocation = htmlLocation;
            }
            // to ensure "token" is required (not null)
            if (token == null)
            {
                throw new InvalidDataException("token is a required property for PrivateLinkResponse and cannot be null");
            }
            else
            {
                this.Token = token;
            }
        }
        
        /// <summary>
        /// Url for private link
        /// </summary>
        /// <value>Url for private link</value>
        [DataMember(Name="location", EmitDefaultValue=false)]
        public string Location { get; set; }

        /// <summary>
        /// HTML url for private link
        /// </summary>
        /// <value>HTML url for private link</value>
        [DataMember(Name="html_location", EmitDefaultValue=false)]
        public string HtmlLocation { get; set; }

        /// <summary>
        /// Token for private link
        /// </summary>
        /// <value>Token for private link</value>
        [DataMember(Name="token", EmitDefaultValue=false)]
        public string Token { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class PrivateLinkResponse {\n");
            sb.Append("  Location: ").Append(Location).Append("\n");
            sb.Append("  HtmlLocation: ").Append(HtmlLocation).Append("\n");
            sb.Append("  Token: ").Append(Token).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as PrivateLinkResponse);
        }

        /// <summary>
        /// Returns true if PrivateLinkResponse instances are equal
        /// </summary>
        /// <param name="input">Instance of PrivateLinkResponse to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PrivateLinkResponse input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Location == input.Location ||
                    (this.Location != null &&
                    this.Location.Equals(input.Location))
                ) && 
                (
                    this.HtmlLocation == input.HtmlLocation ||
                    (this.HtmlLocation != null &&
                    this.HtmlLocation.Equals(input.HtmlLocation))
                ) && 
                (
                    this.Token == input.Token ||
                    (this.Token != null &&
                    this.Token.Equals(input.Token))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Location != null)
                    hashCode = hashCode * 59 + this.Location.GetHashCode();
                if (this.HtmlLocation != null)
                    hashCode = hashCode * 59 + this.HtmlLocation.GetHashCode();
                if (this.Token != null)
                    hashCode = hashCode * 59 + this.Token.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
