/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProjectArticle
    /// </summary>
    [DataContract]
    public partial class ProjectArticle : Article,  IEquatable<ProjectArticle>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectArticle" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProjectArticle() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectArticle" /> class.
        /// </summary>
        /// <param name="id">Unique identifier for article (required).</param>
        /// <param name="title">Title of article (required).</param>
        /// <param name="doi">DOI (required).</param>
        /// <param name="handle">Handle (required).</param>
        /// <param name="url">Api endpoint for article (required).</param>
        /// <param name="urlPublicHtml">Public site endpoint for article (required).</param>
        /// <param name="urlPublicApi">Public Api endpoint for article (required).</param>
        /// <param name="urlPrivateHtml">Private site endpoint for article (required).</param>
        /// <param name="urlPrivateApi">Private Api endpoint for article (required).</param>
        /// <param name="timeline">Various timeline dates (required).</param>
        /// <param name="thumb">Thumbnail image (required).</param>
        /// <param name="definedType">Type of article identifier (required).</param>
        /// <param name="definedTypeName">Name of the article type identifier (required).</param>
        /// <param name="citation">Article citation (required).</param>
        /// <param name="confidentialReason">Confidentiality reason (required).</param>
        /// <param name="isConfidential">Article Confidentiality (required).</param>
        /// <param name="size">Article size (required).</param>
        /// <param name="funding">Article funding (required).</param>
        /// <param name="fundingList">Full Article funding information (required).</param>
        /// <param name="tags">List of article tags (required).</param>
        /// <param name="version">Article version (required).</param>
        /// <param name="isActive">True if article is active (required).</param>
        /// <param name="isMetadataRecord">True if article has no files (required).</param>
        /// <param name="metadataReason">Article metadata reason (required).</param>
        /// <param name="status">Article status (required).</param>
        /// <param name="description">Article description (required).</param>
        /// <param name="isEmbargoed">True if article is embargoed (required).</param>
        /// <param name="isPublic">True if article is published (required).</param>
        /// <param name="createdDate">Date when article was created (required).</param>
        /// <param name="hasLinkedFile">True if any files are linked to the article (required).</param>
        /// <param name="categories">List of categories selected for the article (required).</param>
        /// <param name="license">Article selected license (required).</param>
        /// <param name="embargoTitle">Title for embargo (required).</param>
        /// <param name="embargoReason">Reason for embargo (required).</param>
        /// <param name="references">List of references (required).</param>
        /// <param name="relatedMaterials">List of related materials; supersedes references and resource DOI/title..</param>
        public ProjectArticle(long? id = default(long?), string title = default(string), string doi = default(string), string handle = default(string), string url = default(string), string urlPublicHtml = default(string), string urlPublicApi = default(string), string urlPrivateHtml = default(string), string urlPrivateApi = default(string), Timeline timeline = default(Timeline), string thumb = default(string), long? definedType = default(long?), string definedTypeName = default(string), string citation = default(string), string confidentialReason = default(string), bool? isConfidential = default(bool?), long? size = default(long?), string funding = default(string), List<FundingInformation> fundingList = default(List<FundingInformation>), List<string> tags = default(List<string>), long? version = default(long?), bool? isActive = default(bool?), bool? isMetadataRecord = default(bool?), string metadataReason = default(string), string status = default(string), string description = default(string), bool? isEmbargoed = default(bool?), bool? isPublic = default(bool?), string createdDate = default(string), bool? hasLinkedFile = default(bool?), List<Category> categories = default(List<Category>), License license = default(License), string embargoTitle = default(string), string embargoReason = default(string), List<string> references = default(List<string>), List<RelatedMaterial> relatedMaterials = default(List<RelatedMaterial>)) : base()
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "title" is required (not null)
            if (title == null)
            {
                throw new InvalidDataException("title is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Title = title;
            }
            // to ensure "doi" is required (not null)
            if (doi == null)
            {
                throw new InvalidDataException("doi is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Doi = doi;
            }
            // to ensure "handle" is required (not null)
            if (handle == null)
            {
                throw new InvalidDataException("handle is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Handle = handle;
            }
            // to ensure "url" is required (not null)
            if (url == null)
            {
                throw new InvalidDataException("url is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Url = url;
            }
            // to ensure "urlPublicHtml" is required (not null)
            if (urlPublicHtml == null)
            {
                throw new InvalidDataException("urlPublicHtml is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.UrlPublicHtml = urlPublicHtml;
            }
            // to ensure "urlPublicApi" is required (not null)
            if (urlPublicApi == null)
            {
                throw new InvalidDataException("urlPublicApi is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.UrlPublicApi = urlPublicApi;
            }
            // to ensure "urlPrivateHtml" is required (not null)
            if (urlPrivateHtml == null)
            {
                throw new InvalidDataException("urlPrivateHtml is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.UrlPrivateHtml = urlPrivateHtml;
            }
            // to ensure "urlPrivateApi" is required (not null)
            if (urlPrivateApi == null)
            {
                throw new InvalidDataException("urlPrivateApi is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.UrlPrivateApi = urlPrivateApi;
            }
            // to ensure "timeline" is required (not null)
            if (timeline == null)
            {
                throw new InvalidDataException("timeline is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Timeline = timeline;
            }
            // to ensure "thumb" is required (not null)
            if (thumb == null)
            {
                throw new InvalidDataException("thumb is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Thumb = thumb;
            }
            // to ensure "definedType" is required (not null)
            if (definedType == null)
            {
                throw new InvalidDataException("definedType is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.DefinedType = definedType;
            }
            // to ensure "definedTypeName" is required (not null)
            if (definedTypeName == null)
            {
                throw new InvalidDataException("definedTypeName is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.DefinedTypeName = definedTypeName;
            }
            // to ensure "citation" is required (not null)
            if (citation == null)
            {
                throw new InvalidDataException("citation is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Citation = citation;
            }
            // to ensure "confidentialReason" is required (not null)
            if (confidentialReason == null)
            {
                throw new InvalidDataException("confidentialReason is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.ConfidentialReason = confidentialReason;
            }
            // to ensure "isConfidential" is required (not null)
            if (isConfidential == null)
            {
                throw new InvalidDataException("isConfidential is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.IsConfidential = isConfidential;
            }
            // to ensure "size" is required (not null)
            if (size == null)
            {
                throw new InvalidDataException("size is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Size = size;
            }
            // to ensure "funding" is required (not null)
            if (funding == null)
            {
                throw new InvalidDataException("funding is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Funding = funding;
            }
            // to ensure "fundingList" is required (not null)
            if (fundingList == null)
            {
                throw new InvalidDataException("fundingList is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.FundingList = fundingList;
            }
            // to ensure "tags" is required (not null)
            if (tags == null)
            {
                throw new InvalidDataException("tags is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Tags = tags;
            }
            // to ensure "version" is required (not null)
            if (version == null)
            {
                throw new InvalidDataException("version is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Version = version;
            }
            // to ensure "isActive" is required (not null)
            if (isActive == null)
            {
                throw new InvalidDataException("isActive is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.IsActive = isActive;
            }
            // to ensure "isMetadataRecord" is required (not null)
            if (isMetadataRecord == null)
            {
                throw new InvalidDataException("isMetadataRecord is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.IsMetadataRecord = isMetadataRecord;
            }
            // to ensure "metadataReason" is required (not null)
            if (metadataReason == null)
            {
                throw new InvalidDataException("metadataReason is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.MetadataReason = metadataReason;
            }
            // to ensure "status" is required (not null)
            if (status == null)
            {
                throw new InvalidDataException("status is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Status = status;
            }
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new InvalidDataException("description is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Description = description;
            }
            // to ensure "isEmbargoed" is required (not null)
            if (isEmbargoed == null)
            {
                throw new InvalidDataException("isEmbargoed is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.IsEmbargoed = isEmbargoed;
            }
            // to ensure "isPublic" is required (not null)
            if (isPublic == null)
            {
                throw new InvalidDataException("isPublic is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.IsPublic = isPublic;
            }
            // to ensure "createdDate" is required (not null)
            if (createdDate == null)
            {
                throw new InvalidDataException("createdDate is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.CreatedDate = createdDate;
            }
            // to ensure "hasLinkedFile" is required (not null)
            if (hasLinkedFile == null)
            {
                throw new InvalidDataException("hasLinkedFile is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.HasLinkedFile = hasLinkedFile;
            }
            // to ensure "categories" is required (not null)
            if (categories == null)
            {
                throw new InvalidDataException("categories is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.Categories = categories;
            }
            // to ensure "license" is required (not null)
            if (license == null)
            {
                throw new InvalidDataException("license is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.License = license;
            }
            // to ensure "embargoTitle" is required (not null)
            if (embargoTitle == null)
            {
                throw new InvalidDataException("embargoTitle is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.EmbargoTitle = embargoTitle;
            }
            // to ensure "embargoReason" is required (not null)
            if (embargoReason == null)
            {
                throw new InvalidDataException("embargoReason is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.EmbargoReason = embargoReason;
            }
            // to ensure "references" is required (not null)
            if (references == null)
            {
                throw new InvalidDataException("references is a required property for ProjectArticle and cannot be null");
            }
            else
            {
                this.References = references;
            }
            this.RelatedMaterials = relatedMaterials;
        }
        
        /// <summary>
        /// Unique identifier for article
        /// </summary>
        /// <value>Unique identifier for article</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// Title of article
        /// </summary>
        /// <value>Title of article</value>
        [DataMember(Name="title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// DOI
        /// </summary>
        /// <value>DOI</value>
        [DataMember(Name="doi", EmitDefaultValue=false)]
        public string Doi { get; set; }

        /// <summary>
        /// Handle
        /// </summary>
        /// <value>Handle</value>
        [DataMember(Name="handle", EmitDefaultValue=false)]
        public string Handle { get; set; }

        /// <summary>
        /// Api endpoint for article
        /// </summary>
        /// <value>Api endpoint for article</value>
        [DataMember(Name="url", EmitDefaultValue=false)]
        public string Url { get; set; }

        /// <summary>
        /// Public site endpoint for article
        /// </summary>
        /// <value>Public site endpoint for article</value>
        [DataMember(Name="url_public_html", EmitDefaultValue=false)]
        public string UrlPublicHtml { get; set; }

        /// <summary>
        /// Public Api endpoint for article
        /// </summary>
        /// <value>Public Api endpoint for article</value>
        [DataMember(Name="url_public_api", EmitDefaultValue=false)]
        public string UrlPublicApi { get; set; }

        /// <summary>
        /// Private site endpoint for article
        /// </summary>
        /// <value>Private site endpoint for article</value>
        [DataMember(Name="url_private_html", EmitDefaultValue=false)]
        public string UrlPrivateHtml { get; set; }

        /// <summary>
        /// Private Api endpoint for article
        /// </summary>
        /// <value>Private Api endpoint for article</value>
        [DataMember(Name="url_private_api", EmitDefaultValue=false)]
        public string UrlPrivateApi { get; set; }

        /// <summary>
        /// Various timeline dates
        /// </summary>
        /// <value>Various timeline dates</value>
        [DataMember(Name="timeline", EmitDefaultValue=false)]
        public Timeline Timeline { get; set; }

        /// <summary>
        /// Thumbnail image
        /// </summary>
        /// <value>Thumbnail image</value>
        [DataMember(Name="thumb", EmitDefaultValue=false)]
        public string Thumb { get; set; }

        /// <summary>
        /// Type of article identifier
        /// </summary>
        /// <value>Type of article identifier</value>
        [DataMember(Name="defined_type", EmitDefaultValue=false)]
        public long? DefinedType { get; set; }

        /// <summary>
        /// Name of the article type identifier
        /// </summary>
        /// <value>Name of the article type identifier</value>
        [DataMember(Name="defined_type_name", EmitDefaultValue=false)]
        public string DefinedTypeName { get; set; }

        /// <summary>
        /// Article citation
        /// </summary>
        /// <value>Article citation</value>
        [DataMember(Name="citation", EmitDefaultValue=false)]
        public string Citation { get; set; }

        /// <summary>
        /// Confidentiality reason
        /// </summary>
        /// <value>Confidentiality reason</value>
        [DataMember(Name="confidential_reason", EmitDefaultValue=false)]
        public string ConfidentialReason { get; set; }

        /// <summary>
        /// Article Confidentiality
        /// </summary>
        /// <value>Article Confidentiality</value>
        [DataMember(Name="is_confidential", EmitDefaultValue=false)]
        public bool? IsConfidential { get; set; }

        /// <summary>
        /// Article size
        /// </summary>
        /// <value>Article size</value>
        [DataMember(Name="size", EmitDefaultValue=false)]
        public long? Size { get; set; }

        /// <summary>
        /// Article funding
        /// </summary>
        /// <value>Article funding</value>
        [DataMember(Name="funding", EmitDefaultValue=false)]
        public string Funding { get; set; }

        /// <summary>
        /// Full Article funding information
        /// </summary>
        /// <value>Full Article funding information</value>
        [DataMember(Name="funding_list", EmitDefaultValue=false)]
        public List<FundingInformation> FundingList { get; set; }

        /// <summary>
        /// List of article tags
        /// </summary>
        /// <value>List of article tags</value>
        [DataMember(Name="tags", EmitDefaultValue=false)]
        public List<string> Tags { get; set; }

        /// <summary>
        /// Article version
        /// </summary>
        /// <value>Article version</value>
        [DataMember(Name="version", EmitDefaultValue=false)]
        public long? Version { get; set; }

        /// <summary>
        /// True if article is active
        /// </summary>
        /// <value>True if article is active</value>
        [DataMember(Name="is_active", EmitDefaultValue=false)]
        public bool? IsActive { get; set; }

        /// <summary>
        /// True if article has no files
        /// </summary>
        /// <value>True if article has no files</value>
        [DataMember(Name="is_metadata_record", EmitDefaultValue=false)]
        public bool? IsMetadataRecord { get; set; }

        /// <summary>
        /// Article metadata reason
        /// </summary>
        /// <value>Article metadata reason</value>
        [DataMember(Name="metadata_reason", EmitDefaultValue=false)]
        public string MetadataReason { get; set; }

        /// <summary>
        /// Article status
        /// </summary>
        /// <value>Article status</value>
        [DataMember(Name="status", EmitDefaultValue=false)]
        public string Status { get; set; }

        /// <summary>
        /// Article description
        /// </summary>
        /// <value>Article description</value>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// True if article is embargoed
        /// </summary>
        /// <value>True if article is embargoed</value>
        [DataMember(Name="is_embargoed", EmitDefaultValue=false)]
        public bool? IsEmbargoed { get; set; }

        /// <summary>
        /// True if article is published
        /// </summary>
        /// <value>True if article is published</value>
        [DataMember(Name="is_public", EmitDefaultValue=false)]
        public bool? IsPublic { get; set; }

        /// <summary>
        /// Date when article was created
        /// </summary>
        /// <value>Date when article was created</value>
        [DataMember(Name="created_date", EmitDefaultValue=false)]
        public string CreatedDate { get; set; }

        /// <summary>
        /// True if any files are linked to the article
        /// </summary>
        /// <value>True if any files are linked to the article</value>
        [DataMember(Name="has_linked_file", EmitDefaultValue=false)]
        public bool? HasLinkedFile { get; set; }

        /// <summary>
        /// List of categories selected for the article
        /// </summary>
        /// <value>List of categories selected for the article</value>
        [DataMember(Name="categories", EmitDefaultValue=false)]
        public List<Category> Categories { get; set; }

        /// <summary>
        /// Article selected license
        /// </summary>
        /// <value>Article selected license</value>
        [DataMember(Name="license", EmitDefaultValue=false)]
        public License License { get; set; }

        /// <summary>
        /// Title for embargo
        /// </summary>
        /// <value>Title for embargo</value>
        [DataMember(Name="embargo_title", EmitDefaultValue=false)]
        public string EmbargoTitle { get; set; }

        /// <summary>
        /// Reason for embargo
        /// </summary>
        /// <value>Reason for embargo</value>
        [DataMember(Name="embargo_reason", EmitDefaultValue=false)]
        public string EmbargoReason { get; set; }

        /// <summary>
        /// List of references
        /// </summary>
        /// <value>List of references</value>
        [DataMember(Name="references", EmitDefaultValue=false)]
        public List<string> References { get; set; }

        /// <summary>
        /// List of related materials; supersedes references and resource DOI/title.
        /// </summary>
        /// <value>List of related materials; supersedes references and resource DOI/title.</value>
        [DataMember(Name="related_materials", EmitDefaultValue=false)]
        public List<RelatedMaterial> RelatedMaterials { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProjectArticle {\n");
            sb.Append("  ").Append(base.ToString().Replace("\n", "\n  ")).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Doi: ").Append(Doi).Append("\n");
            sb.Append("  Handle: ").Append(Handle).Append("\n");
            sb.Append("  Url: ").Append(Url).Append("\n");
            sb.Append("  UrlPublicHtml: ").Append(UrlPublicHtml).Append("\n");
            sb.Append("  UrlPublicApi: ").Append(UrlPublicApi).Append("\n");
            sb.Append("  UrlPrivateHtml: ").Append(UrlPrivateHtml).Append("\n");
            sb.Append("  UrlPrivateApi: ").Append(UrlPrivateApi).Append("\n");
            sb.Append("  Timeline: ").Append(Timeline).Append("\n");
            sb.Append("  Thumb: ").Append(Thumb).Append("\n");
            sb.Append("  DefinedType: ").Append(DefinedType).Append("\n");
            sb.Append("  DefinedTypeName: ").Append(DefinedTypeName).Append("\n");
            sb.Append("  Citation: ").Append(Citation).Append("\n");
            sb.Append("  ConfidentialReason: ").Append(ConfidentialReason).Append("\n");
            sb.Append("  IsConfidential: ").Append(IsConfidential).Append("\n");
            sb.Append("  Size: ").Append(Size).Append("\n");
            sb.Append("  Funding: ").Append(Funding).Append("\n");
            sb.Append("  FundingList: ").Append(FundingList).Append("\n");
            sb.Append("  Tags: ").Append(Tags).Append("\n");
            sb.Append("  Version: ").Append(Version).Append("\n");
            sb.Append("  IsActive: ").Append(IsActive).Append("\n");
            sb.Append("  IsMetadataRecord: ").Append(IsMetadataRecord).Append("\n");
            sb.Append("  MetadataReason: ").Append(MetadataReason).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  IsEmbargoed: ").Append(IsEmbargoed).Append("\n");
            sb.Append("  IsPublic: ").Append(IsPublic).Append("\n");
            sb.Append("  CreatedDate: ").Append(CreatedDate).Append("\n");
            sb.Append("  HasLinkedFile: ").Append(HasLinkedFile).Append("\n");
            sb.Append("  Categories: ").Append(Categories).Append("\n");
            sb.Append("  License: ").Append(License).Append("\n");
            sb.Append("  EmbargoTitle: ").Append(EmbargoTitle).Append("\n");
            sb.Append("  EmbargoReason: ").Append(EmbargoReason).Append("\n");
            sb.Append("  References: ").Append(References).Append("\n");
            sb.Append("  RelatedMaterials: ").Append(RelatedMaterials).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public override string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectArticle);
        }

        /// <summary>
        /// Returns true if ProjectArticle instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectArticle to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectArticle input)
        {
            if (input == null)
                return false;

            return base.Equals(input) && 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && base.Equals(input) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && base.Equals(input) && 
                (
                    this.Doi == input.Doi ||
                    (this.Doi != null &&
                    this.Doi.Equals(input.Doi))
                ) && base.Equals(input) && 
                (
                    this.Handle == input.Handle ||
                    (this.Handle != null &&
                    this.Handle.Equals(input.Handle))
                ) && base.Equals(input) && 
                (
                    this.Url == input.Url ||
                    (this.Url != null &&
                    this.Url.Equals(input.Url))
                ) && base.Equals(input) && 
                (
                    this.UrlPublicHtml == input.UrlPublicHtml ||
                    (this.UrlPublicHtml != null &&
                    this.UrlPublicHtml.Equals(input.UrlPublicHtml))
                ) && base.Equals(input) && 
                (
                    this.UrlPublicApi == input.UrlPublicApi ||
                    (this.UrlPublicApi != null &&
                    this.UrlPublicApi.Equals(input.UrlPublicApi))
                ) && base.Equals(input) && 
                (
                    this.UrlPrivateHtml == input.UrlPrivateHtml ||
                    (this.UrlPrivateHtml != null &&
                    this.UrlPrivateHtml.Equals(input.UrlPrivateHtml))
                ) && base.Equals(input) && 
                (
                    this.UrlPrivateApi == input.UrlPrivateApi ||
                    (this.UrlPrivateApi != null &&
                    this.UrlPrivateApi.Equals(input.UrlPrivateApi))
                ) && base.Equals(input) && 
                (
                    this.Timeline == input.Timeline ||
                    (this.Timeline != null &&
                    this.Timeline.Equals(input.Timeline))
                ) && base.Equals(input) && 
                (
                    this.Thumb == input.Thumb ||
                    (this.Thumb != null &&
                    this.Thumb.Equals(input.Thumb))
                ) && base.Equals(input) && 
                (
                    this.DefinedType == input.DefinedType ||
                    (this.DefinedType != null &&
                    this.DefinedType.Equals(input.DefinedType))
                ) && base.Equals(input) && 
                (
                    this.DefinedTypeName == input.DefinedTypeName ||
                    (this.DefinedTypeName != null &&
                    this.DefinedTypeName.Equals(input.DefinedTypeName))
                ) && base.Equals(input) && 
                (
                    this.Citation == input.Citation ||
                    (this.Citation != null &&
                    this.Citation.Equals(input.Citation))
                ) && base.Equals(input) && 
                (
                    this.ConfidentialReason == input.ConfidentialReason ||
                    (this.ConfidentialReason != null &&
                    this.ConfidentialReason.Equals(input.ConfidentialReason))
                ) && base.Equals(input) && 
                (
                    this.IsConfidential == input.IsConfidential ||
                    (this.IsConfidential != null &&
                    this.IsConfidential.Equals(input.IsConfidential))
                ) && base.Equals(input) && 
                (
                    this.Size == input.Size ||
                    (this.Size != null &&
                    this.Size.Equals(input.Size))
                ) && base.Equals(input) && 
                (
                    this.Funding == input.Funding ||
                    (this.Funding != null &&
                    this.Funding.Equals(input.Funding))
                ) && base.Equals(input) && 
                (
                    this.FundingList == input.FundingList ||
                    this.FundingList != null &&
                    this.FundingList.SequenceEqual(input.FundingList)
                ) && base.Equals(input) && 
                (
                    this.Tags == input.Tags ||
                    this.Tags != null &&
                    this.Tags.SequenceEqual(input.Tags)
                ) && base.Equals(input) && 
                (
                    this.Version == input.Version ||
                    (this.Version != null &&
                    this.Version.Equals(input.Version))
                ) && base.Equals(input) && 
                (
                    this.IsActive == input.IsActive ||
                    (this.IsActive != null &&
                    this.IsActive.Equals(input.IsActive))
                ) && base.Equals(input) && 
                (
                    this.IsMetadataRecord == input.IsMetadataRecord ||
                    (this.IsMetadataRecord != null &&
                    this.IsMetadataRecord.Equals(input.IsMetadataRecord))
                ) && base.Equals(input) && 
                (
                    this.MetadataReason == input.MetadataReason ||
                    (this.MetadataReason != null &&
                    this.MetadataReason.Equals(input.MetadataReason))
                ) && base.Equals(input) && 
                (
                    this.Status == input.Status ||
                    (this.Status != null &&
                    this.Status.Equals(input.Status))
                ) && base.Equals(input) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && base.Equals(input) && 
                (
                    this.IsEmbargoed == input.IsEmbargoed ||
                    (this.IsEmbargoed != null &&
                    this.IsEmbargoed.Equals(input.IsEmbargoed))
                ) && base.Equals(input) && 
                (
                    this.IsPublic == input.IsPublic ||
                    (this.IsPublic != null &&
                    this.IsPublic.Equals(input.IsPublic))
                ) && base.Equals(input) && 
                (
                    this.CreatedDate == input.CreatedDate ||
                    (this.CreatedDate != null &&
                    this.CreatedDate.Equals(input.CreatedDate))
                ) && base.Equals(input) && 
                (
                    this.HasLinkedFile == input.HasLinkedFile ||
                    (this.HasLinkedFile != null &&
                    this.HasLinkedFile.Equals(input.HasLinkedFile))
                ) && base.Equals(input) && 
                (
                    this.Categories == input.Categories ||
                    this.Categories != null &&
                    this.Categories.SequenceEqual(input.Categories)
                ) && base.Equals(input) && 
                (
                    this.License == input.License ||
                    (this.License != null &&
                    this.License.Equals(input.License))
                ) && base.Equals(input) && 
                (
                    this.EmbargoTitle == input.EmbargoTitle ||
                    (this.EmbargoTitle != null &&
                    this.EmbargoTitle.Equals(input.EmbargoTitle))
                ) && base.Equals(input) && 
                (
                    this.EmbargoReason == input.EmbargoReason ||
                    (this.EmbargoReason != null &&
                    this.EmbargoReason.Equals(input.EmbargoReason))
                ) && base.Equals(input) && 
                (
                    this.References == input.References ||
                    this.References != null &&
                    this.References.SequenceEqual(input.References)
                ) && base.Equals(input) && 
                (
                    this.RelatedMaterials == input.RelatedMaterials ||
                    this.RelatedMaterials != null &&
                    this.RelatedMaterials.SequenceEqual(input.RelatedMaterials)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = base.GetHashCode();
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Doi != null)
                    hashCode = hashCode * 59 + this.Doi.GetHashCode();
                if (this.Handle != null)
                    hashCode = hashCode * 59 + this.Handle.GetHashCode();
                if (this.Url != null)
                    hashCode = hashCode * 59 + this.Url.GetHashCode();
                if (this.UrlPublicHtml != null)
                    hashCode = hashCode * 59 + this.UrlPublicHtml.GetHashCode();
                if (this.UrlPublicApi != null)
                    hashCode = hashCode * 59 + this.UrlPublicApi.GetHashCode();
                if (this.UrlPrivateHtml != null)
                    hashCode = hashCode * 59 + this.UrlPrivateHtml.GetHashCode();
                if (this.UrlPrivateApi != null)
                    hashCode = hashCode * 59 + this.UrlPrivateApi.GetHashCode();
                if (this.Timeline != null)
                    hashCode = hashCode * 59 + this.Timeline.GetHashCode();
                if (this.Thumb != null)
                    hashCode = hashCode * 59 + this.Thumb.GetHashCode();
                if (this.DefinedType != null)
                    hashCode = hashCode * 59 + this.DefinedType.GetHashCode();
                if (this.DefinedTypeName != null)
                    hashCode = hashCode * 59 + this.DefinedTypeName.GetHashCode();
                if (this.Citation != null)
                    hashCode = hashCode * 59 + this.Citation.GetHashCode();
                if (this.ConfidentialReason != null)
                    hashCode = hashCode * 59 + this.ConfidentialReason.GetHashCode();
                if (this.IsConfidential != null)
                    hashCode = hashCode * 59 + this.IsConfidential.GetHashCode();
                if (this.Size != null)
                    hashCode = hashCode * 59 + this.Size.GetHashCode();
                if (this.Funding != null)
                    hashCode = hashCode * 59 + this.Funding.GetHashCode();
                if (this.FundingList != null)
                    hashCode = hashCode * 59 + this.FundingList.GetHashCode();
                if (this.Tags != null)
                    hashCode = hashCode * 59 + this.Tags.GetHashCode();
                if (this.Version != null)
                    hashCode = hashCode * 59 + this.Version.GetHashCode();
                if (this.IsActive != null)
                    hashCode = hashCode * 59 + this.IsActive.GetHashCode();
                if (this.IsMetadataRecord != null)
                    hashCode = hashCode * 59 + this.IsMetadataRecord.GetHashCode();
                if (this.MetadataReason != null)
                    hashCode = hashCode * 59 + this.MetadataReason.GetHashCode();
                if (this.Status != null)
                    hashCode = hashCode * 59 + this.Status.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.IsEmbargoed != null)
                    hashCode = hashCode * 59 + this.IsEmbargoed.GetHashCode();
                if (this.IsPublic != null)
                    hashCode = hashCode * 59 + this.IsPublic.GetHashCode();
                if (this.CreatedDate != null)
                    hashCode = hashCode * 59 + this.CreatedDate.GetHashCode();
                if (this.HasLinkedFile != null)
                    hashCode = hashCode * 59 + this.HasLinkedFile.GetHashCode();
                if (this.Categories != null)
                    hashCode = hashCode * 59 + this.Categories.GetHashCode();
                if (this.License != null)
                    hashCode = hashCode * 59 + this.License.GetHashCode();
                if (this.EmbargoTitle != null)
                    hashCode = hashCode * 59 + this.EmbargoTitle.GetHashCode();
                if (this.EmbargoReason != null)
                    hashCode = hashCode * 59 + this.EmbargoReason.GetHashCode();
                if (this.References != null)
                    hashCode = hashCode * 59 + this.References.GetHashCode();
                if (this.RelatedMaterials != null)
                    hashCode = hashCode * 59 + this.RelatedMaterials.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            foreach(var x in BaseValidate(validationContext)) yield return x;
            yield break;
        }
    }

}
