/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProjectCollaboratorInvite
    /// </summary>
    [DataContract]
    public partial class ProjectCollaboratorInvite :  IEquatable<ProjectCollaboratorInvite>, IValidatableObject
    {
        /// <summary>
        /// Role of the the collaborator inside the project
        /// </summary>
        /// <value>Role of the the collaborator inside the project</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum RoleNameEnum
        {
            
            /// <summary>
            /// Enum Viewer for value: viewer
            /// </summary>
            [EnumMember(Value = "viewer")]
            Viewer = 1,
            
            /// <summary>
            /// Enum Collaborator for value: collaborator
            /// </summary>
            [EnumMember(Value = "collaborator")]
            Collaborator = 2
        }

        /// <summary>
        /// Role of the the collaborator inside the project
        /// </summary>
        /// <value>Role of the the collaborator inside the project</value>
        [DataMember(Name="role_name", EmitDefaultValue=false)]
        public RoleNameEnum RoleName { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectCollaboratorInvite" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProjectCollaboratorInvite() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectCollaboratorInvite" /> class.
        /// </summary>
        /// <param name="roleName">Role of the the collaborator inside the project (required).</param>
        /// <param name="userId">User id of the collaborator.</param>
        /// <param name="email">Collaborator email.</param>
        /// <param name="comment">Text sent when inviting the user to the project.</param>
        public ProjectCollaboratorInvite(RoleNameEnum roleName = default(RoleNameEnum), long? userId = default(long?), string email = default(string), string comment = default(string))
        {
            // to ensure "roleName" is required (not null)
            if (roleName == null)
            {
                throw new InvalidDataException("roleName is a required property for ProjectCollaboratorInvite and cannot be null");
            }
            else
            {
                this.RoleName = roleName;
            }
            this.UserId = userId;
            this.Email = email;
            this.Comment = comment;
        }
        

        /// <summary>
        /// User id of the collaborator
        /// </summary>
        /// <value>User id of the collaborator</value>
        [DataMember(Name="user_id", EmitDefaultValue=false)]
        public long? UserId { get; set; }

        /// <summary>
        /// Collaborator email
        /// </summary>
        /// <value>Collaborator email</value>
        [DataMember(Name="email", EmitDefaultValue=false)]
        public string Email { get; set; }

        /// <summary>
        /// Text sent when inviting the user to the project
        /// </summary>
        /// <value>Text sent when inviting the user to the project</value>
        [DataMember(Name="comment", EmitDefaultValue=false)]
        public string Comment { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProjectCollaboratorInvite {\n");
            sb.Append("  RoleName: ").Append(RoleName).Append("\n");
            sb.Append("  UserId: ").Append(UserId).Append("\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("  Comment: ").Append(Comment).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectCollaboratorInvite);
        }

        /// <summary>
        /// Returns true if ProjectCollaboratorInvite instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectCollaboratorInvite to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectCollaboratorInvite input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.RoleName == input.RoleName ||
                    (this.RoleName != null &&
                    this.RoleName.Equals(input.RoleName))
                ) && 
                (
                    this.UserId == input.UserId ||
                    (this.UserId != null &&
                    this.UserId.Equals(input.UserId))
                ) && 
                (
                    this.Email == input.Email ||
                    (this.Email != null &&
                    this.Email.Equals(input.Email))
                ) && 
                (
                    this.Comment == input.Comment ||
                    (this.Comment != null &&
                    this.Comment.Equals(input.Comment))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.RoleName != null)
                    hashCode = hashCode * 59 + this.RoleName.GetHashCode();
                if (this.UserId != null)
                    hashCode = hashCode * 59 + this.UserId.GetHashCode();
                if (this.Email != null)
                    hashCode = hashCode * 59 + this.Email.GetHashCode();
                if (this.Comment != null)
                    hashCode = hashCode * 59 + this.Comment.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
