/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProjectComplete
    /// </summary>
    [DataContract]
    public partial class ProjectComplete : Project,  IEquatable<ProjectComplete>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectComplete" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProjectComplete() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectComplete" /> class.
        /// </summary>
        /// <param name="url">Api endpoint (required).</param>
        /// <param name="id">Project id (required).</param>
        /// <param name="title">Project title (required).</param>
        /// <param name="funding">Project funding (required).</param>
        /// <param name="fundingList">Full Project funding information (required).</param>
        /// <param name="description">Project description (required).</param>
        /// <param name="collaborators">List of project collaborators (required).</param>
        public ProjectComplete(string url = default(string), long? id = default(long?), string title = default(string), string funding = default(string), List<FundingInformation> fundingList = default(List<FundingInformation>), string description = default(string), List<Collaborator> collaborators = default(List<Collaborator>)) : base()
        {
            // to ensure "url" is required (not null)
            if (url == null)
            {
                throw new InvalidDataException("url is a required property for ProjectComplete and cannot be null");
            }
            else
            {
                this.Url = url;
            }
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for ProjectComplete and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "title" is required (not null)
            if (title == null)
            {
                throw new InvalidDataException("title is a required property for ProjectComplete and cannot be null");
            }
            else
            {
                this.Title = title;
            }
            // to ensure "funding" is required (not null)
            if (funding == null)
            {
                throw new InvalidDataException("funding is a required property for ProjectComplete and cannot be null");
            }
            else
            {
                this.Funding = funding;
            }
            // to ensure "fundingList" is required (not null)
            if (fundingList == null)
            {
                throw new InvalidDataException("fundingList is a required property for ProjectComplete and cannot be null");
            }
            else
            {
                this.FundingList = fundingList;
            }
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new InvalidDataException("description is a required property for ProjectComplete and cannot be null");
            }
            else
            {
                this.Description = description;
            }
            // to ensure "collaborators" is required (not null)
            if (collaborators == null)
            {
                throw new InvalidDataException("collaborators is a required property for ProjectComplete and cannot be null");
            }
            else
            {
                this.Collaborators = collaborators;
            }
        }
        
        /// <summary>
        /// Api endpoint
        /// </summary>
        /// <value>Api endpoint</value>
        [DataMember(Name="url", EmitDefaultValue=false)]
        public string Url { get; set; }

        /// <summary>
        /// Project id
        /// </summary>
        /// <value>Project id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// Project title
        /// </summary>
        /// <value>Project title</value>
        [DataMember(Name="title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// Project funding
        /// </summary>
        /// <value>Project funding</value>
        [DataMember(Name="funding", EmitDefaultValue=false)]
        public string Funding { get; set; }

        /// <summary>
        /// Full Project funding information
        /// </summary>
        /// <value>Full Project funding information</value>
        [DataMember(Name="funding_list", EmitDefaultValue=false)]
        public List<FundingInformation> FundingList { get; set; }

        /// <summary>
        /// Project description
        /// </summary>
        /// <value>Project description</value>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// List of project collaborators
        /// </summary>
        /// <value>List of project collaborators</value>
        [DataMember(Name="collaborators", EmitDefaultValue=false)]
        public List<Collaborator> Collaborators { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProjectComplete {\n");
            sb.Append("  ").Append(base.ToString().Replace("\n", "\n  ")).Append("\n");
            sb.Append("  Url: ").Append(Url).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Funding: ").Append(Funding).Append("\n");
            sb.Append("  FundingList: ").Append(FundingList).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Collaborators: ").Append(Collaborators).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public override string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectComplete);
        }

        /// <summary>
        /// Returns true if ProjectComplete instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectComplete to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectComplete input)
        {
            if (input == null)
                return false;

            return base.Equals(input) && 
                (
                    this.Url == input.Url ||
                    (this.Url != null &&
                    this.Url.Equals(input.Url))
                ) && base.Equals(input) && 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && base.Equals(input) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && base.Equals(input) && 
                (
                    this.Funding == input.Funding ||
                    (this.Funding != null &&
                    this.Funding.Equals(input.Funding))
                ) && base.Equals(input) && 
                (
                    this.FundingList == input.FundingList ||
                    this.FundingList != null &&
                    this.FundingList.SequenceEqual(input.FundingList)
                ) && base.Equals(input) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && base.Equals(input) && 
                (
                    this.Collaborators == input.Collaborators ||
                    this.Collaborators != null &&
                    this.Collaborators.SequenceEqual(input.Collaborators)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = base.GetHashCode();
                if (this.Url != null)
                    hashCode = hashCode * 59 + this.Url.GetHashCode();
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Funding != null)
                    hashCode = hashCode * 59 + this.Funding.GetHashCode();
                if (this.FundingList != null)
                    hashCode = hashCode * 59 + this.FundingList.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.Collaborators != null)
                    hashCode = hashCode * 59 + this.Collaborators.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            foreach(var x in BaseValidate(validationContext)) yield return x;
            yield break;
        }
    }

}
