/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ShortAccount
    /// </summary>
    [DataContract]
    public partial class ShortAccount :  IEquatable<ShortAccount>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ShortAccount" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ShortAccount() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ShortAccount" /> class.
        /// </summary>
        /// <param name="id">Account id (required).</param>
        /// <param name="firstName">First Name (required).</param>
        /// <param name="lastName">Last Name (required).</param>
        /// <param name="institutionId">Account institution (required).</param>
        /// <param name="email">User email (required).</param>
        /// <param name="active">Account activity status (required).</param>
        /// <param name="institutionUserId">Account institution user id (required).</param>
        /// <param name="quota">Total storage available to account, in bytes (required).</param>
        /// <param name="usedQuota">Storage used by the account, in bytes (required).</param>
        /// <param name="userId">User id associated with account, useful for example for adding the account as an author to an item (required).</param>
        /// <param name="orcidId">ORCID iD associated to account (required).</param>
        public ShortAccount(long? id = default(long?), string firstName = default(string), string lastName = default(string), long? institutionId = default(long?), string email = default(string), long? active = default(long?), string institutionUserId = default(string), long? quota = default(long?), long? usedQuota = default(long?), long? userId = default(long?), string orcidId = default(string))
        {
            // to ensure "id" is required (not null)
            if (id == null)
            {
                throw new InvalidDataException("id is a required property for ShortAccount and cannot be null");
            }
            else
            {
                this.Id = id;
            }
            // to ensure "firstName" is required (not null)
            if (firstName == null)
            {
                throw new InvalidDataException("firstName is a required property for ShortAccount and cannot be null");
            }
            else
            {
                this.FirstName = firstName;
            }
            // to ensure "lastName" is required (not null)
            if (lastName == null)
            {
                throw new InvalidDataException("lastName is a required property for ShortAccount and cannot be null");
            }
            else
            {
                this.LastName = lastName;
            }
            // to ensure "institutionId" is required (not null)
            if (institutionId == null)
            {
                throw new InvalidDataException("institutionId is a required property for ShortAccount and cannot be null");
            }
            else
            {
                this.InstitutionId = institutionId;
            }
            // to ensure "email" is required (not null)
            if (email == null)
            {
                throw new InvalidDataException("email is a required property for ShortAccount and cannot be null");
            }
            else
            {
                this.Email = email;
            }
            // to ensure "active" is required (not null)
            if (active == null)
            {
                throw new InvalidDataException("active is a required property for ShortAccount and cannot be null");
            }
            else
            {
                this.Active = active;
            }
            // to ensure "institutionUserId" is required (not null)
            if (institutionUserId == null)
            {
                throw new InvalidDataException("institutionUserId is a required property for ShortAccount and cannot be null");
            }
            else
            {
                this.InstitutionUserId = institutionUserId;
            }
            // to ensure "quota" is required (not null)
            if (quota == null)
            {
                throw new InvalidDataException("quota is a required property for ShortAccount and cannot be null");
            }
            else
            {
                this.Quota = quota;
            }
            // to ensure "usedQuota" is required (not null)
            if (usedQuota == null)
            {
                throw new InvalidDataException("usedQuota is a required property for ShortAccount and cannot be null");
            }
            else
            {
                this.UsedQuota = usedQuota;
            }
            // to ensure "userId" is required (not null)
            if (userId == null)
            {
                throw new InvalidDataException("userId is a required property for ShortAccount and cannot be null");
            }
            else
            {
                this.UserId = userId;
            }
            // to ensure "orcidId" is required (not null)
            if (orcidId == null)
            {
                throw new InvalidDataException("orcidId is a required property for ShortAccount and cannot be null");
            }
            else
            {
                this.OrcidId = orcidId;
            }
        }
        
        /// <summary>
        /// Account id
        /// </summary>
        /// <value>Account id</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public long? Id { get; set; }

        /// <summary>
        /// First Name
        /// </summary>
        /// <value>First Name</value>
        [DataMember(Name="first_name", EmitDefaultValue=false)]
        public string FirstName { get; set; }

        /// <summary>
        /// Last Name
        /// </summary>
        /// <value>Last Name</value>
        [DataMember(Name="last_name", EmitDefaultValue=false)]
        public string LastName { get; set; }

        /// <summary>
        /// Account institution
        /// </summary>
        /// <value>Account institution</value>
        [DataMember(Name="institution_id", EmitDefaultValue=false)]
        public long? InstitutionId { get; set; }

        /// <summary>
        /// User email
        /// </summary>
        /// <value>User email</value>
        [DataMember(Name="email", EmitDefaultValue=false)]
        public string Email { get; set; }

        /// <summary>
        /// Account activity status
        /// </summary>
        /// <value>Account activity status</value>
        [DataMember(Name="active", EmitDefaultValue=false)]
        public long? Active { get; set; }

        /// <summary>
        /// Account institution user id
        /// </summary>
        /// <value>Account institution user id</value>
        [DataMember(Name="institution_user_id", EmitDefaultValue=false)]
        public string InstitutionUserId { get; set; }

        /// <summary>
        /// Total storage available to account, in bytes
        /// </summary>
        /// <value>Total storage available to account, in bytes</value>
        [DataMember(Name="quota", EmitDefaultValue=false)]
        public long? Quota { get; set; }

        /// <summary>
        /// Storage used by the account, in bytes
        /// </summary>
        /// <value>Storage used by the account, in bytes</value>
        [DataMember(Name="used_quota", EmitDefaultValue=false)]
        public long? UsedQuota { get; set; }

        /// <summary>
        /// User id associated with account, useful for example for adding the account as an author to an item
        /// </summary>
        /// <value>User id associated with account, useful for example for adding the account as an author to an item</value>
        [DataMember(Name="user_id", EmitDefaultValue=false)]
        public long? UserId { get; set; }

        /// <summary>
        /// ORCID iD associated to account
        /// </summary>
        /// <value>ORCID iD associated to account</value>
        [DataMember(Name="orcid_id", EmitDefaultValue=false)]
        public string OrcidId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ShortAccount {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  FirstName: ").Append(FirstName).Append("\n");
            sb.Append("  LastName: ").Append(LastName).Append("\n");
            sb.Append("  InstitutionId: ").Append(InstitutionId).Append("\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("  Active: ").Append(Active).Append("\n");
            sb.Append("  InstitutionUserId: ").Append(InstitutionUserId).Append("\n");
            sb.Append("  Quota: ").Append(Quota).Append("\n");
            sb.Append("  UsedQuota: ").Append(UsedQuota).Append("\n");
            sb.Append("  UserId: ").Append(UserId).Append("\n");
            sb.Append("  OrcidId: ").Append(OrcidId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ShortAccount);
        }

        /// <summary>
        /// Returns true if ShortAccount instances are equal
        /// </summary>
        /// <param name="input">Instance of ShortAccount to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ShortAccount input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.FirstName == input.FirstName ||
                    (this.FirstName != null &&
                    this.FirstName.Equals(input.FirstName))
                ) && 
                (
                    this.LastName == input.LastName ||
                    (this.LastName != null &&
                    this.LastName.Equals(input.LastName))
                ) && 
                (
                    this.InstitutionId == input.InstitutionId ||
                    (this.InstitutionId != null &&
                    this.InstitutionId.Equals(input.InstitutionId))
                ) && 
                (
                    this.Email == input.Email ||
                    (this.Email != null &&
                    this.Email.Equals(input.Email))
                ) && 
                (
                    this.Active == input.Active ||
                    (this.Active != null &&
                    this.Active.Equals(input.Active))
                ) && 
                (
                    this.InstitutionUserId == input.InstitutionUserId ||
                    (this.InstitutionUserId != null &&
                    this.InstitutionUserId.Equals(input.InstitutionUserId))
                ) && 
                (
                    this.Quota == input.Quota ||
                    (this.Quota != null &&
                    this.Quota.Equals(input.Quota))
                ) && 
                (
                    this.UsedQuota == input.UsedQuota ||
                    (this.UsedQuota != null &&
                    this.UsedQuota.Equals(input.UsedQuota))
                ) && 
                (
                    this.UserId == input.UserId ||
                    (this.UserId != null &&
                    this.UserId.Equals(input.UserId))
                ) && 
                (
                    this.OrcidId == input.OrcidId ||
                    (this.OrcidId != null &&
                    this.OrcidId.Equals(input.OrcidId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.FirstName != null)
                    hashCode = hashCode * 59 + this.FirstName.GetHashCode();
                if (this.LastName != null)
                    hashCode = hashCode * 59 + this.LastName.GetHashCode();
                if (this.InstitutionId != null)
                    hashCode = hashCode * 59 + this.InstitutionId.GetHashCode();
                if (this.Email != null)
                    hashCode = hashCode * 59 + this.Email.GetHashCode();
                if (this.Active != null)
                    hashCode = hashCode * 59 + this.Active.GetHashCode();
                if (this.InstitutionUserId != null)
                    hashCode = hashCode * 59 + this.InstitutionUserId.GetHashCode();
                if (this.Quota != null)
                    hashCode = hashCode * 59 + this.Quota.GetHashCode();
                if (this.UsedQuota != null)
                    hashCode = hashCode * 59 + this.UsedQuota.GetHashCode();
                if (this.UserId != null)
                    hashCode = hashCode * 59 + this.UserId.GetHashCode();
                if (this.OrcidId != null)
                    hashCode = hashCode * 59 + this.OrcidId.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
