/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Timeline
    /// </summary>
    [DataContract]
    public partial class Timeline : TimelineUpdate,  IEquatable<Timeline>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Timeline" /> class.
        /// </summary>
        /// <param name="firstOnline">Online posted date.</param>
        /// <param name="publisherPublication">Publish date.</param>
        /// <param name="publisherAcceptance">Date when the item was accepted for publication.</param>
        public Timeline(string firstOnline = default(string), string publisherPublication = default(string), string publisherAcceptance = default(string)) : base()
        {
            this.FirstOnline = firstOnline;
            this.PublisherPublication = publisherPublication;
            this.PublisherAcceptance = publisherAcceptance;
        }
        
        /// <summary>
        /// Online posted date
        /// </summary>
        /// <value>Online posted date</value>
        [DataMember(Name="firstOnline", EmitDefaultValue=false)]
        public string FirstOnline { get; set; }

        /// <summary>
        /// Publish date
        /// </summary>
        /// <value>Publish date</value>
        [DataMember(Name="publisherPublication", EmitDefaultValue=false)]
        public string PublisherPublication { get; set; }

        /// <summary>
        /// Date when the item was accepted for publication
        /// </summary>
        /// <value>Date when the item was accepted for publication</value>
        [DataMember(Name="publisherAcceptance", EmitDefaultValue=false)]
        public string PublisherAcceptance { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Timeline {\n");
            sb.Append("  ").Append(base.ToString().Replace("\n", "\n  ")).Append("\n");
            sb.Append("  FirstOnline: ").Append(FirstOnline).Append("\n");
            sb.Append("  PublisherPublication: ").Append(PublisherPublication).Append("\n");
            sb.Append("  PublisherAcceptance: ").Append(PublisherAcceptance).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public override string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Timeline);
        }

        /// <summary>
        /// Returns true if Timeline instances are equal
        /// </summary>
        /// <param name="input">Instance of Timeline to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Timeline input)
        {
            if (input == null)
                return false;

            return base.Equals(input) && 
                (
                    this.FirstOnline == input.FirstOnline ||
                    (this.FirstOnline != null &&
                    this.FirstOnline.Equals(input.FirstOnline))
                ) && base.Equals(input) && 
                (
                    this.PublisherPublication == input.PublisherPublication ||
                    (this.PublisherPublication != null &&
                    this.PublisherPublication.Equals(input.PublisherPublication))
                ) && base.Equals(input) && 
                (
                    this.PublisherAcceptance == input.PublisherAcceptance ||
                    (this.PublisherAcceptance != null &&
                    this.PublisherAcceptance.Equals(input.PublisherAcceptance))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = base.GetHashCode();
                if (this.FirstOnline != null)
                    hashCode = hashCode * 59 + this.FirstOnline.GetHashCode();
                if (this.PublisherPublication != null)
                    hashCode = hashCode * 59 + this.PublisherPublication.GetHashCode();
                if (this.PublisherAcceptance != null)
                    hashCode = hashCode * 59 + this.PublisherAcceptance.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            foreach(var x in BaseValidate(validationContext)) yield return x;
            yield break;
        }
    }

}
