/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// UploadFilePart
    /// </summary>
    [DataContract]
    public partial class UploadFilePart :  IEquatable<UploadFilePart>, IValidatableObject
    {
        /// <summary>
        /// part status
        /// </summary>
        /// <value>part status</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum StatusEnum
        {
            
            /// <summary>
            /// Enum PENDING for value: PENDING
            /// </summary>
            [EnumMember(Value = "PENDING")]
            PENDING = 1,
            
            /// <summary>
            /// Enum COMPLETE for value: COMPLETE
            /// </summary>
            [EnumMember(Value = "COMPLETE")]
            COMPLETE = 2
        }

        /// <summary>
        /// part status
        /// </summary>
        /// <value>part status</value>
        [DataMember(Name="status", EmitDefaultValue=false)]
        public StatusEnum? Status { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="UploadFilePart" /> class.
        /// </summary>
        /// <param name="partNo">File part id.</param>
        /// <param name="startOffset">Indexes on byte range. zero-based and inclusive.</param>
        /// <param name="endOffset">Indexes on byte range. zero-based and inclusive.</param>
        /// <param name="status">part status.</param>
        /// <param name="locked">When a part is being uploaded it is being locked, by setting the locked flag to true. No changes/uploads can happen on this part from other requests..</param>
        public UploadFilePart(long? partNo = default(long?), long? startOffset = default(long?), long? endOffset = default(long?), StatusEnum? status = default(StatusEnum?), bool? locked = default(bool?))
        {
            this.PartNo = partNo;
            this.StartOffset = startOffset;
            this.EndOffset = endOffset;
            this.Status = status;
            this.Locked = locked;
        }
        
        /// <summary>
        /// File part id
        /// </summary>
        /// <value>File part id</value>
        [DataMember(Name="partNo", EmitDefaultValue=false)]
        public long? PartNo { get; set; }

        /// <summary>
        /// Indexes on byte range. zero-based and inclusive
        /// </summary>
        /// <value>Indexes on byte range. zero-based and inclusive</value>
        [DataMember(Name="startOffset", EmitDefaultValue=false)]
        public long? StartOffset { get; set; }

        /// <summary>
        /// Indexes on byte range. zero-based and inclusive
        /// </summary>
        /// <value>Indexes on byte range. zero-based and inclusive</value>
        [DataMember(Name="endOffset", EmitDefaultValue=false)]
        public long? EndOffset { get; set; }


        /// <summary>
        /// When a part is being uploaded it is being locked, by setting the locked flag to true. No changes/uploads can happen on this part from other requests.
        /// </summary>
        /// <value>When a part is being uploaded it is being locked, by setting the locked flag to true. No changes/uploads can happen on this part from other requests.</value>
        [DataMember(Name="locked", EmitDefaultValue=false)]
        public bool? Locked { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class UploadFilePart {\n");
            sb.Append("  PartNo: ").Append(PartNo).Append("\n");
            sb.Append("  StartOffset: ").Append(StartOffset).Append("\n");
            sb.Append("  EndOffset: ").Append(EndOffset).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("  Locked: ").Append(Locked).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as UploadFilePart);
        }

        /// <summary>
        /// Returns true if UploadFilePart instances are equal
        /// </summary>
        /// <param name="input">Instance of UploadFilePart to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(UploadFilePart input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.PartNo == input.PartNo ||
                    (this.PartNo != null &&
                    this.PartNo.Equals(input.PartNo))
                ) && 
                (
                    this.StartOffset == input.StartOffset ||
                    (this.StartOffset != null &&
                    this.StartOffset.Equals(input.StartOffset))
                ) && 
                (
                    this.EndOffset == input.EndOffset ||
                    (this.EndOffset != null &&
                    this.EndOffset.Equals(input.EndOffset))
                ) && 
                (
                    this.Status == input.Status ||
                    (this.Status != null &&
                    this.Status.Equals(input.Status))
                ) && 
                (
                    this.Locked == input.Locked ||
                    (this.Locked != null &&
                    this.Locked.Equals(input.Locked))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PartNo != null)
                    hashCode = hashCode * 59 + this.PartNo.GetHashCode();
                if (this.StartOffset != null)
                    hashCode = hashCode * 59 + this.StartOffset.GetHashCode();
                if (this.EndOffset != null)
                    hashCode = hashCode * 59 + this.EndOffset.GetHashCode();
                if (this.Status != null)
                    hashCode = hashCode * 59 + this.Status.GetHashCode();
                if (this.Locked != null)
                    hashCode = hashCode * 59 + this.Locked.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
