/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IInstitutionsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Institution Curation Review
        /// </summary>
        /// <remarks>
        /// Retrieve a certain curation review by its ID
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <returns>CurationDetail</returns>
        CurationDetail AccountInstitutionCuration (long? curationId);

        /// <summary>
        /// Institution Curation Review
        /// </summary>
        /// <remarks>
        /// Retrieve a certain curation review by its ID
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <returns>ApiResponse of CurationDetail</returns>
        ApiResponse<CurationDetail> AccountInstitutionCurationWithHttpInfo (long? curationId);
        /// <summary>
        /// Institution Curation Review Comments
        /// </summary>
        /// <remarks>
        /// Retrieve a certain curation review&#39;s comments.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>CurationComment</returns>
        CurationComment AccountInstitutionCurationComments (long? curationId, long? limit = null, long? offset = null);

        /// <summary>
        /// Institution Curation Review Comments
        /// </summary>
        /// <remarks>
        /// Retrieve a certain curation review&#39;s comments.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>ApiResponse of CurationComment</returns>
        ApiResponse<CurationComment> AccountInstitutionCurationCommentsWithHttpInfo (long? curationId, long? limit = null, long? offset = null);
        /// <summary>
        /// POST Institution Curation Review Comment
        /// </summary>
        /// <remarks>
        /// Add a new comment to the review.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="curationComment">The content/value of the comment.</param>
        /// <returns></returns>
        void AccountInstitutionCurationComments_0 (long? curationId, CurationCommentCreate curationComment);

        /// <summary>
        /// POST Institution Curation Review Comment
        /// </summary>
        /// <remarks>
        /// Add a new comment to the review.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="curationComment">The content/value of the comment.</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> AccountInstitutionCurationComments_0WithHttpInfo (long? curationId, CurationCommentCreate curationComment);
        /// <summary>
        /// Institution Curation Reviews
        /// </summary>
        /// <remarks>
        /// Retrieve a list of curation reviews for this institution
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Filter by the group ID (optional)</param>
        /// <param name="articleId">Retrieve the reviews for this article (optional)</param>
        /// <param name="status">Filter by the status of the review (optional)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Curation</returns>
        Curation AccountInstitutionCurations (long? groupId = null, long? articleId = null, string status = null, long? limit = null, long? offset = null);

        /// <summary>
        /// Institution Curation Reviews
        /// </summary>
        /// <remarks>
        /// Retrieve a list of curation reviews for this institution
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Filter by the group ID (optional)</param>
        /// <param name="articleId">Retrieve the reviews for this article (optional)</param>
        /// <param name="status">Filter by the status of the review (optional)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>ApiResponse of Curation</returns>
        ApiResponse<Curation> AccountInstitutionCurationsWithHttpInfo (long? groupId = null, long? articleId = null, string status = null, long? limit = null, long? offset = null);
        /// <summary>
        /// Private account institution group custom fields
        /// </summary>
        /// <remarks>
        /// Returns the custom fields in the group the user belongs to, or the ones in the group specified, if the user has access.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group_id (optional)</param>
        /// <returns>List&lt;ShortCustomField&gt;</returns>
        List<ShortCustomField> CustomFieldsList (long? groupId = null);

        /// <summary>
        /// Private account institution group custom fields
        /// </summary>
        /// <remarks>
        /// Returns the custom fields in the group the user belongs to, or the ones in the group specified, if the user has access.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group_id (optional)</param>
        /// <returns>ApiResponse of List&lt;ShortCustomField&gt;</returns>
        ApiResponse<List<ShortCustomField>> CustomFieldsListWithHttpInfo (long? groupId = null);
        /// <summary>
        /// Custom fields values files upload
        /// </summary>
        /// <remarks>
        /// Uploads a CSV containing values for a specific custom field of type &lt;b&gt;dropdown_large_list&lt;/b&gt;. More details in the &lt;a href&#x3D;\&quot;#custom_fields\&quot;&gt;Custom Fields section&lt;/a&gt;
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="customFieldId">Custom field identifier</param>
        /// <param name="externalFile">CSV file to be uploaded (optional)</param>
        /// <returns>Object</returns>
        Object CustomFieldsUpload (long? customFieldId, System.IO.Stream externalFile = null);

        /// <summary>
        /// Custom fields values files upload
        /// </summary>
        /// <remarks>
        /// Uploads a CSV containing values for a specific custom field of type &lt;b&gt;dropdown_large_list&lt;/b&gt;. More details in the &lt;a href&#x3D;\&quot;#custom_fields\&quot;&gt;Custom Fields section&lt;/a&gt;
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="customFieldId">Custom field identifier</param>
        /// <param name="externalFile">CSV file to be uploaded (optional)</param>
        /// <returns>ApiResponse of Object</returns>
        ApiResponse<Object> CustomFieldsUploadWithHttpInfo (long? customFieldId, System.IO.Stream externalFile = null);
        /// <summary>
        /// Public Institution Articles
        /// </summary>
        /// <remarks>
        /// Returns a list of articles belonging to the institution
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="institutionStringId"></param>
        /// <param name="resourceId"></param>
        /// <param name="filename"></param>
        /// <returns>List&lt;Article&gt;</returns>
        List<Article> InstitutionArticles (string institutionStringId, string resourceId, string filename);

        /// <summary>
        /// Public Institution Articles
        /// </summary>
        /// <remarks>
        /// Returns a list of articles belonging to the institution
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="institutionStringId"></param>
        /// <param name="resourceId"></param>
        /// <param name="filename"></param>
        /// <returns>ApiResponse of List&lt;Article&gt;</returns>
        ApiResponse<List<Article>> InstitutionArticlesWithHttpInfo (string institutionStringId, string resourceId, string filename);
        /// <summary>
        /// Private Institution HRfeed Upload
        /// </summary>
        /// <remarks>
        /// More info in the &lt;a href&#x3D;\&quot;#hr_feed\&quot;&gt;HR Feed section&lt;/a&gt;
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="hrfeed">You can find an example in the Hr Feed section (optional)</param>
        /// <returns>ResponseMessage</returns>
        ResponseMessage InstitutionHrfeedUpload (System.IO.Stream hrfeed = null);

        /// <summary>
        /// Private Institution HRfeed Upload
        /// </summary>
        /// <remarks>
        /// More info in the &lt;a href&#x3D;\&quot;#hr_feed\&quot;&gt;HR Feed section&lt;/a&gt;
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="hrfeed">You can find an example in the Hr Feed section (optional)</param>
        /// <returns>ApiResponse of ResponseMessage</returns>
        ApiResponse<ResponseMessage> InstitutionHrfeedUploadWithHttpInfo (System.IO.Stream hrfeed = null);
        /// <summary>
        /// Private Account Institution User
        /// </summary>
        /// <remarks>
        /// Retrieve institution user information using the account_id
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>User</returns>
        User PrivateAccountInstitutionUser (long? accountId);

        /// <summary>
        /// Private Account Institution User
        /// </summary>
        /// <remarks>
        /// Retrieve institution user information using the account_id
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>ApiResponse of User</returns>
        ApiResponse<User> PrivateAccountInstitutionUserWithHttpInfo (long? accountId);
        /// <summary>
        /// Private Account Categories
        /// </summary>
        /// <remarks>
        /// List institution categories (including parent Categories)
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>List&lt;Category&gt;</returns>
        List<Category> PrivateCategoriesList ();

        /// <summary>
        /// Private Account Categories
        /// </summary>
        /// <remarks>
        /// List institution categories (including parent Categories)
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of List&lt;Category&gt;</returns>
        ApiResponse<List<Category>> PrivateCategoriesListWithHttpInfo ();
        /// <summary>
        /// Private Account Institution Group Embargo Options
        /// </summary>
        /// <remarks>
        /// Account institution group embargo options details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group identifier</param>
        /// <returns>List&lt;GroupEmbargoOptions&gt;</returns>
        List<GroupEmbargoOptions> PrivateGroupEmbargoOptionsDetails (long? groupId);

        /// <summary>
        /// Private Account Institution Group Embargo Options
        /// </summary>
        /// <remarks>
        /// Account institution group embargo options details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group identifier</param>
        /// <returns>ApiResponse of List&lt;GroupEmbargoOptions&gt;</returns>
        ApiResponse<List<GroupEmbargoOptions>> PrivateGroupEmbargoOptionsDetailsWithHttpInfo (long? groupId);
        /// <summary>
        /// Delete Institution Account Group Role
        /// </summary>
        /// <remarks>
        /// Delete Institution Account Group Role
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier for which to remove the role</param>
        /// <param name="groupId">Group identifier for which to remove the role</param>
        /// <param name="roleId">Role identifier</param>
        /// <returns></returns>
        void PrivateInstitutionAccountGroupRoleDelete (long? accountId, long? groupId, long? roleId);

        /// <summary>
        /// Delete Institution Account Group Role
        /// </summary>
        /// <remarks>
        /// Delete Institution Account Group Role
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier for which to remove the role</param>
        /// <param name="groupId">Group identifier for which to remove the role</param>
        /// <param name="roleId">Role identifier</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PrivateInstitutionAccountGroupRoleDeleteWithHttpInfo (long? accountId, long? groupId, long? roleId);
        /// <summary>
        /// List Institution Account Group Roles
        /// </summary>
        /// <remarks>
        /// List Institution Account Group Roles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>AccountGroupRoles</returns>
        AccountGroupRoles PrivateInstitutionAccountGroupRoles (long? accountId);

        /// <summary>
        /// List Institution Account Group Roles
        /// </summary>
        /// <remarks>
        /// List Institution Account Group Roles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>ApiResponse of AccountGroupRoles</returns>
        ApiResponse<AccountGroupRoles> PrivateInstitutionAccountGroupRolesWithHttpInfo (long? accountId);
        /// <summary>
        /// Add Institution Account Group Roles
        /// </summary>
        /// <remarks>
        /// Add Institution Account Group Roles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns></returns>
        void PrivateInstitutionAccountGroupRolesCreate (long? accountId, AccountGroupRolesCreate account);

        /// <summary>
        /// Add Institution Account Group Roles
        /// </summary>
        /// <remarks>
        /// Add Institution Account Group Roles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PrivateInstitutionAccountGroupRolesCreateWithHttpInfo (long? accountId, AccountGroupRolesCreate account);
        /// <summary>
        /// Create new Institution Account
        /// </summary>
        /// <remarks>
        /// Create a new Account by sending account information
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="account">Account description</param>
        /// <returns></returns>
        void PrivateInstitutionAccountsCreate (AccountCreate account);

        /// <summary>
        /// Create new Institution Account
        /// </summary>
        /// <remarks>
        /// Create a new Account by sending account information
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="account">Account description</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PrivateInstitutionAccountsCreateWithHttpInfo (AccountCreate account);
        /// <summary>
        /// Private Account Institution Accounts
        /// </summary>
        /// <remarks>
        /// Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="isActive">Filter by active status (optional)</param>
        /// <param name="institutionUserId">Filter by institution_user_id (optional)</param>
        /// <param name="email">Filter by email (optional)</param>
        /// <param name="idLte">Retrieve accounts with an ID lower or equal to the specified value (optional)</param>
        /// <param name="idGte">Retrieve accounts with an ID greater or equal to the specified value (optional)</param>
        /// <returns>List&lt;ShortAccount&gt;</returns>
        List<ShortAccount> PrivateInstitutionAccountsList (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, long? isActive = null, string institutionUserId = null, string email = null, long? idLte = null, long? idGte = null);

        /// <summary>
        /// Private Account Institution Accounts
        /// </summary>
        /// <remarks>
        /// Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="isActive">Filter by active status (optional)</param>
        /// <param name="institutionUserId">Filter by institution_user_id (optional)</param>
        /// <param name="email">Filter by email (optional)</param>
        /// <param name="idLte">Retrieve accounts with an ID lower or equal to the specified value (optional)</param>
        /// <param name="idGte">Retrieve accounts with an ID greater or equal to the specified value (optional)</param>
        /// <returns>ApiResponse of List&lt;ShortAccount&gt;</returns>
        ApiResponse<List<ShortAccount>> PrivateInstitutionAccountsListWithHttpInfo (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, long? isActive = null, string institutionUserId = null, string email = null, long? idLte = null, long? idGte = null);
        /// <summary>
        /// Private Account Institution Accounts Search
        /// </summary>
        /// <remarks>
        /// Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters</param>
        /// <returns>List&lt;ShortAccount&gt;</returns>
        List<ShortAccount> PrivateInstitutionAccountsSearch (InstitutionAccountsSearch search);

        /// <summary>
        /// Private Account Institution Accounts Search
        /// </summary>
        /// <remarks>
        /// Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters</param>
        /// <returns>ApiResponse of List&lt;ShortAccount&gt;</returns>
        ApiResponse<List<ShortAccount>> PrivateInstitutionAccountsSearchWithHttpInfo (InstitutionAccountsSearch search);
        /// <summary>
        /// Update Institution Account
        /// </summary>
        /// <remarks>
        /// Update Institution Account
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns></returns>
        void PrivateInstitutionAccountsUpdate (long? accountId, AccountUpdate account);

        /// <summary>
        /// Update Institution Account
        /// </summary>
        /// <remarks>
        /// Update Institution Account
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PrivateInstitutionAccountsUpdateWithHttpInfo (long? accountId, AccountUpdate account);
        /// <summary>
        /// Private Institution Articles
        /// </summary>
        /// <remarks>
        /// Get Articles from own institution. User must be administrator of the institution
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="modifiedSince">Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="status">only return collections with this status (optional)</param>
        /// <param name="resourceDoi">only return collections with this resource_doi (optional)</param>
        /// <param name="itemType">Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)</param>
        /// <returns>List&lt;Article&gt;</returns>
        List<Article> PrivateInstitutionArticles (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string publishedSince = null, string modifiedSince = null, long? status = null, string resourceDoi = null, long? itemType = null);

        /// <summary>
        /// Private Institution Articles
        /// </summary>
        /// <remarks>
        /// Get Articles from own institution. User must be administrator of the institution
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="modifiedSince">Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="status">only return collections with this status (optional)</param>
        /// <param name="resourceDoi">only return collections with this resource_doi (optional)</param>
        /// <param name="itemType">Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)</param>
        /// <returns>ApiResponse of List&lt;Article&gt;</returns>
        ApiResponse<List<Article>> PrivateInstitutionArticlesWithHttpInfo (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string publishedSince = null, string modifiedSince = null, long? status = null, string resourceDoi = null, long? itemType = null);
        /// <summary>
        /// Private Account Institutions
        /// </summary>
        /// <remarks>
        /// Account institution details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Institution</returns>
        Institution PrivateInstitutionDetails ();

        /// <summary>
        /// Private Account Institutions
        /// </summary>
        /// <remarks>
        /// Account institution details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of Institution</returns>
        ApiResponse<Institution> PrivateInstitutionDetailsWithHttpInfo ();
        /// <summary>
        /// Private Account Institution embargo options
        /// </summary>
        /// <remarks>
        /// Account institution embargo options details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>List&lt;GroupEmbargoOptions&gt;</returns>
        List<GroupEmbargoOptions> PrivateInstitutionEmbargoOptionsDetails ();

        /// <summary>
        /// Private Account Institution embargo options
        /// </summary>
        /// <remarks>
        /// Account institution embargo options details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of List&lt;GroupEmbargoOptions&gt;</returns>
        ApiResponse<List<GroupEmbargoOptions>> PrivateInstitutionEmbargoOptionsDetailsWithHttpInfo ();
        /// <summary>
        /// Private Account Institution Groups
        /// </summary>
        /// <remarks>
        /// Returns the groups for which the account has administrative privileges (assigned and inherited).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>List&lt;Group&gt;</returns>
        List<Group> PrivateInstitutionGroupsList ();

        /// <summary>
        /// Private Account Institution Groups
        /// </summary>
        /// <remarks>
        /// Returns the groups for which the account has administrative privileges (assigned and inherited).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of List&lt;Group&gt;</returns>
        ApiResponse<List<Group>> PrivateInstitutionGroupsListWithHttpInfo ();
        /// <summary>
        /// Private Account Institution Roles
        /// </summary>
        /// <remarks>
        /// Returns the roles available for groups and the institution group.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>List&lt;Role&gt;</returns>
        List<Role> PrivateInstitutionRolesList ();

        /// <summary>
        /// Private Account Institution Roles
        /// </summary>
        /// <remarks>
        /// Returns the roles available for groups and the institution group.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of List&lt;Role&gt;</returns>
        ApiResponse<List<Role>> PrivateInstitutionRolesListWithHttpInfo ();
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Institution Curation Review
        /// </summary>
        /// <remarks>
        /// Retrieve a certain curation review by its ID
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <returns>Task of CurationDetail</returns>
        System.Threading.Tasks.Task<CurationDetail> AccountInstitutionCurationAsync (long? curationId);

        /// <summary>
        /// Institution Curation Review
        /// </summary>
        /// <remarks>
        /// Retrieve a certain curation review by its ID
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <returns>Task of ApiResponse (CurationDetail)</returns>
        System.Threading.Tasks.Task<ApiResponse<CurationDetail>> AccountInstitutionCurationAsyncWithHttpInfo (long? curationId);
        /// <summary>
        /// Institution Curation Review Comments
        /// </summary>
        /// <remarks>
        /// Retrieve a certain curation review&#39;s comments.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of CurationComment</returns>
        System.Threading.Tasks.Task<CurationComment> AccountInstitutionCurationCommentsAsync (long? curationId, long? limit = null, long? offset = null);

        /// <summary>
        /// Institution Curation Review Comments
        /// </summary>
        /// <remarks>
        /// Retrieve a certain curation review&#39;s comments.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of ApiResponse (CurationComment)</returns>
        System.Threading.Tasks.Task<ApiResponse<CurationComment>> AccountInstitutionCurationCommentsAsyncWithHttpInfo (long? curationId, long? limit = null, long? offset = null);
        /// <summary>
        /// POST Institution Curation Review Comment
        /// </summary>
        /// <remarks>
        /// Add a new comment to the review.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="curationComment">The content/value of the comment.</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task AccountInstitutionCurationComments_0Async (long? curationId, CurationCommentCreate curationComment);

        /// <summary>
        /// POST Institution Curation Review Comment
        /// </summary>
        /// <remarks>
        /// Add a new comment to the review.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="curationComment">The content/value of the comment.</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> AccountInstitutionCurationComments_0AsyncWithHttpInfo (long? curationId, CurationCommentCreate curationComment);
        /// <summary>
        /// Institution Curation Reviews
        /// </summary>
        /// <remarks>
        /// Retrieve a list of curation reviews for this institution
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Filter by the group ID (optional)</param>
        /// <param name="articleId">Retrieve the reviews for this article (optional)</param>
        /// <param name="status">Filter by the status of the review (optional)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of Curation</returns>
        System.Threading.Tasks.Task<Curation> AccountInstitutionCurationsAsync (long? groupId = null, long? articleId = null, string status = null, long? limit = null, long? offset = null);

        /// <summary>
        /// Institution Curation Reviews
        /// </summary>
        /// <remarks>
        /// Retrieve a list of curation reviews for this institution
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Filter by the group ID (optional)</param>
        /// <param name="articleId">Retrieve the reviews for this article (optional)</param>
        /// <param name="status">Filter by the status of the review (optional)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of ApiResponse (Curation)</returns>
        System.Threading.Tasks.Task<ApiResponse<Curation>> AccountInstitutionCurationsAsyncWithHttpInfo (long? groupId = null, long? articleId = null, string status = null, long? limit = null, long? offset = null);
        /// <summary>
        /// Private account institution group custom fields
        /// </summary>
        /// <remarks>
        /// Returns the custom fields in the group the user belongs to, or the ones in the group specified, if the user has access.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group_id (optional)</param>
        /// <returns>Task of List&lt;ShortCustomField&gt;</returns>
        System.Threading.Tasks.Task<List<ShortCustomField>> CustomFieldsListAsync (long? groupId = null);

        /// <summary>
        /// Private account institution group custom fields
        /// </summary>
        /// <remarks>
        /// Returns the custom fields in the group the user belongs to, or the ones in the group specified, if the user has access.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group_id (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ShortCustomField&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<ShortCustomField>>> CustomFieldsListAsyncWithHttpInfo (long? groupId = null);
        /// <summary>
        /// Custom fields values files upload
        /// </summary>
        /// <remarks>
        /// Uploads a CSV containing values for a specific custom field of type &lt;b&gt;dropdown_large_list&lt;/b&gt;. More details in the &lt;a href&#x3D;\&quot;#custom_fields\&quot;&gt;Custom Fields section&lt;/a&gt;
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="customFieldId">Custom field identifier</param>
        /// <param name="externalFile">CSV file to be uploaded (optional)</param>
        /// <returns>Task of Object</returns>
        System.Threading.Tasks.Task<Object> CustomFieldsUploadAsync (long? customFieldId, System.IO.Stream externalFile = null);

        /// <summary>
        /// Custom fields values files upload
        /// </summary>
        /// <remarks>
        /// Uploads a CSV containing values for a specific custom field of type &lt;b&gt;dropdown_large_list&lt;/b&gt;. More details in the &lt;a href&#x3D;\&quot;#custom_fields\&quot;&gt;Custom Fields section&lt;/a&gt;
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="customFieldId">Custom field identifier</param>
        /// <param name="externalFile">CSV file to be uploaded (optional)</param>
        /// <returns>Task of ApiResponse (Object)</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> CustomFieldsUploadAsyncWithHttpInfo (long? customFieldId, System.IO.Stream externalFile = null);
        /// <summary>
        /// Public Institution Articles
        /// </summary>
        /// <remarks>
        /// Returns a list of articles belonging to the institution
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="institutionStringId"></param>
        /// <param name="resourceId"></param>
        /// <param name="filename"></param>
        /// <returns>Task of List&lt;Article&gt;</returns>
        System.Threading.Tasks.Task<List<Article>> InstitutionArticlesAsync (string institutionStringId, string resourceId, string filename);

        /// <summary>
        /// Public Institution Articles
        /// </summary>
        /// <remarks>
        /// Returns a list of articles belonging to the institution
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="institutionStringId"></param>
        /// <param name="resourceId"></param>
        /// <param name="filename"></param>
        /// <returns>Task of ApiResponse (List&lt;Article&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Article>>> InstitutionArticlesAsyncWithHttpInfo (string institutionStringId, string resourceId, string filename);
        /// <summary>
        /// Private Institution HRfeed Upload
        /// </summary>
        /// <remarks>
        /// More info in the &lt;a href&#x3D;\&quot;#hr_feed\&quot;&gt;HR Feed section&lt;/a&gt;
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="hrfeed">You can find an example in the Hr Feed section (optional)</param>
        /// <returns>Task of ResponseMessage</returns>
        System.Threading.Tasks.Task<ResponseMessage> InstitutionHrfeedUploadAsync (System.IO.Stream hrfeed = null);

        /// <summary>
        /// Private Institution HRfeed Upload
        /// </summary>
        /// <remarks>
        /// More info in the &lt;a href&#x3D;\&quot;#hr_feed\&quot;&gt;HR Feed section&lt;/a&gt;
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="hrfeed">You can find an example in the Hr Feed section (optional)</param>
        /// <returns>Task of ApiResponse (ResponseMessage)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseMessage>> InstitutionHrfeedUploadAsyncWithHttpInfo (System.IO.Stream hrfeed = null);
        /// <summary>
        /// Private Account Institution User
        /// </summary>
        /// <remarks>
        /// Retrieve institution user information using the account_id
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>Task of User</returns>
        System.Threading.Tasks.Task<User> PrivateAccountInstitutionUserAsync (long? accountId);

        /// <summary>
        /// Private Account Institution User
        /// </summary>
        /// <remarks>
        /// Retrieve institution user information using the account_id
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>Task of ApiResponse (User)</returns>
        System.Threading.Tasks.Task<ApiResponse<User>> PrivateAccountInstitutionUserAsyncWithHttpInfo (long? accountId);
        /// <summary>
        /// Private Account Categories
        /// </summary>
        /// <remarks>
        /// List institution categories (including parent Categories)
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of List&lt;Category&gt;</returns>
        System.Threading.Tasks.Task<List<Category>> PrivateCategoriesListAsync ();

        /// <summary>
        /// Private Account Categories
        /// </summary>
        /// <remarks>
        /// List institution categories (including parent Categories)
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (List&lt;Category&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Category>>> PrivateCategoriesListAsyncWithHttpInfo ();
        /// <summary>
        /// Private Account Institution Group Embargo Options
        /// </summary>
        /// <remarks>
        /// Account institution group embargo options details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group identifier</param>
        /// <returns>Task of List&lt;GroupEmbargoOptions&gt;</returns>
        System.Threading.Tasks.Task<List<GroupEmbargoOptions>> PrivateGroupEmbargoOptionsDetailsAsync (long? groupId);

        /// <summary>
        /// Private Account Institution Group Embargo Options
        /// </summary>
        /// <remarks>
        /// Account institution group embargo options details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group identifier</param>
        /// <returns>Task of ApiResponse (List&lt;GroupEmbargoOptions&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<GroupEmbargoOptions>>> PrivateGroupEmbargoOptionsDetailsAsyncWithHttpInfo (long? groupId);
        /// <summary>
        /// Delete Institution Account Group Role
        /// </summary>
        /// <remarks>
        /// Delete Institution Account Group Role
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier for which to remove the role</param>
        /// <param name="groupId">Group identifier for which to remove the role</param>
        /// <param name="roleId">Role identifier</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PrivateInstitutionAccountGroupRoleDeleteAsync (long? accountId, long? groupId, long? roleId);

        /// <summary>
        /// Delete Institution Account Group Role
        /// </summary>
        /// <remarks>
        /// Delete Institution Account Group Role
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier for which to remove the role</param>
        /// <param name="groupId">Group identifier for which to remove the role</param>
        /// <param name="roleId">Role identifier</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PrivateInstitutionAccountGroupRoleDeleteAsyncWithHttpInfo (long? accountId, long? groupId, long? roleId);
        /// <summary>
        /// List Institution Account Group Roles
        /// </summary>
        /// <remarks>
        /// List Institution Account Group Roles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>Task of AccountGroupRoles</returns>
        System.Threading.Tasks.Task<AccountGroupRoles> PrivateInstitutionAccountGroupRolesAsync (long? accountId);

        /// <summary>
        /// List Institution Account Group Roles
        /// </summary>
        /// <remarks>
        /// List Institution Account Group Roles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>Task of ApiResponse (AccountGroupRoles)</returns>
        System.Threading.Tasks.Task<ApiResponse<AccountGroupRoles>> PrivateInstitutionAccountGroupRolesAsyncWithHttpInfo (long? accountId);
        /// <summary>
        /// Add Institution Account Group Roles
        /// </summary>
        /// <remarks>
        /// Add Institution Account Group Roles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PrivateInstitutionAccountGroupRolesCreateAsync (long? accountId, AccountGroupRolesCreate account);

        /// <summary>
        /// Add Institution Account Group Roles
        /// </summary>
        /// <remarks>
        /// Add Institution Account Group Roles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PrivateInstitutionAccountGroupRolesCreateAsyncWithHttpInfo (long? accountId, AccountGroupRolesCreate account);
        /// <summary>
        /// Create new Institution Account
        /// </summary>
        /// <remarks>
        /// Create a new Account by sending account information
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="account">Account description</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PrivateInstitutionAccountsCreateAsync (AccountCreate account);

        /// <summary>
        /// Create new Institution Account
        /// </summary>
        /// <remarks>
        /// Create a new Account by sending account information
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="account">Account description</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PrivateInstitutionAccountsCreateAsyncWithHttpInfo (AccountCreate account);
        /// <summary>
        /// Private Account Institution Accounts
        /// </summary>
        /// <remarks>
        /// Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="isActive">Filter by active status (optional)</param>
        /// <param name="institutionUserId">Filter by institution_user_id (optional)</param>
        /// <param name="email">Filter by email (optional)</param>
        /// <param name="idLte">Retrieve accounts with an ID lower or equal to the specified value (optional)</param>
        /// <param name="idGte">Retrieve accounts with an ID greater or equal to the specified value (optional)</param>
        /// <returns>Task of List&lt;ShortAccount&gt;</returns>
        System.Threading.Tasks.Task<List<ShortAccount>> PrivateInstitutionAccountsListAsync (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, long? isActive = null, string institutionUserId = null, string email = null, long? idLte = null, long? idGte = null);

        /// <summary>
        /// Private Account Institution Accounts
        /// </summary>
        /// <remarks>
        /// Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="isActive">Filter by active status (optional)</param>
        /// <param name="institutionUserId">Filter by institution_user_id (optional)</param>
        /// <param name="email">Filter by email (optional)</param>
        /// <param name="idLte">Retrieve accounts with an ID lower or equal to the specified value (optional)</param>
        /// <param name="idGte">Retrieve accounts with an ID greater or equal to the specified value (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ShortAccount&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<ShortAccount>>> PrivateInstitutionAccountsListAsyncWithHttpInfo (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, long? isActive = null, string institutionUserId = null, string email = null, long? idLte = null, long? idGte = null);
        /// <summary>
        /// Private Account Institution Accounts Search
        /// </summary>
        /// <remarks>
        /// Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters</param>
        /// <returns>Task of List&lt;ShortAccount&gt;</returns>
        System.Threading.Tasks.Task<List<ShortAccount>> PrivateInstitutionAccountsSearchAsync (InstitutionAccountsSearch search);

        /// <summary>
        /// Private Account Institution Accounts Search
        /// </summary>
        /// <remarks>
        /// Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters</param>
        /// <returns>Task of ApiResponse (List&lt;ShortAccount&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<ShortAccount>>> PrivateInstitutionAccountsSearchAsyncWithHttpInfo (InstitutionAccountsSearch search);
        /// <summary>
        /// Update Institution Account
        /// </summary>
        /// <remarks>
        /// Update Institution Account
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PrivateInstitutionAccountsUpdateAsync (long? accountId, AccountUpdate account);

        /// <summary>
        /// Update Institution Account
        /// </summary>
        /// <remarks>
        /// Update Institution Account
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PrivateInstitutionAccountsUpdateAsyncWithHttpInfo (long? accountId, AccountUpdate account);
        /// <summary>
        /// Private Institution Articles
        /// </summary>
        /// <remarks>
        /// Get Articles from own institution. User must be administrator of the institution
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="modifiedSince">Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="status">only return collections with this status (optional)</param>
        /// <param name="resourceDoi">only return collections with this resource_doi (optional)</param>
        /// <param name="itemType">Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)</param>
        /// <returns>Task of List&lt;Article&gt;</returns>
        System.Threading.Tasks.Task<List<Article>> PrivateInstitutionArticlesAsync (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string publishedSince = null, string modifiedSince = null, long? status = null, string resourceDoi = null, long? itemType = null);

        /// <summary>
        /// Private Institution Articles
        /// </summary>
        /// <remarks>
        /// Get Articles from own institution. User must be administrator of the institution
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="modifiedSince">Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="status">only return collections with this status (optional)</param>
        /// <param name="resourceDoi">only return collections with this resource_doi (optional)</param>
        /// <param name="itemType">Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Article&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Article>>> PrivateInstitutionArticlesAsyncWithHttpInfo (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string publishedSince = null, string modifiedSince = null, long? status = null, string resourceDoi = null, long? itemType = null);
        /// <summary>
        /// Private Account Institutions
        /// </summary>
        /// <remarks>
        /// Account institution details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of Institution</returns>
        System.Threading.Tasks.Task<Institution> PrivateInstitutionDetailsAsync ();

        /// <summary>
        /// Private Account Institutions
        /// </summary>
        /// <remarks>
        /// Account institution details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (Institution)</returns>
        System.Threading.Tasks.Task<ApiResponse<Institution>> PrivateInstitutionDetailsAsyncWithHttpInfo ();
        /// <summary>
        /// Private Account Institution embargo options
        /// </summary>
        /// <remarks>
        /// Account institution embargo options details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of List&lt;GroupEmbargoOptions&gt;</returns>
        System.Threading.Tasks.Task<List<GroupEmbargoOptions>> PrivateInstitutionEmbargoOptionsDetailsAsync ();

        /// <summary>
        /// Private Account Institution embargo options
        /// </summary>
        /// <remarks>
        /// Account institution embargo options details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (List&lt;GroupEmbargoOptions&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<GroupEmbargoOptions>>> PrivateInstitutionEmbargoOptionsDetailsAsyncWithHttpInfo ();
        /// <summary>
        /// Private Account Institution Groups
        /// </summary>
        /// <remarks>
        /// Returns the groups for which the account has administrative privileges (assigned and inherited).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of List&lt;Group&gt;</returns>
        System.Threading.Tasks.Task<List<Group>> PrivateInstitutionGroupsListAsync ();

        /// <summary>
        /// Private Account Institution Groups
        /// </summary>
        /// <remarks>
        /// Returns the groups for which the account has administrative privileges (assigned and inherited).
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (List&lt;Group&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Group>>> PrivateInstitutionGroupsListAsyncWithHttpInfo ();
        /// <summary>
        /// Private Account Institution Roles
        /// </summary>
        /// <remarks>
        /// Returns the roles available for groups and the institution group.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of List&lt;Role&gt;</returns>
        System.Threading.Tasks.Task<List<Role>> PrivateInstitutionRolesListAsync ();

        /// <summary>
        /// Private Account Institution Roles
        /// </summary>
        /// <remarks>
        /// Returns the roles available for groups and the institution group.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (List&lt;Role&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Role>>> PrivateInstitutionRolesListAsyncWithHttpInfo ();
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class InstitutionsApi : IInstitutionsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="InstitutionsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public InstitutionsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="InstitutionsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public InstitutionsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Institution Curation Review Retrieve a certain curation review by its ID
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <returns>CurationDetail</returns>
        public CurationDetail AccountInstitutionCuration (long? curationId)
        {
             ApiResponse<CurationDetail> localVarResponse = AccountInstitutionCurationWithHttpInfo(curationId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Institution Curation Review Retrieve a certain curation review by its ID
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <returns>ApiResponse of CurationDetail</returns>
        public ApiResponse< CurationDetail > AccountInstitutionCurationWithHttpInfo (long? curationId)
        {
            // verify the required parameter 'curationId' is set
            if (curationId == null)
                throw new ApiException(400, "Missing required parameter 'curationId' when calling InstitutionsApi->AccountInstitutionCuration");

            var localVarPath = "/account/institution/review/{curation_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (curationId != null) localVarPathParams.Add("curation_id", this.Configuration.ApiClient.ParameterToString(curationId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountInstitutionCuration", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CurationDetail>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (CurationDetail) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CurationDetail)));
        }

        /// <summary>
        /// Institution Curation Review Retrieve a certain curation review by its ID
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <returns>Task of CurationDetail</returns>
        public async System.Threading.Tasks.Task<CurationDetail> AccountInstitutionCurationAsync (long? curationId)
        {
             ApiResponse<CurationDetail> localVarResponse = await AccountInstitutionCurationAsyncWithHttpInfo(curationId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Institution Curation Review Retrieve a certain curation review by its ID
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <returns>Task of ApiResponse (CurationDetail)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<CurationDetail>> AccountInstitutionCurationAsyncWithHttpInfo (long? curationId)
        {
            // verify the required parameter 'curationId' is set
            if (curationId == null)
                throw new ApiException(400, "Missing required parameter 'curationId' when calling InstitutionsApi->AccountInstitutionCuration");

            var localVarPath = "/account/institution/review/{curation_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (curationId != null) localVarPathParams.Add("curation_id", this.Configuration.ApiClient.ParameterToString(curationId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountInstitutionCuration", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CurationDetail>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (CurationDetail) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CurationDetail)));
        }

        /// <summary>
        /// Institution Curation Review Comments Retrieve a certain curation review&#39;s comments.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>CurationComment</returns>
        public CurationComment AccountInstitutionCurationComments (long? curationId, long? limit = null, long? offset = null)
        {
             ApiResponse<CurationComment> localVarResponse = AccountInstitutionCurationCommentsWithHttpInfo(curationId, limit, offset);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Institution Curation Review Comments Retrieve a certain curation review&#39;s comments.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>ApiResponse of CurationComment</returns>
        public ApiResponse< CurationComment > AccountInstitutionCurationCommentsWithHttpInfo (long? curationId, long? limit = null, long? offset = null)
        {
            // verify the required parameter 'curationId' is set
            if (curationId == null)
                throw new ApiException(400, "Missing required parameter 'curationId' when calling InstitutionsApi->AccountInstitutionCurationComments");

            var localVarPath = "/account/institution/review/{curation_id}/comments";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (curationId != null) localVarPathParams.Add("curation_id", this.Configuration.ApiClient.ParameterToString(curationId)); // path parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountInstitutionCurationComments", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CurationComment>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (CurationComment) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CurationComment)));
        }

        /// <summary>
        /// Institution Curation Review Comments Retrieve a certain curation review&#39;s comments.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of CurationComment</returns>
        public async System.Threading.Tasks.Task<CurationComment> AccountInstitutionCurationCommentsAsync (long? curationId, long? limit = null, long? offset = null)
        {
             ApiResponse<CurationComment> localVarResponse = await AccountInstitutionCurationCommentsAsyncWithHttpInfo(curationId, limit, offset);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Institution Curation Review Comments Retrieve a certain curation review&#39;s comments.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of ApiResponse (CurationComment)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<CurationComment>> AccountInstitutionCurationCommentsAsyncWithHttpInfo (long? curationId, long? limit = null, long? offset = null)
        {
            // verify the required parameter 'curationId' is set
            if (curationId == null)
                throw new ApiException(400, "Missing required parameter 'curationId' when calling InstitutionsApi->AccountInstitutionCurationComments");

            var localVarPath = "/account/institution/review/{curation_id}/comments";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (curationId != null) localVarPathParams.Add("curation_id", this.Configuration.ApiClient.ParameterToString(curationId)); // path parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountInstitutionCurationComments", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CurationComment>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (CurationComment) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CurationComment)));
        }

        /// <summary>
        /// POST Institution Curation Review Comment Add a new comment to the review.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="curationComment">The content/value of the comment.</param>
        /// <returns></returns>
        public void AccountInstitutionCurationComments_0 (long? curationId, CurationCommentCreate curationComment)
        {
             AccountInstitutionCurationComments_0WithHttpInfo(curationId, curationComment);
        }

        /// <summary>
        /// POST Institution Curation Review Comment Add a new comment to the review.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="curationComment">The content/value of the comment.</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> AccountInstitutionCurationComments_0WithHttpInfo (long? curationId, CurationCommentCreate curationComment)
        {
            // verify the required parameter 'curationId' is set
            if (curationId == null)
                throw new ApiException(400, "Missing required parameter 'curationId' when calling InstitutionsApi->AccountInstitutionCurationComments_0");
            // verify the required parameter 'curationComment' is set
            if (curationComment == null)
                throw new ApiException(400, "Missing required parameter 'curationComment' when calling InstitutionsApi->AccountInstitutionCurationComments_0");

            var localVarPath = "/account/institution/review/{curation_id}/comments";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (curationId != null) localVarPathParams.Add("curation_id", this.Configuration.ApiClient.ParameterToString(curationId)); // path parameter
            if (curationComment != null && curationComment.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(curationComment); // http body (model) parameter
            }
            else
            {
                localVarPostBody = curationComment; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountInstitutionCurationComments_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// POST Institution Curation Review Comment Add a new comment to the review.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="curationComment">The content/value of the comment.</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task AccountInstitutionCurationComments_0Async (long? curationId, CurationCommentCreate curationComment)
        {
             await AccountInstitutionCurationComments_0AsyncWithHttpInfo(curationId, curationComment);

        }

        /// <summary>
        /// POST Institution Curation Review Comment Add a new comment to the review.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="curationId">ID of the curation</param>
        /// <param name="curationComment">The content/value of the comment.</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> AccountInstitutionCurationComments_0AsyncWithHttpInfo (long? curationId, CurationCommentCreate curationComment)
        {
            // verify the required parameter 'curationId' is set
            if (curationId == null)
                throw new ApiException(400, "Missing required parameter 'curationId' when calling InstitutionsApi->AccountInstitutionCurationComments_0");
            // verify the required parameter 'curationComment' is set
            if (curationComment == null)
                throw new ApiException(400, "Missing required parameter 'curationComment' when calling InstitutionsApi->AccountInstitutionCurationComments_0");

            var localVarPath = "/account/institution/review/{curation_id}/comments";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (curationId != null) localVarPathParams.Add("curation_id", this.Configuration.ApiClient.ParameterToString(curationId)); // path parameter
            if (curationComment != null && curationComment.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(curationComment); // http body (model) parameter
            }
            else
            {
                localVarPostBody = curationComment; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountInstitutionCurationComments_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Institution Curation Reviews Retrieve a list of curation reviews for this institution
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Filter by the group ID (optional)</param>
        /// <param name="articleId">Retrieve the reviews for this article (optional)</param>
        /// <param name="status">Filter by the status of the review (optional)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Curation</returns>
        public Curation AccountInstitutionCurations (long? groupId = null, long? articleId = null, string status = null, long? limit = null, long? offset = null)
        {
             ApiResponse<Curation> localVarResponse = AccountInstitutionCurationsWithHttpInfo(groupId, articleId, status, limit, offset);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Institution Curation Reviews Retrieve a list of curation reviews for this institution
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Filter by the group ID (optional)</param>
        /// <param name="articleId">Retrieve the reviews for this article (optional)</param>
        /// <param name="status">Filter by the status of the review (optional)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>ApiResponse of Curation</returns>
        public ApiResponse< Curation > AccountInstitutionCurationsWithHttpInfo (long? groupId = null, long? articleId = null, string status = null, long? limit = null, long? offset = null)
        {

            var localVarPath = "/account/institution/reviews";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "group_id", groupId)); // query parameter
            if (articleId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "article_id", articleId)); // query parameter
            if (status != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "status", status)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountInstitutionCurations", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Curation>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Curation) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Curation)));
        }

        /// <summary>
        /// Institution Curation Reviews Retrieve a list of curation reviews for this institution
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Filter by the group ID (optional)</param>
        /// <param name="articleId">Retrieve the reviews for this article (optional)</param>
        /// <param name="status">Filter by the status of the review (optional)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of Curation</returns>
        public async System.Threading.Tasks.Task<Curation> AccountInstitutionCurationsAsync (long? groupId = null, long? articleId = null, string status = null, long? limit = null, long? offset = null)
        {
             ApiResponse<Curation> localVarResponse = await AccountInstitutionCurationsAsyncWithHttpInfo(groupId, articleId, status, limit, offset);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Institution Curation Reviews Retrieve a list of curation reviews for this institution
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Filter by the group ID (optional)</param>
        /// <param name="articleId">Retrieve the reviews for this article (optional)</param>
        /// <param name="status">Filter by the status of the review (optional)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of ApiResponse (Curation)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Curation>> AccountInstitutionCurationsAsyncWithHttpInfo (long? groupId = null, long? articleId = null, string status = null, long? limit = null, long? offset = null)
        {

            var localVarPath = "/account/institution/reviews";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "group_id", groupId)); // query parameter
            if (articleId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "article_id", articleId)); // query parameter
            if (status != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "status", status)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountInstitutionCurations", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Curation>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Curation) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Curation)));
        }

        /// <summary>
        /// Private account institution group custom fields Returns the custom fields in the group the user belongs to, or the ones in the group specified, if the user has access.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group_id (optional)</param>
        /// <returns>List&lt;ShortCustomField&gt;</returns>
        public List<ShortCustomField> CustomFieldsList (long? groupId = null)
        {
             ApiResponse<List<ShortCustomField>> localVarResponse = CustomFieldsListWithHttpInfo(groupId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private account institution group custom fields Returns the custom fields in the group the user belongs to, or the ones in the group specified, if the user has access.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group_id (optional)</param>
        /// <returns>ApiResponse of List&lt;ShortCustomField&gt;</returns>
        public ApiResponse< List<ShortCustomField> > CustomFieldsListWithHttpInfo (long? groupId = null)
        {

            var localVarPath = "/account/institution/custom_fields";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "group_id", groupId)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CustomFieldsList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ShortCustomField>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ShortCustomField>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ShortCustomField>)));
        }

        /// <summary>
        /// Private account institution group custom fields Returns the custom fields in the group the user belongs to, or the ones in the group specified, if the user has access.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group_id (optional)</param>
        /// <returns>Task of List&lt;ShortCustomField&gt;</returns>
        public async System.Threading.Tasks.Task<List<ShortCustomField>> CustomFieldsListAsync (long? groupId = null)
        {
             ApiResponse<List<ShortCustomField>> localVarResponse = await CustomFieldsListAsyncWithHttpInfo(groupId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private account institution group custom fields Returns the custom fields in the group the user belongs to, or the ones in the group specified, if the user has access.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group_id (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ShortCustomField&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<ShortCustomField>>> CustomFieldsListAsyncWithHttpInfo (long? groupId = null)
        {

            var localVarPath = "/account/institution/custom_fields";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "group_id", groupId)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CustomFieldsList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ShortCustomField>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ShortCustomField>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ShortCustomField>)));
        }

        /// <summary>
        /// Custom fields values files upload Uploads a CSV containing values for a specific custom field of type &lt;b&gt;dropdown_large_list&lt;/b&gt;. More details in the &lt;a href&#x3D;\&quot;#custom_fields\&quot;&gt;Custom Fields section&lt;/a&gt;
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="customFieldId">Custom field identifier</param>
        /// <param name="externalFile">CSV file to be uploaded (optional)</param>
        /// <returns>Object</returns>
        public Object CustomFieldsUpload (long? customFieldId, System.IO.Stream externalFile = null)
        {
             ApiResponse<Object> localVarResponse = CustomFieldsUploadWithHttpInfo(customFieldId, externalFile);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Custom fields values files upload Uploads a CSV containing values for a specific custom field of type &lt;b&gt;dropdown_large_list&lt;/b&gt;. More details in the &lt;a href&#x3D;\&quot;#custom_fields\&quot;&gt;Custom Fields section&lt;/a&gt;
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="customFieldId">Custom field identifier</param>
        /// <param name="externalFile">CSV file to be uploaded (optional)</param>
        /// <returns>ApiResponse of Object</returns>
        public ApiResponse< Object > CustomFieldsUploadWithHttpInfo (long? customFieldId, System.IO.Stream externalFile = null)
        {
            // verify the required parameter 'customFieldId' is set
            if (customFieldId == null)
                throw new ApiException(400, "Missing required parameter 'customFieldId' when calling InstitutionsApi->CustomFieldsUpload");

            var localVarPath = "/account/institution/custom_fields/{custom_field_id}/items/upload";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "multipart/form-data"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (customFieldId != null) localVarPathParams.Add("custom_field_id", this.Configuration.ApiClient.ParameterToString(customFieldId)); // path parameter
            if (externalFile != null) localVarFileParams.Add("external_file", this.Configuration.ApiClient.ParameterToFile("external_file", externalFile));

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CustomFieldsUpload", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Object) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Object)));
        }

        /// <summary>
        /// Custom fields values files upload Uploads a CSV containing values for a specific custom field of type &lt;b&gt;dropdown_large_list&lt;/b&gt;. More details in the &lt;a href&#x3D;\&quot;#custom_fields\&quot;&gt;Custom Fields section&lt;/a&gt;
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="customFieldId">Custom field identifier</param>
        /// <param name="externalFile">CSV file to be uploaded (optional)</param>
        /// <returns>Task of Object</returns>
        public async System.Threading.Tasks.Task<Object> CustomFieldsUploadAsync (long? customFieldId, System.IO.Stream externalFile = null)
        {
             ApiResponse<Object> localVarResponse = await CustomFieldsUploadAsyncWithHttpInfo(customFieldId, externalFile);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Custom fields values files upload Uploads a CSV containing values for a specific custom field of type &lt;b&gt;dropdown_large_list&lt;/b&gt;. More details in the &lt;a href&#x3D;\&quot;#custom_fields\&quot;&gt;Custom Fields section&lt;/a&gt;
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="customFieldId">Custom field identifier</param>
        /// <param name="externalFile">CSV file to be uploaded (optional)</param>
        /// <returns>Task of ApiResponse (Object)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> CustomFieldsUploadAsyncWithHttpInfo (long? customFieldId, System.IO.Stream externalFile = null)
        {
            // verify the required parameter 'customFieldId' is set
            if (customFieldId == null)
                throw new ApiException(400, "Missing required parameter 'customFieldId' when calling InstitutionsApi->CustomFieldsUpload");

            var localVarPath = "/account/institution/custom_fields/{custom_field_id}/items/upload";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "multipart/form-data"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (customFieldId != null) localVarPathParams.Add("custom_field_id", this.Configuration.ApiClient.ParameterToString(customFieldId)); // path parameter
            if (externalFile != null) localVarFileParams.Add("external_file", this.Configuration.ApiClient.ParameterToFile("external_file", externalFile));

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CustomFieldsUpload", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Object) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Object)));
        }

        /// <summary>
        /// Public Institution Articles Returns a list of articles belonging to the institution
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="institutionStringId"></param>
        /// <param name="resourceId"></param>
        /// <param name="filename"></param>
        /// <returns>List&lt;Article&gt;</returns>
        public List<Article> InstitutionArticles (string institutionStringId, string resourceId, string filename)
        {
             ApiResponse<List<Article>> localVarResponse = InstitutionArticlesWithHttpInfo(institutionStringId, resourceId, filename);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Public Institution Articles Returns a list of articles belonging to the institution
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="institutionStringId"></param>
        /// <param name="resourceId"></param>
        /// <param name="filename"></param>
        /// <returns>ApiResponse of List&lt;Article&gt;</returns>
        public ApiResponse< List<Article> > InstitutionArticlesWithHttpInfo (string institutionStringId, string resourceId, string filename)
        {
            // verify the required parameter 'institutionStringId' is set
            if (institutionStringId == null)
                throw new ApiException(400, "Missing required parameter 'institutionStringId' when calling InstitutionsApi->InstitutionArticles");
            // verify the required parameter 'resourceId' is set
            if (resourceId == null)
                throw new ApiException(400, "Missing required parameter 'resourceId' when calling InstitutionsApi->InstitutionArticles");
            // verify the required parameter 'filename' is set
            if (filename == null)
                throw new ApiException(400, "Missing required parameter 'filename' when calling InstitutionsApi->InstitutionArticles");

            var localVarPath = "/institutions/{institution_string_id}/articles/filter-by";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (institutionStringId != null) localVarPathParams.Add("institution_string_id", this.Configuration.ApiClient.ParameterToString(institutionStringId)); // path parameter
            if (resourceId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "resource_id", resourceId)); // query parameter
            if (filename != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "filename", filename)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InstitutionArticles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Article>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Article>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Article>)));
        }

        /// <summary>
        /// Public Institution Articles Returns a list of articles belonging to the institution
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="institutionStringId"></param>
        /// <param name="resourceId"></param>
        /// <param name="filename"></param>
        /// <returns>Task of List&lt;Article&gt;</returns>
        public async System.Threading.Tasks.Task<List<Article>> InstitutionArticlesAsync (string institutionStringId, string resourceId, string filename)
        {
             ApiResponse<List<Article>> localVarResponse = await InstitutionArticlesAsyncWithHttpInfo(institutionStringId, resourceId, filename);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Public Institution Articles Returns a list of articles belonging to the institution
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="institutionStringId"></param>
        /// <param name="resourceId"></param>
        /// <param name="filename"></param>
        /// <returns>Task of ApiResponse (List&lt;Article&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Article>>> InstitutionArticlesAsyncWithHttpInfo (string institutionStringId, string resourceId, string filename)
        {
            // verify the required parameter 'institutionStringId' is set
            if (institutionStringId == null)
                throw new ApiException(400, "Missing required parameter 'institutionStringId' when calling InstitutionsApi->InstitutionArticles");
            // verify the required parameter 'resourceId' is set
            if (resourceId == null)
                throw new ApiException(400, "Missing required parameter 'resourceId' when calling InstitutionsApi->InstitutionArticles");
            // verify the required parameter 'filename' is set
            if (filename == null)
                throw new ApiException(400, "Missing required parameter 'filename' when calling InstitutionsApi->InstitutionArticles");

            var localVarPath = "/institutions/{institution_string_id}/articles/filter-by";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (institutionStringId != null) localVarPathParams.Add("institution_string_id", this.Configuration.ApiClient.ParameterToString(institutionStringId)); // path parameter
            if (resourceId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "resource_id", resourceId)); // query parameter
            if (filename != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "filename", filename)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InstitutionArticles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Article>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Article>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Article>)));
        }

        /// <summary>
        /// Private Institution HRfeed Upload More info in the &lt;a href&#x3D;\&quot;#hr_feed\&quot;&gt;HR Feed section&lt;/a&gt;
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="hrfeed">You can find an example in the Hr Feed section (optional)</param>
        /// <returns>ResponseMessage</returns>
        public ResponseMessage InstitutionHrfeedUpload (System.IO.Stream hrfeed = null)
        {
             ApiResponse<ResponseMessage> localVarResponse = InstitutionHrfeedUploadWithHttpInfo(hrfeed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Institution HRfeed Upload More info in the &lt;a href&#x3D;\&quot;#hr_feed\&quot;&gt;HR Feed section&lt;/a&gt;
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="hrfeed">You can find an example in the Hr Feed section (optional)</param>
        /// <returns>ApiResponse of ResponseMessage</returns>
        public ApiResponse< ResponseMessage > InstitutionHrfeedUploadWithHttpInfo (System.IO.Stream hrfeed = null)
        {

            var localVarPath = "/institution/hrfeed/upload";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "multipart/form-data"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (hrfeed != null) localVarFileParams.Add("hrfeed", this.Configuration.ApiClient.ParameterToFile("hrfeed", hrfeed));

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InstitutionHrfeedUpload", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseMessage>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ResponseMessage) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseMessage)));
        }

        /// <summary>
        /// Private Institution HRfeed Upload More info in the &lt;a href&#x3D;\&quot;#hr_feed\&quot;&gt;HR Feed section&lt;/a&gt;
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="hrfeed">You can find an example in the Hr Feed section (optional)</param>
        /// <returns>Task of ResponseMessage</returns>
        public async System.Threading.Tasks.Task<ResponseMessage> InstitutionHrfeedUploadAsync (System.IO.Stream hrfeed = null)
        {
             ApiResponse<ResponseMessage> localVarResponse = await InstitutionHrfeedUploadAsyncWithHttpInfo(hrfeed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Institution HRfeed Upload More info in the &lt;a href&#x3D;\&quot;#hr_feed\&quot;&gt;HR Feed section&lt;/a&gt;
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="hrfeed">You can find an example in the Hr Feed section (optional)</param>
        /// <returns>Task of ApiResponse (ResponseMessage)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseMessage>> InstitutionHrfeedUploadAsyncWithHttpInfo (System.IO.Stream hrfeed = null)
        {

            var localVarPath = "/institution/hrfeed/upload";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "multipart/form-data"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (hrfeed != null) localVarFileParams.Add("hrfeed", this.Configuration.ApiClient.ParameterToFile("hrfeed", hrfeed));

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InstitutionHrfeedUpload", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseMessage>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ResponseMessage) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseMessage)));
        }

        /// <summary>
        /// Private Account Institution User Retrieve institution user information using the account_id
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>User</returns>
        public User PrivateAccountInstitutionUser (long? accountId)
        {
             ApiResponse<User> localVarResponse = PrivateAccountInstitutionUserWithHttpInfo(accountId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Account Institution User Retrieve institution user information using the account_id
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>ApiResponse of User</returns>
        public ApiResponse< User > PrivateAccountInstitutionUserWithHttpInfo (long? accountId)
        {
            // verify the required parameter 'accountId' is set
            if (accountId == null)
                throw new ApiException(400, "Missing required parameter 'accountId' when calling InstitutionsApi->PrivateAccountInstitutionUser");

            var localVarPath = "/account/institution/users/{account_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (accountId != null) localVarPathParams.Add("account_id", this.Configuration.ApiClient.ParameterToString(accountId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateAccountInstitutionUser", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<User>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (User) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(User)));
        }

        /// <summary>
        /// Private Account Institution User Retrieve institution user information using the account_id
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>Task of User</returns>
        public async System.Threading.Tasks.Task<User> PrivateAccountInstitutionUserAsync (long? accountId)
        {
             ApiResponse<User> localVarResponse = await PrivateAccountInstitutionUserAsyncWithHttpInfo(accountId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Account Institution User Retrieve institution user information using the account_id
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>Task of ApiResponse (User)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<User>> PrivateAccountInstitutionUserAsyncWithHttpInfo (long? accountId)
        {
            // verify the required parameter 'accountId' is set
            if (accountId == null)
                throw new ApiException(400, "Missing required parameter 'accountId' when calling InstitutionsApi->PrivateAccountInstitutionUser");

            var localVarPath = "/account/institution/users/{account_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (accountId != null) localVarPathParams.Add("account_id", this.Configuration.ApiClient.ParameterToString(accountId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateAccountInstitutionUser", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<User>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (User) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(User)));
        }

        /// <summary>
        /// Private Account Categories List institution categories (including parent Categories)
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>List&lt;Category&gt;</returns>
        public List<Category> PrivateCategoriesList ()
        {
             ApiResponse<List<Category>> localVarResponse = PrivateCategoriesListWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Account Categories List institution categories (including parent Categories)
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of List&lt;Category&gt;</returns>
        public ApiResponse< List<Category> > PrivateCategoriesListWithHttpInfo ()
        {

            var localVarPath = "/account/categories";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateCategoriesList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Category>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Category>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Category>)));
        }

        /// <summary>
        /// Private Account Categories List institution categories (including parent Categories)
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of List&lt;Category&gt;</returns>
        public async System.Threading.Tasks.Task<List<Category>> PrivateCategoriesListAsync ()
        {
             ApiResponse<List<Category>> localVarResponse = await PrivateCategoriesListAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Account Categories List institution categories (including parent Categories)
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (List&lt;Category&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Category>>> PrivateCategoriesListAsyncWithHttpInfo ()
        {

            var localVarPath = "/account/categories";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateCategoriesList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Category>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Category>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Category>)));
        }

        /// <summary>
        /// Private Account Institution Group Embargo Options Account institution group embargo options details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group identifier</param>
        /// <returns>List&lt;GroupEmbargoOptions&gt;</returns>
        public List<GroupEmbargoOptions> PrivateGroupEmbargoOptionsDetails (long? groupId)
        {
             ApiResponse<List<GroupEmbargoOptions>> localVarResponse = PrivateGroupEmbargoOptionsDetailsWithHttpInfo(groupId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Account Institution Group Embargo Options Account institution group embargo options details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group identifier</param>
        /// <returns>ApiResponse of List&lt;GroupEmbargoOptions&gt;</returns>
        public ApiResponse< List<GroupEmbargoOptions> > PrivateGroupEmbargoOptionsDetailsWithHttpInfo (long? groupId)
        {
            // verify the required parameter 'groupId' is set
            if (groupId == null)
                throw new ApiException(400, "Missing required parameter 'groupId' when calling InstitutionsApi->PrivateGroupEmbargoOptionsDetails");

            var localVarPath = "/account/institution/groups/{group_id}/embargo_options";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupId != null) localVarPathParams.Add("group_id", this.Configuration.ApiClient.ParameterToString(groupId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateGroupEmbargoOptionsDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<GroupEmbargoOptions>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<GroupEmbargoOptions>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<GroupEmbargoOptions>)));
        }

        /// <summary>
        /// Private Account Institution Group Embargo Options Account institution group embargo options details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group identifier</param>
        /// <returns>Task of List&lt;GroupEmbargoOptions&gt;</returns>
        public async System.Threading.Tasks.Task<List<GroupEmbargoOptions>> PrivateGroupEmbargoOptionsDetailsAsync (long? groupId)
        {
             ApiResponse<List<GroupEmbargoOptions>> localVarResponse = await PrivateGroupEmbargoOptionsDetailsAsyncWithHttpInfo(groupId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Account Institution Group Embargo Options Account institution group embargo options details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupId">Group identifier</param>
        /// <returns>Task of ApiResponse (List&lt;GroupEmbargoOptions&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<GroupEmbargoOptions>>> PrivateGroupEmbargoOptionsDetailsAsyncWithHttpInfo (long? groupId)
        {
            // verify the required parameter 'groupId' is set
            if (groupId == null)
                throw new ApiException(400, "Missing required parameter 'groupId' when calling InstitutionsApi->PrivateGroupEmbargoOptionsDetails");

            var localVarPath = "/account/institution/groups/{group_id}/embargo_options";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (groupId != null) localVarPathParams.Add("group_id", this.Configuration.ApiClient.ParameterToString(groupId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateGroupEmbargoOptionsDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<GroupEmbargoOptions>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<GroupEmbargoOptions>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<GroupEmbargoOptions>)));
        }

        /// <summary>
        /// Delete Institution Account Group Role Delete Institution Account Group Role
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier for which to remove the role</param>
        /// <param name="groupId">Group identifier for which to remove the role</param>
        /// <param name="roleId">Role identifier</param>
        /// <returns></returns>
        public void PrivateInstitutionAccountGroupRoleDelete (long? accountId, long? groupId, long? roleId)
        {
             PrivateInstitutionAccountGroupRoleDeleteWithHttpInfo(accountId, groupId, roleId);
        }

        /// <summary>
        /// Delete Institution Account Group Role Delete Institution Account Group Role
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier for which to remove the role</param>
        /// <param name="groupId">Group identifier for which to remove the role</param>
        /// <param name="roleId">Role identifier</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PrivateInstitutionAccountGroupRoleDeleteWithHttpInfo (long? accountId, long? groupId, long? roleId)
        {
            // verify the required parameter 'accountId' is set
            if (accountId == null)
                throw new ApiException(400, "Missing required parameter 'accountId' when calling InstitutionsApi->PrivateInstitutionAccountGroupRoleDelete");
            // verify the required parameter 'groupId' is set
            if (groupId == null)
                throw new ApiException(400, "Missing required parameter 'groupId' when calling InstitutionsApi->PrivateInstitutionAccountGroupRoleDelete");
            // verify the required parameter 'roleId' is set
            if (roleId == null)
                throw new ApiException(400, "Missing required parameter 'roleId' when calling InstitutionsApi->PrivateInstitutionAccountGroupRoleDelete");

            var localVarPath = "/account/institution/roles/{account_id}/{group_id}/{role_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (accountId != null) localVarPathParams.Add("account_id", this.Configuration.ApiClient.ParameterToString(accountId)); // path parameter
            if (groupId != null) localVarPathParams.Add("group_id", this.Configuration.ApiClient.ParameterToString(groupId)); // path parameter
            if (roleId != null) localVarPathParams.Add("role_id", this.Configuration.ApiClient.ParameterToString(roleId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountGroupRoleDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete Institution Account Group Role Delete Institution Account Group Role
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier for which to remove the role</param>
        /// <param name="groupId">Group identifier for which to remove the role</param>
        /// <param name="roleId">Role identifier</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PrivateInstitutionAccountGroupRoleDeleteAsync (long? accountId, long? groupId, long? roleId)
        {
             await PrivateInstitutionAccountGroupRoleDeleteAsyncWithHttpInfo(accountId, groupId, roleId);

        }

        /// <summary>
        /// Delete Institution Account Group Role Delete Institution Account Group Role
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier for which to remove the role</param>
        /// <param name="groupId">Group identifier for which to remove the role</param>
        /// <param name="roleId">Role identifier</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PrivateInstitutionAccountGroupRoleDeleteAsyncWithHttpInfo (long? accountId, long? groupId, long? roleId)
        {
            // verify the required parameter 'accountId' is set
            if (accountId == null)
                throw new ApiException(400, "Missing required parameter 'accountId' when calling InstitutionsApi->PrivateInstitutionAccountGroupRoleDelete");
            // verify the required parameter 'groupId' is set
            if (groupId == null)
                throw new ApiException(400, "Missing required parameter 'groupId' when calling InstitutionsApi->PrivateInstitutionAccountGroupRoleDelete");
            // verify the required parameter 'roleId' is set
            if (roleId == null)
                throw new ApiException(400, "Missing required parameter 'roleId' when calling InstitutionsApi->PrivateInstitutionAccountGroupRoleDelete");

            var localVarPath = "/account/institution/roles/{account_id}/{group_id}/{role_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (accountId != null) localVarPathParams.Add("account_id", this.Configuration.ApiClient.ParameterToString(accountId)); // path parameter
            if (groupId != null) localVarPathParams.Add("group_id", this.Configuration.ApiClient.ParameterToString(groupId)); // path parameter
            if (roleId != null) localVarPathParams.Add("role_id", this.Configuration.ApiClient.ParameterToString(roleId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountGroupRoleDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// List Institution Account Group Roles List Institution Account Group Roles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>AccountGroupRoles</returns>
        public AccountGroupRoles PrivateInstitutionAccountGroupRoles (long? accountId)
        {
             ApiResponse<AccountGroupRoles> localVarResponse = PrivateInstitutionAccountGroupRolesWithHttpInfo(accountId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// List Institution Account Group Roles List Institution Account Group Roles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>ApiResponse of AccountGroupRoles</returns>
        public ApiResponse< AccountGroupRoles > PrivateInstitutionAccountGroupRolesWithHttpInfo (long? accountId)
        {
            // verify the required parameter 'accountId' is set
            if (accountId == null)
                throw new ApiException(400, "Missing required parameter 'accountId' when calling InstitutionsApi->PrivateInstitutionAccountGroupRoles");

            var localVarPath = "/account/institution/roles/{account_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (accountId != null) localVarPathParams.Add("account_id", this.Configuration.ApiClient.ParameterToString(accountId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountGroupRoles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AccountGroupRoles>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AccountGroupRoles) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(AccountGroupRoles)));
        }

        /// <summary>
        /// List Institution Account Group Roles List Institution Account Group Roles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>Task of AccountGroupRoles</returns>
        public async System.Threading.Tasks.Task<AccountGroupRoles> PrivateInstitutionAccountGroupRolesAsync (long? accountId)
        {
             ApiResponse<AccountGroupRoles> localVarResponse = await PrivateInstitutionAccountGroupRolesAsyncWithHttpInfo(accountId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// List Institution Account Group Roles List Institution Account Group Roles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <returns>Task of ApiResponse (AccountGroupRoles)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<AccountGroupRoles>> PrivateInstitutionAccountGroupRolesAsyncWithHttpInfo (long? accountId)
        {
            // verify the required parameter 'accountId' is set
            if (accountId == null)
                throw new ApiException(400, "Missing required parameter 'accountId' when calling InstitutionsApi->PrivateInstitutionAccountGroupRoles");

            var localVarPath = "/account/institution/roles/{account_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (accountId != null) localVarPathParams.Add("account_id", this.Configuration.ApiClient.ParameterToString(accountId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountGroupRoles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AccountGroupRoles>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AccountGroupRoles) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(AccountGroupRoles)));
        }

        /// <summary>
        /// Add Institution Account Group Roles Add Institution Account Group Roles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns></returns>
        public void PrivateInstitutionAccountGroupRolesCreate (long? accountId, AccountGroupRolesCreate account)
        {
             PrivateInstitutionAccountGroupRolesCreateWithHttpInfo(accountId, account);
        }

        /// <summary>
        /// Add Institution Account Group Roles Add Institution Account Group Roles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PrivateInstitutionAccountGroupRolesCreateWithHttpInfo (long? accountId, AccountGroupRolesCreate account)
        {
            // verify the required parameter 'accountId' is set
            if (accountId == null)
                throw new ApiException(400, "Missing required parameter 'accountId' when calling InstitutionsApi->PrivateInstitutionAccountGroupRolesCreate");
            // verify the required parameter 'account' is set
            if (account == null)
                throw new ApiException(400, "Missing required parameter 'account' when calling InstitutionsApi->PrivateInstitutionAccountGroupRolesCreate");

            var localVarPath = "/account/institution/roles/{account_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (accountId != null) localVarPathParams.Add("account_id", this.Configuration.ApiClient.ParameterToString(accountId)); // path parameter
            if (account != null && account.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(account); // http body (model) parameter
            }
            else
            {
                localVarPostBody = account; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountGroupRolesCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Add Institution Account Group Roles Add Institution Account Group Roles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PrivateInstitutionAccountGroupRolesCreateAsync (long? accountId, AccountGroupRolesCreate account)
        {
             await PrivateInstitutionAccountGroupRolesCreateAsyncWithHttpInfo(accountId, account);

        }

        /// <summary>
        /// Add Institution Account Group Roles Add Institution Account Group Roles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PrivateInstitutionAccountGroupRolesCreateAsyncWithHttpInfo (long? accountId, AccountGroupRolesCreate account)
        {
            // verify the required parameter 'accountId' is set
            if (accountId == null)
                throw new ApiException(400, "Missing required parameter 'accountId' when calling InstitutionsApi->PrivateInstitutionAccountGroupRolesCreate");
            // verify the required parameter 'account' is set
            if (account == null)
                throw new ApiException(400, "Missing required parameter 'account' when calling InstitutionsApi->PrivateInstitutionAccountGroupRolesCreate");

            var localVarPath = "/account/institution/roles/{account_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (accountId != null) localVarPathParams.Add("account_id", this.Configuration.ApiClient.ParameterToString(accountId)); // path parameter
            if (account != null && account.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(account); // http body (model) parameter
            }
            else
            {
                localVarPostBody = account; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountGroupRolesCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Create new Institution Account Create a new Account by sending account information
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="account">Account description</param>
        /// <returns></returns>
        public void PrivateInstitutionAccountsCreate (AccountCreate account)
        {
             PrivateInstitutionAccountsCreateWithHttpInfo(account);
        }

        /// <summary>
        /// Create new Institution Account Create a new Account by sending account information
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="account">Account description</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PrivateInstitutionAccountsCreateWithHttpInfo (AccountCreate account)
        {
            // verify the required parameter 'account' is set
            if (account == null)
                throw new ApiException(400, "Missing required parameter 'account' when calling InstitutionsApi->PrivateInstitutionAccountsCreate");

            var localVarPath = "/account/institution/accounts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (account != null && account.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(account); // http body (model) parameter
            }
            else
            {
                localVarPostBody = account; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountsCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Create new Institution Account Create a new Account by sending account information
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="account">Account description</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PrivateInstitutionAccountsCreateAsync (AccountCreate account)
        {
             await PrivateInstitutionAccountsCreateAsyncWithHttpInfo(account);

        }

        /// <summary>
        /// Create new Institution Account Create a new Account by sending account information
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="account">Account description</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PrivateInstitutionAccountsCreateAsyncWithHttpInfo (AccountCreate account)
        {
            // verify the required parameter 'account' is set
            if (account == null)
                throw new ApiException(400, "Missing required parameter 'account' when calling InstitutionsApi->PrivateInstitutionAccountsCreate");

            var localVarPath = "/account/institution/accounts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (account != null && account.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(account); // http body (model) parameter
            }
            else
            {
                localVarPostBody = account; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountsCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Private Account Institution Accounts Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="isActive">Filter by active status (optional)</param>
        /// <param name="institutionUserId">Filter by institution_user_id (optional)</param>
        /// <param name="email">Filter by email (optional)</param>
        /// <param name="idLte">Retrieve accounts with an ID lower or equal to the specified value (optional)</param>
        /// <param name="idGte">Retrieve accounts with an ID greater or equal to the specified value (optional)</param>
        /// <returns>List&lt;ShortAccount&gt;</returns>
        public List<ShortAccount> PrivateInstitutionAccountsList (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, long? isActive = null, string institutionUserId = null, string email = null, long? idLte = null, long? idGte = null)
        {
             ApiResponse<List<ShortAccount>> localVarResponse = PrivateInstitutionAccountsListWithHttpInfo(page, pageSize, limit, offset, isActive, institutionUserId, email, idLte, idGte);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Account Institution Accounts Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="isActive">Filter by active status (optional)</param>
        /// <param name="institutionUserId">Filter by institution_user_id (optional)</param>
        /// <param name="email">Filter by email (optional)</param>
        /// <param name="idLte">Retrieve accounts with an ID lower or equal to the specified value (optional)</param>
        /// <param name="idGte">Retrieve accounts with an ID greater or equal to the specified value (optional)</param>
        /// <returns>ApiResponse of List&lt;ShortAccount&gt;</returns>
        public ApiResponse< List<ShortAccount> > PrivateInstitutionAccountsListWithHttpInfo (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, long? isActive = null, string institutionUserId = null, string email = null, long? idLte = null, long? idGte = null)
        {

            var localVarPath = "/account/institution/accounts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (isActive != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "is_active", isActive)); // query parameter
            if (institutionUserId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "institution_user_id", institutionUserId)); // query parameter
            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            if (idLte != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id_lte", idLte)); // query parameter
            if (idGte != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id_gte", idGte)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountsList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ShortAccount>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ShortAccount>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ShortAccount>)));
        }

        /// <summary>
        /// Private Account Institution Accounts Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="isActive">Filter by active status (optional)</param>
        /// <param name="institutionUserId">Filter by institution_user_id (optional)</param>
        /// <param name="email">Filter by email (optional)</param>
        /// <param name="idLte">Retrieve accounts with an ID lower or equal to the specified value (optional)</param>
        /// <param name="idGte">Retrieve accounts with an ID greater or equal to the specified value (optional)</param>
        /// <returns>Task of List&lt;ShortAccount&gt;</returns>
        public async System.Threading.Tasks.Task<List<ShortAccount>> PrivateInstitutionAccountsListAsync (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, long? isActive = null, string institutionUserId = null, string email = null, long? idLte = null, long? idGte = null)
        {
             ApiResponse<List<ShortAccount>> localVarResponse = await PrivateInstitutionAccountsListAsyncWithHttpInfo(page, pageSize, limit, offset, isActive, institutionUserId, email, idLte, idGte);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Account Institution Accounts Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="isActive">Filter by active status (optional)</param>
        /// <param name="institutionUserId">Filter by institution_user_id (optional)</param>
        /// <param name="email">Filter by email (optional)</param>
        /// <param name="idLte">Retrieve accounts with an ID lower or equal to the specified value (optional)</param>
        /// <param name="idGte">Retrieve accounts with an ID greater or equal to the specified value (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ShortAccount&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<ShortAccount>>> PrivateInstitutionAccountsListAsyncWithHttpInfo (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, long? isActive = null, string institutionUserId = null, string email = null, long? idLte = null, long? idGte = null)
        {

            var localVarPath = "/account/institution/accounts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (isActive != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "is_active", isActive)); // query parameter
            if (institutionUserId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "institution_user_id", institutionUserId)); // query parameter
            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            if (idLte != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id_lte", idLte)); // query parameter
            if (idGte != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id_gte", idGte)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountsList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ShortAccount>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ShortAccount>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ShortAccount>)));
        }

        /// <summary>
        /// Private Account Institution Accounts Search Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters</param>
        /// <returns>List&lt;ShortAccount&gt;</returns>
        public List<ShortAccount> PrivateInstitutionAccountsSearch (InstitutionAccountsSearch search)
        {
             ApiResponse<List<ShortAccount>> localVarResponse = PrivateInstitutionAccountsSearchWithHttpInfo(search);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Account Institution Accounts Search Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters</param>
        /// <returns>ApiResponse of List&lt;ShortAccount&gt;</returns>
        public ApiResponse< List<ShortAccount> > PrivateInstitutionAccountsSearchWithHttpInfo (InstitutionAccountsSearch search)
        {
            // verify the required parameter 'search' is set
            if (search == null)
                throw new ApiException(400, "Missing required parameter 'search' when calling InstitutionsApi->PrivateInstitutionAccountsSearch");

            var localVarPath = "/account/institution/accounts/search";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (search != null && search.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(search); // http body (model) parameter
            }
            else
            {
                localVarPostBody = search; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountsSearch", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ShortAccount>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ShortAccount>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ShortAccount>)));
        }

        /// <summary>
        /// Private Account Institution Accounts Search Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters</param>
        /// <returns>Task of List&lt;ShortAccount&gt;</returns>
        public async System.Threading.Tasks.Task<List<ShortAccount>> PrivateInstitutionAccountsSearchAsync (InstitutionAccountsSearch search)
        {
             ApiResponse<List<ShortAccount>> localVarResponse = await PrivateInstitutionAccountsSearchAsyncWithHttpInfo(search);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Account Institution Accounts Search Returns the accounts for which the account has administrative privileges (assigned and inherited).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters</param>
        /// <returns>Task of ApiResponse (List&lt;ShortAccount&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<ShortAccount>>> PrivateInstitutionAccountsSearchAsyncWithHttpInfo (InstitutionAccountsSearch search)
        {
            // verify the required parameter 'search' is set
            if (search == null)
                throw new ApiException(400, "Missing required parameter 'search' when calling InstitutionsApi->PrivateInstitutionAccountsSearch");

            var localVarPath = "/account/institution/accounts/search";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (search != null && search.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(search); // http body (model) parameter
            }
            else
            {
                localVarPostBody = search; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountsSearch", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ShortAccount>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ShortAccount>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ShortAccount>)));
        }

        /// <summary>
        /// Update Institution Account Update Institution Account
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns></returns>
        public void PrivateInstitutionAccountsUpdate (long? accountId, AccountUpdate account)
        {
             PrivateInstitutionAccountsUpdateWithHttpInfo(accountId, account);
        }

        /// <summary>
        /// Update Institution Account Update Institution Account
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PrivateInstitutionAccountsUpdateWithHttpInfo (long? accountId, AccountUpdate account)
        {
            // verify the required parameter 'accountId' is set
            if (accountId == null)
                throw new ApiException(400, "Missing required parameter 'accountId' when calling InstitutionsApi->PrivateInstitutionAccountsUpdate");
            // verify the required parameter 'account' is set
            if (account == null)
                throw new ApiException(400, "Missing required parameter 'account' when calling InstitutionsApi->PrivateInstitutionAccountsUpdate");

            var localVarPath = "/account/institution/accounts/{account_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (accountId != null) localVarPathParams.Add("account_id", this.Configuration.ApiClient.ParameterToString(accountId)); // path parameter
            if (account != null && account.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(account); // http body (model) parameter
            }
            else
            {
                localVarPostBody = account; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountsUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Update Institution Account Update Institution Account
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PrivateInstitutionAccountsUpdateAsync (long? accountId, AccountUpdate account)
        {
             await PrivateInstitutionAccountsUpdateAsyncWithHttpInfo(accountId, account);

        }

        /// <summary>
        /// Update Institution Account Update Institution Account
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="accountId">Account identifier the user is associated to</param>
        /// <param name="account">Account description</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PrivateInstitutionAccountsUpdateAsyncWithHttpInfo (long? accountId, AccountUpdate account)
        {
            // verify the required parameter 'accountId' is set
            if (accountId == null)
                throw new ApiException(400, "Missing required parameter 'accountId' when calling InstitutionsApi->PrivateInstitutionAccountsUpdate");
            // verify the required parameter 'account' is set
            if (account == null)
                throw new ApiException(400, "Missing required parameter 'account' when calling InstitutionsApi->PrivateInstitutionAccountsUpdate");

            var localVarPath = "/account/institution/accounts/{account_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (accountId != null) localVarPathParams.Add("account_id", this.Configuration.ApiClient.ParameterToString(accountId)); // path parameter
            if (account != null && account.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(account); // http body (model) parameter
            }
            else
            {
                localVarPostBody = account; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionAccountsUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Private Institution Articles Get Articles from own institution. User must be administrator of the institution
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="modifiedSince">Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="status">only return collections with this status (optional)</param>
        /// <param name="resourceDoi">only return collections with this resource_doi (optional)</param>
        /// <param name="itemType">Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)</param>
        /// <returns>List&lt;Article&gt;</returns>
        public List<Article> PrivateInstitutionArticles (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string publishedSince = null, string modifiedSince = null, long? status = null, string resourceDoi = null, long? itemType = null)
        {
             ApiResponse<List<Article>> localVarResponse = PrivateInstitutionArticlesWithHttpInfo(page, pageSize, limit, offset, order, orderDirection, publishedSince, modifiedSince, status, resourceDoi, itemType);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Institution Articles Get Articles from own institution. User must be administrator of the institution
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="modifiedSince">Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="status">only return collections with this status (optional)</param>
        /// <param name="resourceDoi">only return collections with this resource_doi (optional)</param>
        /// <param name="itemType">Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)</param>
        /// <returns>ApiResponse of List&lt;Article&gt;</returns>
        public ApiResponse< List<Article> > PrivateInstitutionArticlesWithHttpInfo (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string publishedSince = null, string modifiedSince = null, long? status = null, string resourceDoi = null, long? itemType = null)
        {

            var localVarPath = "/account/institution/articles";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (order != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "order", order)); // query parameter
            if (orderDirection != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "order_direction", orderDirection)); // query parameter
            if (publishedSince != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "published_since", publishedSince)); // query parameter
            if (modifiedSince != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modified_since", modifiedSince)); // query parameter
            if (status != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "status", status)); // query parameter
            if (resourceDoi != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "resource_doi", resourceDoi)); // query parameter
            if (itemType != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "item_type", itemType)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionArticles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Article>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Article>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Article>)));
        }

        /// <summary>
        /// Private Institution Articles Get Articles from own institution. User must be administrator of the institution
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="modifiedSince">Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="status">only return collections with this status (optional)</param>
        /// <param name="resourceDoi">only return collections with this resource_doi (optional)</param>
        /// <param name="itemType">Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)</param>
        /// <returns>Task of List&lt;Article&gt;</returns>
        public async System.Threading.Tasks.Task<List<Article>> PrivateInstitutionArticlesAsync (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string publishedSince = null, string modifiedSince = null, long? status = null, string resourceDoi = null, long? itemType = null)
        {
             ApiResponse<List<Article>> localVarResponse = await PrivateInstitutionArticlesAsyncWithHttpInfo(page, pageSize, limit, offset, order, orderDirection, publishedSince, modifiedSince, status, resourceDoi, itemType);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Institution Articles Get Articles from own institution. User must be administrator of the institution
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="modifiedSince">Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="status">only return collections with this status (optional)</param>
        /// <param name="resourceDoi">only return collections with this resource_doi (optional)</param>
        /// <param name="itemType">Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Article&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Article>>> PrivateInstitutionArticlesAsyncWithHttpInfo (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string publishedSince = null, string modifiedSince = null, long? status = null, string resourceDoi = null, long? itemType = null)
        {

            var localVarPath = "/account/institution/articles";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (order != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "order", order)); // query parameter
            if (orderDirection != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "order_direction", orderDirection)); // query parameter
            if (publishedSince != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "published_since", publishedSince)); // query parameter
            if (modifiedSince != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "modified_since", modifiedSince)); // query parameter
            if (status != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "status", status)); // query parameter
            if (resourceDoi != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "resource_doi", resourceDoi)); // query parameter
            if (itemType != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "item_type", itemType)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionArticles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Article>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Article>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Article>)));
        }

        /// <summary>
        /// Private Account Institutions Account institution details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Institution</returns>
        public Institution PrivateInstitutionDetails ()
        {
             ApiResponse<Institution> localVarResponse = PrivateInstitutionDetailsWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Account Institutions Account institution details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of Institution</returns>
        public ApiResponse< Institution > PrivateInstitutionDetailsWithHttpInfo ()
        {

            var localVarPath = "/account/institution";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Institution>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Institution) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Institution)));
        }

        /// <summary>
        /// Private Account Institutions Account institution details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of Institution</returns>
        public async System.Threading.Tasks.Task<Institution> PrivateInstitutionDetailsAsync ()
        {
             ApiResponse<Institution> localVarResponse = await PrivateInstitutionDetailsAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Account Institutions Account institution details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (Institution)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Institution>> PrivateInstitutionDetailsAsyncWithHttpInfo ()
        {

            var localVarPath = "/account/institution";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Institution>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Institution) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Institution)));
        }

        /// <summary>
        /// Private Account Institution embargo options Account institution embargo options details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>List&lt;GroupEmbargoOptions&gt;</returns>
        public List<GroupEmbargoOptions> PrivateInstitutionEmbargoOptionsDetails ()
        {
             ApiResponse<List<GroupEmbargoOptions>> localVarResponse = PrivateInstitutionEmbargoOptionsDetailsWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Account Institution embargo options Account institution embargo options details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of List&lt;GroupEmbargoOptions&gt;</returns>
        public ApiResponse< List<GroupEmbargoOptions> > PrivateInstitutionEmbargoOptionsDetailsWithHttpInfo ()
        {

            var localVarPath = "/account/institution/embargo_options";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionEmbargoOptionsDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<GroupEmbargoOptions>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<GroupEmbargoOptions>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<GroupEmbargoOptions>)));
        }

        /// <summary>
        /// Private Account Institution embargo options Account institution embargo options details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of List&lt;GroupEmbargoOptions&gt;</returns>
        public async System.Threading.Tasks.Task<List<GroupEmbargoOptions>> PrivateInstitutionEmbargoOptionsDetailsAsync ()
        {
             ApiResponse<List<GroupEmbargoOptions>> localVarResponse = await PrivateInstitutionEmbargoOptionsDetailsAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Account Institution embargo options Account institution embargo options details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (List&lt;GroupEmbargoOptions&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<GroupEmbargoOptions>>> PrivateInstitutionEmbargoOptionsDetailsAsyncWithHttpInfo ()
        {

            var localVarPath = "/account/institution/embargo_options";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionEmbargoOptionsDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<GroupEmbargoOptions>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<GroupEmbargoOptions>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<GroupEmbargoOptions>)));
        }

        /// <summary>
        /// Private Account Institution Groups Returns the groups for which the account has administrative privileges (assigned and inherited).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>List&lt;Group&gt;</returns>
        public List<Group> PrivateInstitutionGroupsList ()
        {
             ApiResponse<List<Group>> localVarResponse = PrivateInstitutionGroupsListWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Account Institution Groups Returns the groups for which the account has administrative privileges (assigned and inherited).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of List&lt;Group&gt;</returns>
        public ApiResponse< List<Group> > PrivateInstitutionGroupsListWithHttpInfo ()
        {

            var localVarPath = "/account/institution/groups";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionGroupsList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Group>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Group>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Group>)));
        }

        /// <summary>
        /// Private Account Institution Groups Returns the groups for which the account has administrative privileges (assigned and inherited).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of List&lt;Group&gt;</returns>
        public async System.Threading.Tasks.Task<List<Group>> PrivateInstitutionGroupsListAsync ()
        {
             ApiResponse<List<Group>> localVarResponse = await PrivateInstitutionGroupsListAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Account Institution Groups Returns the groups for which the account has administrative privileges (assigned and inherited).
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (List&lt;Group&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Group>>> PrivateInstitutionGroupsListAsyncWithHttpInfo ()
        {

            var localVarPath = "/account/institution/groups";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionGroupsList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Group>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Group>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Group>)));
        }

        /// <summary>
        /// Private Account Institution Roles Returns the roles available for groups and the institution group.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>List&lt;Role&gt;</returns>
        public List<Role> PrivateInstitutionRolesList ()
        {
             ApiResponse<List<Role>> localVarResponse = PrivateInstitutionRolesListWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Account Institution Roles Returns the roles available for groups and the institution group.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of List&lt;Role&gt;</returns>
        public ApiResponse< List<Role> > PrivateInstitutionRolesListWithHttpInfo ()
        {

            var localVarPath = "/account/institution/roles";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionRolesList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Role>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Role>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Role>)));
        }

        /// <summary>
        /// Private Account Institution Roles Returns the roles available for groups and the institution group.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of List&lt;Role&gt;</returns>
        public async System.Threading.Tasks.Task<List<Role>> PrivateInstitutionRolesListAsync ()
        {
             ApiResponse<List<Role>> localVarResponse = await PrivateInstitutionRolesListAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Account Institution Roles Returns the roles available for groups and the institution group.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (List&lt;Role&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Role>>> PrivateInstitutionRolesListAsyncWithHttpInfo ()
        {

            var localVarPath = "/account/institution/roles";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateInstitutionRolesList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Role>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Role>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Role>)));
        }

    }
}
