/* 
 * Figshare API
 *
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IProjectsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Delete project article
        /// </summary>
        /// <remarks>
        /// Delete project article
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns></returns>
        void PrivateProjectArticleDelete (long? projectId, long? articleId);

        /// <summary>
        /// Delete project article
        /// </summary>
        /// <remarks>
        /// Delete project article
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PrivateProjectArticleDeleteWithHttpInfo (long? projectId, long? articleId);
        /// <summary>
        /// Project article details
        /// </summary>
        /// <remarks>
        /// Project article details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>ProjectArticle</returns>
        ProjectArticle PrivateProjectArticleDetails (long? projectId, long? articleId);

        /// <summary>
        /// Project article details
        /// </summary>
        /// <remarks>
        /// Project article details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>ApiResponse of ProjectArticle</returns>
        ApiResponse<ProjectArticle> PrivateProjectArticleDetailsWithHttpInfo (long? projectId, long? articleId);
        /// <summary>
        /// Project article file details
        /// </summary>
        /// <remarks>
        /// Project article file details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <param name="fileId">File unique identifier</param>
        /// <returns>PrivateFile</returns>
        PrivateFile PrivateProjectArticleFile (long? projectId, long? articleId, long? fileId);

        /// <summary>
        /// Project article file details
        /// </summary>
        /// <remarks>
        /// Project article file details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <param name="fileId">File unique identifier</param>
        /// <returns>ApiResponse of PrivateFile</returns>
        ApiResponse<PrivateFile> PrivateProjectArticleFileWithHttpInfo (long? projectId, long? articleId, long? fileId);
        /// <summary>
        /// Project article list files
        /// </summary>
        /// <remarks>
        /// List article files
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>List&lt;PrivateFile&gt;</returns>
        List<PrivateFile> PrivateProjectArticleFiles (long? projectId, long? articleId);

        /// <summary>
        /// Project article list files
        /// </summary>
        /// <remarks>
        /// List article files
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>ApiResponse of List&lt;PrivateFile&gt;</returns>
        ApiResponse<List<PrivateFile>> PrivateProjectArticleFilesWithHttpInfo (long? projectId, long? articleId);
        /// <summary>
        /// Create project article
        /// </summary>
        /// <remarks>
        /// Create a new Article and associate it with this project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="article">Article description</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Location</returns>
        Location PrivateProjectArticlesCreate (long? projectId, ArticleProjectCreate article, long? page = null, long? pageSize = null, long? limit = null, long? offset = null);

        /// <summary>
        /// Create project article
        /// </summary>
        /// <remarks>
        /// Create a new Article and associate it with this project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="article">Article description</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>ApiResponse of Location</returns>
        ApiResponse<Location> PrivateProjectArticlesCreateWithHttpInfo (long? projectId, ArticleProjectCreate article, long? page = null, long? pageSize = null, long? limit = null, long? offset = null);
        /// <summary>
        /// List project articles
        /// </summary>
        /// <remarks>
        /// List project articles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>List&lt;Article&gt;</returns>
        List<Article> PrivateProjectArticlesList (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null);

        /// <summary>
        /// List project articles
        /// </summary>
        /// <remarks>
        /// List project articles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>ApiResponse of List&lt;Article&gt;</returns>
        ApiResponse<List<Article>> PrivateProjectArticlesListWithHttpInfo (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null);
        /// <summary>
        /// Remove project collaborator
        /// </summary>
        /// <remarks>
        /// Remove project collaborator
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="userId">User unique identifier</param>
        /// <returns></returns>
        void PrivateProjectCollaboratorDelete (long? projectId, long? userId);

        /// <summary>
        /// Remove project collaborator
        /// </summary>
        /// <remarks>
        /// Remove project collaborator
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="userId">User unique identifier</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PrivateProjectCollaboratorDeleteWithHttpInfo (long? projectId, long? userId);
        /// <summary>
        /// Invite project collaborators
        /// </summary>
        /// <remarks>
        /// Invite users to collaborate on project or view the project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="collaborator">viewer or collaborator role. User user_id or email of user</param>
        /// <returns>ResponseMessage</returns>
        ResponseMessage PrivateProjectCollaboratorsInvite (long? projectId, ProjectCollaboratorInvite collaborator);

        /// <summary>
        /// Invite project collaborators
        /// </summary>
        /// <remarks>
        /// Invite users to collaborate on project or view the project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="collaborator">viewer or collaborator role. User user_id or email of user</param>
        /// <returns>ApiResponse of ResponseMessage</returns>
        ApiResponse<ResponseMessage> PrivateProjectCollaboratorsInviteWithHttpInfo (long? projectId, ProjectCollaboratorInvite collaborator);
        /// <summary>
        /// List project collaborators
        /// </summary>
        /// <remarks>
        /// List Project collaborators and invited users
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>List&lt;ProjectCollaborator&gt;</returns>
        List<ProjectCollaborator> PrivateProjectCollaboratorsList (long? projectId);

        /// <summary>
        /// List project collaborators
        /// </summary>
        /// <remarks>
        /// List Project collaborators and invited users
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ApiResponse of List&lt;ProjectCollaborator&gt;</returns>
        ApiResponse<List<ProjectCollaborator>> PrivateProjectCollaboratorsListWithHttpInfo (long? projectId);
        /// <summary>
        /// Create project
        /// </summary>
        /// <remarks>
        /// Create a new project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="project">Project  description</param>
        /// <returns>CreateProjectResponse</returns>
        CreateProjectResponse PrivateProjectCreate (ProjectCreate project);

        /// <summary>
        /// Create project
        /// </summary>
        /// <remarks>
        /// Create a new project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="project">Project  description</param>
        /// <returns>ApiResponse of CreateProjectResponse</returns>
        ApiResponse<CreateProjectResponse> PrivateProjectCreateWithHttpInfo (ProjectCreate project);
        /// <summary>
        /// Delete project
        /// </summary>
        /// <remarks>
        /// A project can be deleted only if: - it is not public - it does not have public articles.  When an individual project is deleted, all the articles are moved to my data of each owner.  When a group project is deleted, all the articles and files are deleted as well. Only project owner, group admin and above can delete a project. 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns></returns>
        void PrivateProjectDelete (long? projectId);

        /// <summary>
        /// Delete project
        /// </summary>
        /// <remarks>
        /// A project can be deleted only if: - it is not public - it does not have public articles.  When an individual project is deleted, all the articles are moved to my data of each owner.  When a group project is deleted, all the articles and files are deleted as well. Only project owner, group admin and above can delete a project. 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PrivateProjectDeleteWithHttpInfo (long? projectId);
        /// <summary>
        /// View project details
        /// </summary>
        /// <remarks>
        /// View a private project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ProjectCompletePrivate</returns>
        ProjectCompletePrivate PrivateProjectDetails (long? projectId);

        /// <summary>
        /// View project details
        /// </summary>
        /// <remarks>
        /// View a private project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ApiResponse of ProjectCompletePrivate</returns>
        ApiResponse<ProjectCompletePrivate> PrivateProjectDetailsWithHttpInfo (long? projectId);
        /// <summary>
        /// Private Project Leave
        /// </summary>
        /// <remarks>
        /// Please note: project&#39;s owner cannot leave the project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns></returns>
        void PrivateProjectLeave (long? projectId);

        /// <summary>
        /// Private Project Leave
        /// </summary>
        /// <remarks>
        /// Please note: project&#39;s owner cannot leave the project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PrivateProjectLeaveWithHttpInfo (long? projectId);
        /// <summary>
        /// Project note details
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>ProjectNotePrivate</returns>
        ProjectNotePrivate PrivateProjectNote (long? projectId, long? noteId);

        /// <summary>
        /// Project note details
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>ApiResponse of ProjectNotePrivate</returns>
        ApiResponse<ProjectNotePrivate> PrivateProjectNoteWithHttpInfo (long? projectId, long? noteId);
        /// <summary>
        /// Delete project note
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns></returns>
        void PrivateProjectNoteDelete (long? projectId, long? noteId);

        /// <summary>
        /// Delete project note
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PrivateProjectNoteDeleteWithHttpInfo (long? projectId, long? noteId);
        /// <summary>
        /// Update project note
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns></returns>
        void PrivateProjectNoteUpdate (long? projectId, long? noteId, ProjectNoteCreate note);

        /// <summary>
        /// Update project note
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PrivateProjectNoteUpdateWithHttpInfo (long? projectId, long? noteId, ProjectNoteCreate note);
        /// <summary>
        /// Create project note
        /// </summary>
        /// <remarks>
        /// Create a new project note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>Location</returns>
        Location PrivateProjectNotesCreate (long? projectId, ProjectNoteCreate note);

        /// <summary>
        /// Create project note
        /// </summary>
        /// <remarks>
        /// Create a new project note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>ApiResponse of Location</returns>
        ApiResponse<Location> PrivateProjectNotesCreateWithHttpInfo (long? projectId, ProjectNoteCreate note);
        /// <summary>
        /// List project notes
        /// </summary>
        /// <remarks>
        /// List project notes
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>List&lt;ProjectNote&gt;</returns>
        List<ProjectNote> PrivateProjectNotesList (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null);

        /// <summary>
        /// List project notes
        /// </summary>
        /// <remarks>
        /// List project notes
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>ApiResponse of List&lt;ProjectNote&gt;</returns>
        ApiResponse<List<ProjectNote>> PrivateProjectNotesListWithHttpInfo (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null);
        /// <summary>
        /// Private Project Publish
        /// </summary>
        /// <remarks>
        /// Publish a project. Possible after all items inside it are public
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ResponseMessage</returns>
        ResponseMessage PrivateProjectPublish (long? projectId);

        /// <summary>
        /// Private Project Publish
        /// </summary>
        /// <remarks>
        /// Publish a project. Possible after all items inside it are public
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ApiResponse of ResponseMessage</returns>
        ApiResponse<ResponseMessage> PrivateProjectPublishWithHttpInfo (long? projectId);
        /// <summary>
        /// Update project
        /// </summary>
        /// <remarks>
        /// Updating an project by passing body parameters; request can also be made with the PATCH method.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="project">Project description</param>
        /// <returns></returns>
        void PrivateProjectUpdate (long? projectId, ProjectUpdate project);

        /// <summary>
        /// Update project
        /// </summary>
        /// <remarks>
        /// Updating an project by passing body parameters; request can also be made with the PATCH method.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="project">Project description</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PrivateProjectUpdateWithHttpInfo (long? projectId, ProjectUpdate project);
        /// <summary>
        /// Private Projects
        /// </summary>
        /// <remarks>
        /// List private projects
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="storage">only return collections from this institution (optional)</param>
        /// <param name="roles">Any combination of owner, collaborator, viewer separated by comma. Examples: \&quot;owner\&quot; or \&quot;owner,collaborator\&quot;. (optional)</param>
        /// <returns>List&lt;ProjectPrivate&gt;</returns>
        List<ProjectPrivate> PrivateProjectsList (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string storage = null, string roles = null);

        /// <summary>
        /// Private Projects
        /// </summary>
        /// <remarks>
        /// List private projects
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="storage">only return collections from this institution (optional)</param>
        /// <param name="roles">Any combination of owner, collaborator, viewer separated by comma. Examples: \&quot;owner\&quot; or \&quot;owner,collaborator\&quot;. (optional)</param>
        /// <returns>ApiResponse of List&lt;ProjectPrivate&gt;</returns>
        ApiResponse<List<ProjectPrivate>> PrivateProjectsListWithHttpInfo (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string storage = null, string roles = null);
        /// <summary>
        /// Private Projects search
        /// </summary>
        /// <remarks>
        /// Search inside the private projects
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>List&lt;ProjectPrivate&gt;</returns>
        List<ProjectPrivate> PrivateProjectsSearch (ProjectsSearch search = null);

        /// <summary>
        /// Private Projects search
        /// </summary>
        /// <remarks>
        /// Search inside the private projects
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>ApiResponse of List&lt;ProjectPrivate&gt;</returns>
        ApiResponse<List<ProjectPrivate>> PrivateProjectsSearchWithHttpInfo (ProjectsSearch search = null);
        /// <summary>
        /// Public Project Articles
        /// </summary>
        /// <remarks>
        /// List articles in project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>List&lt;Article&gt;</returns>
        List<Article> ProjectArticles (long? projectId);

        /// <summary>
        /// Public Project Articles
        /// </summary>
        /// <remarks>
        /// List articles in project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>ApiResponse of List&lt;Article&gt;</returns>
        ApiResponse<List<Article>> ProjectArticlesWithHttpInfo (long? projectId);
        /// <summary>
        /// Public Project
        /// </summary>
        /// <remarks>
        /// View a project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>ProjectComplete</returns>
        ProjectComplete ProjectDetails (long? projectId);

        /// <summary>
        /// Public Project
        /// </summary>
        /// <remarks>
        /// View a project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>ApiResponse of ProjectComplete</returns>
        ApiResponse<ProjectComplete> ProjectDetailsWithHttpInfo (long? projectId);
        /// <summary>
        /// Public Projects
        /// </summary>
        /// <remarks>
        /// Returns a list of public projects
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="institution">only return collections from this institution (optional)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="group">only return collections from this group (optional)</param>
        /// <returns>List&lt;Project&gt;</returns>
        List<Project> ProjectsList (Guid? xCursor = null, long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, long? institution = null, string publishedSince = null, long? group = null);

        /// <summary>
        /// Public Projects
        /// </summary>
        /// <remarks>
        /// Returns a list of public projects
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="institution">only return collections from this institution (optional)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="group">only return collections from this group (optional)</param>
        /// <returns>ApiResponse of List&lt;Project&gt;</returns>
        ApiResponse<List<Project>> ProjectsListWithHttpInfo (Guid? xCursor = null, long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, long? institution = null, string publishedSince = null, long? group = null);
        /// <summary>
        /// Public Projects Search
        /// </summary>
        /// <remarks>
        /// Returns a list of public articles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>List&lt;Project&gt;</returns>
        List<Project> ProjectsSearch (Guid? xCursor = null, ProjectsSearch search = null);

        /// <summary>
        /// Public Projects Search
        /// </summary>
        /// <remarks>
        /// Returns a list of public articles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>ApiResponse of List&lt;Project&gt;</returns>
        ApiResponse<List<Project>> ProjectsSearchWithHttpInfo (Guid? xCursor = null, ProjectsSearch search = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Delete project article
        /// </summary>
        /// <remarks>
        /// Delete project article
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PrivateProjectArticleDeleteAsync (long? projectId, long? articleId);

        /// <summary>
        /// Delete project article
        /// </summary>
        /// <remarks>
        /// Delete project article
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectArticleDeleteAsyncWithHttpInfo (long? projectId, long? articleId);
        /// <summary>
        /// Project article details
        /// </summary>
        /// <remarks>
        /// Project article details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>Task of ProjectArticle</returns>
        System.Threading.Tasks.Task<ProjectArticle> PrivateProjectArticleDetailsAsync (long? projectId, long? articleId);

        /// <summary>
        /// Project article details
        /// </summary>
        /// <remarks>
        /// Project article details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>Task of ApiResponse (ProjectArticle)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectArticle>> PrivateProjectArticleDetailsAsyncWithHttpInfo (long? projectId, long? articleId);
        /// <summary>
        /// Project article file details
        /// </summary>
        /// <remarks>
        /// Project article file details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <param name="fileId">File unique identifier</param>
        /// <returns>Task of PrivateFile</returns>
        System.Threading.Tasks.Task<PrivateFile> PrivateProjectArticleFileAsync (long? projectId, long? articleId, long? fileId);

        /// <summary>
        /// Project article file details
        /// </summary>
        /// <remarks>
        /// Project article file details
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <param name="fileId">File unique identifier</param>
        /// <returns>Task of ApiResponse (PrivateFile)</returns>
        System.Threading.Tasks.Task<ApiResponse<PrivateFile>> PrivateProjectArticleFileAsyncWithHttpInfo (long? projectId, long? articleId, long? fileId);
        /// <summary>
        /// Project article list files
        /// </summary>
        /// <remarks>
        /// List article files
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>Task of List&lt;PrivateFile&gt;</returns>
        System.Threading.Tasks.Task<List<PrivateFile>> PrivateProjectArticleFilesAsync (long? projectId, long? articleId);

        /// <summary>
        /// Project article list files
        /// </summary>
        /// <remarks>
        /// List article files
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>Task of ApiResponse (List&lt;PrivateFile&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<PrivateFile>>> PrivateProjectArticleFilesAsyncWithHttpInfo (long? projectId, long? articleId);
        /// <summary>
        /// Create project article
        /// </summary>
        /// <remarks>
        /// Create a new Article and associate it with this project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="article">Article description</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of Location</returns>
        System.Threading.Tasks.Task<Location> PrivateProjectArticlesCreateAsync (long? projectId, ArticleProjectCreate article, long? page = null, long? pageSize = null, long? limit = null, long? offset = null);

        /// <summary>
        /// Create project article
        /// </summary>
        /// <remarks>
        /// Create a new Article and associate it with this project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="article">Article description</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of ApiResponse (Location)</returns>
        System.Threading.Tasks.Task<ApiResponse<Location>> PrivateProjectArticlesCreateAsyncWithHttpInfo (long? projectId, ArticleProjectCreate article, long? page = null, long? pageSize = null, long? limit = null, long? offset = null);
        /// <summary>
        /// List project articles
        /// </summary>
        /// <remarks>
        /// List project articles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of List&lt;Article&gt;</returns>
        System.Threading.Tasks.Task<List<Article>> PrivateProjectArticlesListAsync (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null);

        /// <summary>
        /// List project articles
        /// </summary>
        /// <remarks>
        /// List project articles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Article&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Article>>> PrivateProjectArticlesListAsyncWithHttpInfo (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null);
        /// <summary>
        /// Remove project collaborator
        /// </summary>
        /// <remarks>
        /// Remove project collaborator
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="userId">User unique identifier</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PrivateProjectCollaboratorDeleteAsync (long? projectId, long? userId);

        /// <summary>
        /// Remove project collaborator
        /// </summary>
        /// <remarks>
        /// Remove project collaborator
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="userId">User unique identifier</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectCollaboratorDeleteAsyncWithHttpInfo (long? projectId, long? userId);
        /// <summary>
        /// Invite project collaborators
        /// </summary>
        /// <remarks>
        /// Invite users to collaborate on project or view the project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="collaborator">viewer or collaborator role. User user_id or email of user</param>
        /// <returns>Task of ResponseMessage</returns>
        System.Threading.Tasks.Task<ResponseMessage> PrivateProjectCollaboratorsInviteAsync (long? projectId, ProjectCollaboratorInvite collaborator);

        /// <summary>
        /// Invite project collaborators
        /// </summary>
        /// <remarks>
        /// Invite users to collaborate on project or view the project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="collaborator">viewer or collaborator role. User user_id or email of user</param>
        /// <returns>Task of ApiResponse (ResponseMessage)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseMessage>> PrivateProjectCollaboratorsInviteAsyncWithHttpInfo (long? projectId, ProjectCollaboratorInvite collaborator);
        /// <summary>
        /// List project collaborators
        /// </summary>
        /// <remarks>
        /// List Project collaborators and invited users
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of List&lt;ProjectCollaborator&gt;</returns>
        System.Threading.Tasks.Task<List<ProjectCollaborator>> PrivateProjectCollaboratorsListAsync (long? projectId);

        /// <summary>
        /// List project collaborators
        /// </summary>
        /// <remarks>
        /// List Project collaborators and invited users
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ApiResponse (List&lt;ProjectCollaborator&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<ProjectCollaborator>>> PrivateProjectCollaboratorsListAsyncWithHttpInfo (long? projectId);
        /// <summary>
        /// Create project
        /// </summary>
        /// <remarks>
        /// Create a new project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="project">Project  description</param>
        /// <returns>Task of CreateProjectResponse</returns>
        System.Threading.Tasks.Task<CreateProjectResponse> PrivateProjectCreateAsync (ProjectCreate project);

        /// <summary>
        /// Create project
        /// </summary>
        /// <remarks>
        /// Create a new project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="project">Project  description</param>
        /// <returns>Task of ApiResponse (CreateProjectResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<CreateProjectResponse>> PrivateProjectCreateAsyncWithHttpInfo (ProjectCreate project);
        /// <summary>
        /// Delete project
        /// </summary>
        /// <remarks>
        /// A project can be deleted only if: - it is not public - it does not have public articles.  When an individual project is deleted, all the articles are moved to my data of each owner.  When a group project is deleted, all the articles and files are deleted as well. Only project owner, group admin and above can delete a project. 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PrivateProjectDeleteAsync (long? projectId);

        /// <summary>
        /// Delete project
        /// </summary>
        /// <remarks>
        /// A project can be deleted only if: - it is not public - it does not have public articles.  When an individual project is deleted, all the articles are moved to my data of each owner.  When a group project is deleted, all the articles and files are deleted as well. Only project owner, group admin and above can delete a project. 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectDeleteAsyncWithHttpInfo (long? projectId);
        /// <summary>
        /// View project details
        /// </summary>
        /// <remarks>
        /// View a private project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ProjectCompletePrivate</returns>
        System.Threading.Tasks.Task<ProjectCompletePrivate> PrivateProjectDetailsAsync (long? projectId);

        /// <summary>
        /// View project details
        /// </summary>
        /// <remarks>
        /// View a private project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ApiResponse (ProjectCompletePrivate)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectCompletePrivate>> PrivateProjectDetailsAsyncWithHttpInfo (long? projectId);
        /// <summary>
        /// Private Project Leave
        /// </summary>
        /// <remarks>
        /// Please note: project&#39;s owner cannot leave the project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PrivateProjectLeaveAsync (long? projectId);

        /// <summary>
        /// Private Project Leave
        /// </summary>
        /// <remarks>
        /// Please note: project&#39;s owner cannot leave the project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectLeaveAsyncWithHttpInfo (long? projectId);
        /// <summary>
        /// Project note details
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>Task of ProjectNotePrivate</returns>
        System.Threading.Tasks.Task<ProjectNotePrivate> PrivateProjectNoteAsync (long? projectId, long? noteId);

        /// <summary>
        /// Project note details
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>Task of ApiResponse (ProjectNotePrivate)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectNotePrivate>> PrivateProjectNoteAsyncWithHttpInfo (long? projectId, long? noteId);
        /// <summary>
        /// Delete project note
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PrivateProjectNoteDeleteAsync (long? projectId, long? noteId);

        /// <summary>
        /// Delete project note
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectNoteDeleteAsyncWithHttpInfo (long? projectId, long? noteId);
        /// <summary>
        /// Update project note
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PrivateProjectNoteUpdateAsync (long? projectId, long? noteId, ProjectNoteCreate note);

        /// <summary>
        /// Update project note
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectNoteUpdateAsyncWithHttpInfo (long? projectId, long? noteId, ProjectNoteCreate note);
        /// <summary>
        /// Create project note
        /// </summary>
        /// <remarks>
        /// Create a new project note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>Task of Location</returns>
        System.Threading.Tasks.Task<Location> PrivateProjectNotesCreateAsync (long? projectId, ProjectNoteCreate note);

        /// <summary>
        /// Create project note
        /// </summary>
        /// <remarks>
        /// Create a new project note
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>Task of ApiResponse (Location)</returns>
        System.Threading.Tasks.Task<ApiResponse<Location>> PrivateProjectNotesCreateAsyncWithHttpInfo (long? projectId, ProjectNoteCreate note);
        /// <summary>
        /// List project notes
        /// </summary>
        /// <remarks>
        /// List project notes
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of List&lt;ProjectNote&gt;</returns>
        System.Threading.Tasks.Task<List<ProjectNote>> PrivateProjectNotesListAsync (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null);

        /// <summary>
        /// List project notes
        /// </summary>
        /// <remarks>
        /// List project notes
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ProjectNote&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<ProjectNote>>> PrivateProjectNotesListAsyncWithHttpInfo (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null);
        /// <summary>
        /// Private Project Publish
        /// </summary>
        /// <remarks>
        /// Publish a project. Possible after all items inside it are public
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ResponseMessage</returns>
        System.Threading.Tasks.Task<ResponseMessage> PrivateProjectPublishAsync (long? projectId);

        /// <summary>
        /// Private Project Publish
        /// </summary>
        /// <remarks>
        /// Publish a project. Possible after all items inside it are public
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ApiResponse (ResponseMessage)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseMessage>> PrivateProjectPublishAsyncWithHttpInfo (long? projectId);
        /// <summary>
        /// Update project
        /// </summary>
        /// <remarks>
        /// Updating an project by passing body parameters; request can also be made with the PATCH method.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="project">Project description</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PrivateProjectUpdateAsync (long? projectId, ProjectUpdate project);

        /// <summary>
        /// Update project
        /// </summary>
        /// <remarks>
        /// Updating an project by passing body parameters; request can also be made with the PATCH method.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="project">Project description</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectUpdateAsyncWithHttpInfo (long? projectId, ProjectUpdate project);
        /// <summary>
        /// Private Projects
        /// </summary>
        /// <remarks>
        /// List private projects
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="storage">only return collections from this institution (optional)</param>
        /// <param name="roles">Any combination of owner, collaborator, viewer separated by comma. Examples: \&quot;owner\&quot; or \&quot;owner,collaborator\&quot;. (optional)</param>
        /// <returns>Task of List&lt;ProjectPrivate&gt;</returns>
        System.Threading.Tasks.Task<List<ProjectPrivate>> PrivateProjectsListAsync (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string storage = null, string roles = null);

        /// <summary>
        /// Private Projects
        /// </summary>
        /// <remarks>
        /// List private projects
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="storage">only return collections from this institution (optional)</param>
        /// <param name="roles">Any combination of owner, collaborator, viewer separated by comma. Examples: \&quot;owner\&quot; or \&quot;owner,collaborator\&quot;. (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ProjectPrivate&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<ProjectPrivate>>> PrivateProjectsListAsyncWithHttpInfo (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string storage = null, string roles = null);
        /// <summary>
        /// Private Projects search
        /// </summary>
        /// <remarks>
        /// Search inside the private projects
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>Task of List&lt;ProjectPrivate&gt;</returns>
        System.Threading.Tasks.Task<List<ProjectPrivate>> PrivateProjectsSearchAsync (ProjectsSearch search = null);

        /// <summary>
        /// Private Projects search
        /// </summary>
        /// <remarks>
        /// Search inside the private projects
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ProjectPrivate&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<ProjectPrivate>>> PrivateProjectsSearchAsyncWithHttpInfo (ProjectsSearch search = null);
        /// <summary>
        /// Public Project Articles
        /// </summary>
        /// <remarks>
        /// List articles in project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>Task of List&lt;Article&gt;</returns>
        System.Threading.Tasks.Task<List<Article>> ProjectArticlesAsync (long? projectId);

        /// <summary>
        /// Public Project Articles
        /// </summary>
        /// <remarks>
        /// List articles in project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>Task of ApiResponse (List&lt;Article&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Article>>> ProjectArticlesAsyncWithHttpInfo (long? projectId);
        /// <summary>
        /// Public Project
        /// </summary>
        /// <remarks>
        /// View a project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>Task of ProjectComplete</returns>
        System.Threading.Tasks.Task<ProjectComplete> ProjectDetailsAsync (long? projectId);

        /// <summary>
        /// Public Project
        /// </summary>
        /// <remarks>
        /// View a project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>Task of ApiResponse (ProjectComplete)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectComplete>> ProjectDetailsAsyncWithHttpInfo (long? projectId);
        /// <summary>
        /// Public Projects
        /// </summary>
        /// <remarks>
        /// Returns a list of public projects
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="institution">only return collections from this institution (optional)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="group">only return collections from this group (optional)</param>
        /// <returns>Task of List&lt;Project&gt;</returns>
        System.Threading.Tasks.Task<List<Project>> ProjectsListAsync (Guid? xCursor = null, long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, long? institution = null, string publishedSince = null, long? group = null);

        /// <summary>
        /// Public Projects
        /// </summary>
        /// <remarks>
        /// Returns a list of public projects
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="institution">only return collections from this institution (optional)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="group">only return collections from this group (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Project&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Project>>> ProjectsListAsyncWithHttpInfo (Guid? xCursor = null, long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, long? institution = null, string publishedSince = null, long? group = null);
        /// <summary>
        /// Public Projects Search
        /// </summary>
        /// <remarks>
        /// Returns a list of public articles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>Task of List&lt;Project&gt;</returns>
        System.Threading.Tasks.Task<List<Project>> ProjectsSearchAsync (Guid? xCursor = null, ProjectsSearch search = null);

        /// <summary>
        /// Public Projects Search
        /// </summary>
        /// <remarks>
        /// Returns a list of public articles
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Project&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Project>>> ProjectsSearchAsyncWithHttpInfo (Guid? xCursor = null, ProjectsSearch search = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class ProjectsApi : IProjectsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ProjectsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public ProjectsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Delete project article Delete project article
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns></returns>
        public void PrivateProjectArticleDelete (long? projectId, long? articleId)
        {
             PrivateProjectArticleDeleteWithHttpInfo(projectId, articleId);
        }

        /// <summary>
        /// Delete project article Delete project article
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PrivateProjectArticleDeleteWithHttpInfo (long? projectId, long? articleId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectArticleDelete");
            // verify the required parameter 'articleId' is set
            if (articleId == null)
                throw new ApiException(400, "Missing required parameter 'articleId' when calling ProjectsApi->PrivateProjectArticleDelete");

            var localVarPath = "/account/projects/{project_id}/articles/{article_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (articleId != null) localVarPathParams.Add("article_id", this.Configuration.ApiClient.ParameterToString(articleId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectArticleDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete project article Delete project article
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PrivateProjectArticleDeleteAsync (long? projectId, long? articleId)
        {
             await PrivateProjectArticleDeleteAsyncWithHttpInfo(projectId, articleId);

        }

        /// <summary>
        /// Delete project article Delete project article
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectArticleDeleteAsyncWithHttpInfo (long? projectId, long? articleId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectArticleDelete");
            // verify the required parameter 'articleId' is set
            if (articleId == null)
                throw new ApiException(400, "Missing required parameter 'articleId' when calling ProjectsApi->PrivateProjectArticleDelete");

            var localVarPath = "/account/projects/{project_id}/articles/{article_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (articleId != null) localVarPathParams.Add("article_id", this.Configuration.ApiClient.ParameterToString(articleId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectArticleDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Project article details Project article details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>ProjectArticle</returns>
        public ProjectArticle PrivateProjectArticleDetails (long? projectId, long? articleId)
        {
             ApiResponse<ProjectArticle> localVarResponse = PrivateProjectArticleDetailsWithHttpInfo(projectId, articleId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Project article details Project article details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>ApiResponse of ProjectArticle</returns>
        public ApiResponse< ProjectArticle > PrivateProjectArticleDetailsWithHttpInfo (long? projectId, long? articleId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectArticleDetails");
            // verify the required parameter 'articleId' is set
            if (articleId == null)
                throw new ApiException(400, "Missing required parameter 'articleId' when calling ProjectsApi->PrivateProjectArticleDetails");

            var localVarPath = "/account/projects/{project_id}/articles/{article_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (articleId != null) localVarPathParams.Add("article_id", this.Configuration.ApiClient.ParameterToString(articleId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectArticleDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectArticle>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectArticle) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectArticle)));
        }

        /// <summary>
        /// Project article details Project article details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>Task of ProjectArticle</returns>
        public async System.Threading.Tasks.Task<ProjectArticle> PrivateProjectArticleDetailsAsync (long? projectId, long? articleId)
        {
             ApiResponse<ProjectArticle> localVarResponse = await PrivateProjectArticleDetailsAsyncWithHttpInfo(projectId, articleId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Project article details Project article details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>Task of ApiResponse (ProjectArticle)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectArticle>> PrivateProjectArticleDetailsAsyncWithHttpInfo (long? projectId, long? articleId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectArticleDetails");
            // verify the required parameter 'articleId' is set
            if (articleId == null)
                throw new ApiException(400, "Missing required parameter 'articleId' when calling ProjectsApi->PrivateProjectArticleDetails");

            var localVarPath = "/account/projects/{project_id}/articles/{article_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (articleId != null) localVarPathParams.Add("article_id", this.Configuration.ApiClient.ParameterToString(articleId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectArticleDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectArticle>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectArticle) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectArticle)));
        }

        /// <summary>
        /// Project article file details Project article file details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <param name="fileId">File unique identifier</param>
        /// <returns>PrivateFile</returns>
        public PrivateFile PrivateProjectArticleFile (long? projectId, long? articleId, long? fileId)
        {
             ApiResponse<PrivateFile> localVarResponse = PrivateProjectArticleFileWithHttpInfo(projectId, articleId, fileId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Project article file details Project article file details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <param name="fileId">File unique identifier</param>
        /// <returns>ApiResponse of PrivateFile</returns>
        public ApiResponse< PrivateFile > PrivateProjectArticleFileWithHttpInfo (long? projectId, long? articleId, long? fileId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectArticleFile");
            // verify the required parameter 'articleId' is set
            if (articleId == null)
                throw new ApiException(400, "Missing required parameter 'articleId' when calling ProjectsApi->PrivateProjectArticleFile");
            // verify the required parameter 'fileId' is set
            if (fileId == null)
                throw new ApiException(400, "Missing required parameter 'fileId' when calling ProjectsApi->PrivateProjectArticleFile");

            var localVarPath = "/account/projects/{project_id}/articles/{article_id}/files/{file_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (articleId != null) localVarPathParams.Add("article_id", this.Configuration.ApiClient.ParameterToString(articleId)); // path parameter
            if (fileId != null) localVarPathParams.Add("file_id", this.Configuration.ApiClient.ParameterToString(fileId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectArticleFile", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PrivateFile>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PrivateFile) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PrivateFile)));
        }

        /// <summary>
        /// Project article file details Project article file details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <param name="fileId">File unique identifier</param>
        /// <returns>Task of PrivateFile</returns>
        public async System.Threading.Tasks.Task<PrivateFile> PrivateProjectArticleFileAsync (long? projectId, long? articleId, long? fileId)
        {
             ApiResponse<PrivateFile> localVarResponse = await PrivateProjectArticleFileAsyncWithHttpInfo(projectId, articleId, fileId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Project article file details Project article file details
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <param name="fileId">File unique identifier</param>
        /// <returns>Task of ApiResponse (PrivateFile)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PrivateFile>> PrivateProjectArticleFileAsyncWithHttpInfo (long? projectId, long? articleId, long? fileId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectArticleFile");
            // verify the required parameter 'articleId' is set
            if (articleId == null)
                throw new ApiException(400, "Missing required parameter 'articleId' when calling ProjectsApi->PrivateProjectArticleFile");
            // verify the required parameter 'fileId' is set
            if (fileId == null)
                throw new ApiException(400, "Missing required parameter 'fileId' when calling ProjectsApi->PrivateProjectArticleFile");

            var localVarPath = "/account/projects/{project_id}/articles/{article_id}/files/{file_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (articleId != null) localVarPathParams.Add("article_id", this.Configuration.ApiClient.ParameterToString(articleId)); // path parameter
            if (fileId != null) localVarPathParams.Add("file_id", this.Configuration.ApiClient.ParameterToString(fileId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectArticleFile", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PrivateFile>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PrivateFile) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PrivateFile)));
        }

        /// <summary>
        /// Project article list files List article files
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>List&lt;PrivateFile&gt;</returns>
        public List<PrivateFile> PrivateProjectArticleFiles (long? projectId, long? articleId)
        {
             ApiResponse<List<PrivateFile>> localVarResponse = PrivateProjectArticleFilesWithHttpInfo(projectId, articleId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Project article list files List article files
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>ApiResponse of List&lt;PrivateFile&gt;</returns>
        public ApiResponse< List<PrivateFile> > PrivateProjectArticleFilesWithHttpInfo (long? projectId, long? articleId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectArticleFiles");
            // verify the required parameter 'articleId' is set
            if (articleId == null)
                throw new ApiException(400, "Missing required parameter 'articleId' when calling ProjectsApi->PrivateProjectArticleFiles");

            var localVarPath = "/account/projects/{project_id}/articles/{article_id}/files";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (articleId != null) localVarPathParams.Add("article_id", this.Configuration.ApiClient.ParameterToString(articleId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectArticleFiles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<PrivateFile>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<PrivateFile>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<PrivateFile>)));
        }

        /// <summary>
        /// Project article list files List article files
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>Task of List&lt;PrivateFile&gt;</returns>
        public async System.Threading.Tasks.Task<List<PrivateFile>> PrivateProjectArticleFilesAsync (long? projectId, long? articleId)
        {
             ApiResponse<List<PrivateFile>> localVarResponse = await PrivateProjectArticleFilesAsyncWithHttpInfo(projectId, articleId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Project article list files List article files
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="articleId">Project Article unique identifier</param>
        /// <returns>Task of ApiResponse (List&lt;PrivateFile&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<PrivateFile>>> PrivateProjectArticleFilesAsyncWithHttpInfo (long? projectId, long? articleId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectArticleFiles");
            // verify the required parameter 'articleId' is set
            if (articleId == null)
                throw new ApiException(400, "Missing required parameter 'articleId' when calling ProjectsApi->PrivateProjectArticleFiles");

            var localVarPath = "/account/projects/{project_id}/articles/{article_id}/files";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (articleId != null) localVarPathParams.Add("article_id", this.Configuration.ApiClient.ParameterToString(articleId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectArticleFiles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<PrivateFile>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<PrivateFile>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<PrivateFile>)));
        }

        /// <summary>
        /// Create project article Create a new Article and associate it with this project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="article">Article description</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Location</returns>
        public Location PrivateProjectArticlesCreate (long? projectId, ArticleProjectCreate article, long? page = null, long? pageSize = null, long? limit = null, long? offset = null)
        {
             ApiResponse<Location> localVarResponse = PrivateProjectArticlesCreateWithHttpInfo(projectId, article, page, pageSize, limit, offset);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create project article Create a new Article and associate it with this project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="article">Article description</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>ApiResponse of Location</returns>
        public ApiResponse< Location > PrivateProjectArticlesCreateWithHttpInfo (long? projectId, ArticleProjectCreate article, long? page = null, long? pageSize = null, long? limit = null, long? offset = null)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectArticlesCreate");
            // verify the required parameter 'article' is set
            if (article == null)
                throw new ApiException(400, "Missing required parameter 'article' when calling ProjectsApi->PrivateProjectArticlesCreate");

            var localVarPath = "/account/projects/{project_id}/articles";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (article != null && article.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(article); // http body (model) parameter
            }
            else
            {
                localVarPostBody = article; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectArticlesCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Location>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Location) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Location)));
        }

        /// <summary>
        /// Create project article Create a new Article and associate it with this project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="article">Article description</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of Location</returns>
        public async System.Threading.Tasks.Task<Location> PrivateProjectArticlesCreateAsync (long? projectId, ArticleProjectCreate article, long? page = null, long? pageSize = null, long? limit = null, long? offset = null)
        {
             ApiResponse<Location> localVarResponse = await PrivateProjectArticlesCreateAsyncWithHttpInfo(projectId, article, page, pageSize, limit, offset);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create project article Create a new Article and associate it with this project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="article">Article description</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of ApiResponse (Location)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Location>> PrivateProjectArticlesCreateAsyncWithHttpInfo (long? projectId, ArticleProjectCreate article, long? page = null, long? pageSize = null, long? limit = null, long? offset = null)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectArticlesCreate");
            // verify the required parameter 'article' is set
            if (article == null)
                throw new ApiException(400, "Missing required parameter 'article' when calling ProjectsApi->PrivateProjectArticlesCreate");

            var localVarPath = "/account/projects/{project_id}/articles";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (article != null && article.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(article); // http body (model) parameter
            }
            else
            {
                localVarPostBody = article; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectArticlesCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Location>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Location) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Location)));
        }

        /// <summary>
        /// List project articles List project articles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>List&lt;Article&gt;</returns>
        public List<Article> PrivateProjectArticlesList (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null)
        {
             ApiResponse<List<Article>> localVarResponse = PrivateProjectArticlesListWithHttpInfo(projectId, page, pageSize, limit, offset);
             return localVarResponse.Data;
        }

        /// <summary>
        /// List project articles List project articles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>ApiResponse of List&lt;Article&gt;</returns>
        public ApiResponse< List<Article> > PrivateProjectArticlesListWithHttpInfo (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectArticlesList");

            var localVarPath = "/account/projects/{project_id}/articles";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectArticlesList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Article>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Article>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Article>)));
        }

        /// <summary>
        /// List project articles List project articles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of List&lt;Article&gt;</returns>
        public async System.Threading.Tasks.Task<List<Article>> PrivateProjectArticlesListAsync (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null)
        {
             ApiResponse<List<Article>> localVarResponse = await PrivateProjectArticlesListAsyncWithHttpInfo(projectId, page, pageSize, limit, offset);
             return localVarResponse.Data;

        }

        /// <summary>
        /// List project articles List project articles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Article&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Article>>> PrivateProjectArticlesListAsyncWithHttpInfo (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectArticlesList");

            var localVarPath = "/account/projects/{project_id}/articles";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectArticlesList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Article>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Article>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Article>)));
        }

        /// <summary>
        /// Remove project collaborator Remove project collaborator
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="userId">User unique identifier</param>
        /// <returns></returns>
        public void PrivateProjectCollaboratorDelete (long? projectId, long? userId)
        {
             PrivateProjectCollaboratorDeleteWithHttpInfo(projectId, userId);
        }

        /// <summary>
        /// Remove project collaborator Remove project collaborator
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="userId">User unique identifier</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PrivateProjectCollaboratorDeleteWithHttpInfo (long? projectId, long? userId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectCollaboratorDelete");
            // verify the required parameter 'userId' is set
            if (userId == null)
                throw new ApiException(400, "Missing required parameter 'userId' when calling ProjectsApi->PrivateProjectCollaboratorDelete");

            var localVarPath = "/account/projects/{project_id}/collaborators/{user_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (userId != null) localVarPathParams.Add("user_id", this.Configuration.ApiClient.ParameterToString(userId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectCollaboratorDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Remove project collaborator Remove project collaborator
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="userId">User unique identifier</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PrivateProjectCollaboratorDeleteAsync (long? projectId, long? userId)
        {
             await PrivateProjectCollaboratorDeleteAsyncWithHttpInfo(projectId, userId);

        }

        /// <summary>
        /// Remove project collaborator Remove project collaborator
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="userId">User unique identifier</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectCollaboratorDeleteAsyncWithHttpInfo (long? projectId, long? userId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectCollaboratorDelete");
            // verify the required parameter 'userId' is set
            if (userId == null)
                throw new ApiException(400, "Missing required parameter 'userId' when calling ProjectsApi->PrivateProjectCollaboratorDelete");

            var localVarPath = "/account/projects/{project_id}/collaborators/{user_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (userId != null) localVarPathParams.Add("user_id", this.Configuration.ApiClient.ParameterToString(userId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectCollaboratorDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Invite project collaborators Invite users to collaborate on project or view the project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="collaborator">viewer or collaborator role. User user_id or email of user</param>
        /// <returns>ResponseMessage</returns>
        public ResponseMessage PrivateProjectCollaboratorsInvite (long? projectId, ProjectCollaboratorInvite collaborator)
        {
             ApiResponse<ResponseMessage> localVarResponse = PrivateProjectCollaboratorsInviteWithHttpInfo(projectId, collaborator);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Invite project collaborators Invite users to collaborate on project or view the project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="collaborator">viewer or collaborator role. User user_id or email of user</param>
        /// <returns>ApiResponse of ResponseMessage</returns>
        public ApiResponse< ResponseMessage > PrivateProjectCollaboratorsInviteWithHttpInfo (long? projectId, ProjectCollaboratorInvite collaborator)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectCollaboratorsInvite");
            // verify the required parameter 'collaborator' is set
            if (collaborator == null)
                throw new ApiException(400, "Missing required parameter 'collaborator' when calling ProjectsApi->PrivateProjectCollaboratorsInvite");

            var localVarPath = "/account/projects/{project_id}/collaborators";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (collaborator != null && collaborator.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(collaborator); // http body (model) parameter
            }
            else
            {
                localVarPostBody = collaborator; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectCollaboratorsInvite", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseMessage>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ResponseMessage) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseMessage)));
        }

        /// <summary>
        /// Invite project collaborators Invite users to collaborate on project or view the project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="collaborator">viewer or collaborator role. User user_id or email of user</param>
        /// <returns>Task of ResponseMessage</returns>
        public async System.Threading.Tasks.Task<ResponseMessage> PrivateProjectCollaboratorsInviteAsync (long? projectId, ProjectCollaboratorInvite collaborator)
        {
             ApiResponse<ResponseMessage> localVarResponse = await PrivateProjectCollaboratorsInviteAsyncWithHttpInfo(projectId, collaborator);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Invite project collaborators Invite users to collaborate on project or view the project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="collaborator">viewer or collaborator role. User user_id or email of user</param>
        /// <returns>Task of ApiResponse (ResponseMessage)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseMessage>> PrivateProjectCollaboratorsInviteAsyncWithHttpInfo (long? projectId, ProjectCollaboratorInvite collaborator)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectCollaboratorsInvite");
            // verify the required parameter 'collaborator' is set
            if (collaborator == null)
                throw new ApiException(400, "Missing required parameter 'collaborator' when calling ProjectsApi->PrivateProjectCollaboratorsInvite");

            var localVarPath = "/account/projects/{project_id}/collaborators";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (collaborator != null && collaborator.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(collaborator); // http body (model) parameter
            }
            else
            {
                localVarPostBody = collaborator; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectCollaboratorsInvite", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseMessage>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ResponseMessage) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseMessage)));
        }

        /// <summary>
        /// List project collaborators List Project collaborators and invited users
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>List&lt;ProjectCollaborator&gt;</returns>
        public List<ProjectCollaborator> PrivateProjectCollaboratorsList (long? projectId)
        {
             ApiResponse<List<ProjectCollaborator>> localVarResponse = PrivateProjectCollaboratorsListWithHttpInfo(projectId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// List project collaborators List Project collaborators and invited users
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ApiResponse of List&lt;ProjectCollaborator&gt;</returns>
        public ApiResponse< List<ProjectCollaborator> > PrivateProjectCollaboratorsListWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectCollaboratorsList");

            var localVarPath = "/account/projects/{project_id}/collaborators";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectCollaboratorsList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ProjectCollaborator>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ProjectCollaborator>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ProjectCollaborator>)));
        }

        /// <summary>
        /// List project collaborators List Project collaborators and invited users
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of List&lt;ProjectCollaborator&gt;</returns>
        public async System.Threading.Tasks.Task<List<ProjectCollaborator>> PrivateProjectCollaboratorsListAsync (long? projectId)
        {
             ApiResponse<List<ProjectCollaborator>> localVarResponse = await PrivateProjectCollaboratorsListAsyncWithHttpInfo(projectId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// List project collaborators List Project collaborators and invited users
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ApiResponse (List&lt;ProjectCollaborator&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<ProjectCollaborator>>> PrivateProjectCollaboratorsListAsyncWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectCollaboratorsList");

            var localVarPath = "/account/projects/{project_id}/collaborators";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectCollaboratorsList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ProjectCollaborator>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ProjectCollaborator>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ProjectCollaborator>)));
        }

        /// <summary>
        /// Create project Create a new project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="project">Project  description</param>
        /// <returns>CreateProjectResponse</returns>
        public CreateProjectResponse PrivateProjectCreate (ProjectCreate project)
        {
             ApiResponse<CreateProjectResponse> localVarResponse = PrivateProjectCreateWithHttpInfo(project);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create project Create a new project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="project">Project  description</param>
        /// <returns>ApiResponse of CreateProjectResponse</returns>
        public ApiResponse< CreateProjectResponse > PrivateProjectCreateWithHttpInfo (ProjectCreate project)
        {
            // verify the required parameter 'project' is set
            if (project == null)
                throw new ApiException(400, "Missing required parameter 'project' when calling ProjectsApi->PrivateProjectCreate");

            var localVarPath = "/account/projects";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (project != null && project.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(project); // http body (model) parameter
            }
            else
            {
                localVarPostBody = project; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CreateProjectResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (CreateProjectResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CreateProjectResponse)));
        }

        /// <summary>
        /// Create project Create a new project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="project">Project  description</param>
        /// <returns>Task of CreateProjectResponse</returns>
        public async System.Threading.Tasks.Task<CreateProjectResponse> PrivateProjectCreateAsync (ProjectCreate project)
        {
             ApiResponse<CreateProjectResponse> localVarResponse = await PrivateProjectCreateAsyncWithHttpInfo(project);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create project Create a new project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="project">Project  description</param>
        /// <returns>Task of ApiResponse (CreateProjectResponse)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<CreateProjectResponse>> PrivateProjectCreateAsyncWithHttpInfo (ProjectCreate project)
        {
            // verify the required parameter 'project' is set
            if (project == null)
                throw new ApiException(400, "Missing required parameter 'project' when calling ProjectsApi->PrivateProjectCreate");

            var localVarPath = "/account/projects";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (project != null && project.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(project); // http body (model) parameter
            }
            else
            {
                localVarPostBody = project; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CreateProjectResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (CreateProjectResponse) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CreateProjectResponse)));
        }

        /// <summary>
        /// Delete project A project can be deleted only if: - it is not public - it does not have public articles.  When an individual project is deleted, all the articles are moved to my data of each owner.  When a group project is deleted, all the articles and files are deleted as well. Only project owner, group admin and above can delete a project. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns></returns>
        public void PrivateProjectDelete (long? projectId)
        {
             PrivateProjectDeleteWithHttpInfo(projectId);
        }

        /// <summary>
        /// Delete project A project can be deleted only if: - it is not public - it does not have public articles.  When an individual project is deleted, all the articles are moved to my data of each owner.  When a group project is deleted, all the articles and files are deleted as well. Only project owner, group admin and above can delete a project. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PrivateProjectDeleteWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectDelete");

            var localVarPath = "/account/projects/{project_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete project A project can be deleted only if: - it is not public - it does not have public articles.  When an individual project is deleted, all the articles are moved to my data of each owner.  When a group project is deleted, all the articles and files are deleted as well. Only project owner, group admin and above can delete a project. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PrivateProjectDeleteAsync (long? projectId)
        {
             await PrivateProjectDeleteAsyncWithHttpInfo(projectId);

        }

        /// <summary>
        /// Delete project A project can be deleted only if: - it is not public - it does not have public articles.  When an individual project is deleted, all the articles are moved to my data of each owner.  When a group project is deleted, all the articles and files are deleted as well. Only project owner, group admin and above can delete a project. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectDeleteAsyncWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectDelete");

            var localVarPath = "/account/projects/{project_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// View project details View a private project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ProjectCompletePrivate</returns>
        public ProjectCompletePrivate PrivateProjectDetails (long? projectId)
        {
             ApiResponse<ProjectCompletePrivate> localVarResponse = PrivateProjectDetailsWithHttpInfo(projectId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// View project details View a private project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ApiResponse of ProjectCompletePrivate</returns>
        public ApiResponse< ProjectCompletePrivate > PrivateProjectDetailsWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectDetails");

            var localVarPath = "/account/projects/{project_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectCompletePrivate>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectCompletePrivate) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectCompletePrivate)));
        }

        /// <summary>
        /// View project details View a private project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ProjectCompletePrivate</returns>
        public async System.Threading.Tasks.Task<ProjectCompletePrivate> PrivateProjectDetailsAsync (long? projectId)
        {
             ApiResponse<ProjectCompletePrivate> localVarResponse = await PrivateProjectDetailsAsyncWithHttpInfo(projectId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// View project details View a private project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ApiResponse (ProjectCompletePrivate)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectCompletePrivate>> PrivateProjectDetailsAsyncWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectDetails");

            var localVarPath = "/account/projects/{project_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectCompletePrivate>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectCompletePrivate) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectCompletePrivate)));
        }

        /// <summary>
        /// Private Project Leave Please note: project&#39;s owner cannot leave the project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns></returns>
        public void PrivateProjectLeave (long? projectId)
        {
             PrivateProjectLeaveWithHttpInfo(projectId);
        }

        /// <summary>
        /// Private Project Leave Please note: project&#39;s owner cannot leave the project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PrivateProjectLeaveWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectLeave");

            var localVarPath = "/account/projects/{project_id}/leave";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectLeave", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Private Project Leave Please note: project&#39;s owner cannot leave the project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PrivateProjectLeaveAsync (long? projectId)
        {
             await PrivateProjectLeaveAsyncWithHttpInfo(projectId);

        }

        /// <summary>
        /// Private Project Leave Please note: project&#39;s owner cannot leave the project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectLeaveAsyncWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectLeave");

            var localVarPath = "/account/projects/{project_id}/leave";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectLeave", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Project note details 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>ProjectNotePrivate</returns>
        public ProjectNotePrivate PrivateProjectNote (long? projectId, long? noteId)
        {
             ApiResponse<ProjectNotePrivate> localVarResponse = PrivateProjectNoteWithHttpInfo(projectId, noteId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Project note details 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>ApiResponse of ProjectNotePrivate</returns>
        public ApiResponse< ProjectNotePrivate > PrivateProjectNoteWithHttpInfo (long? projectId, long? noteId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectNote");
            // verify the required parameter 'noteId' is set
            if (noteId == null)
                throw new ApiException(400, "Missing required parameter 'noteId' when calling ProjectsApi->PrivateProjectNote");

            var localVarPath = "/account/projects/{project_id}/notes/{note_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (noteId != null) localVarPathParams.Add("note_id", this.Configuration.ApiClient.ParameterToString(noteId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectNote", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectNotePrivate>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectNotePrivate) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectNotePrivate)));
        }

        /// <summary>
        /// Project note details 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>Task of ProjectNotePrivate</returns>
        public async System.Threading.Tasks.Task<ProjectNotePrivate> PrivateProjectNoteAsync (long? projectId, long? noteId)
        {
             ApiResponse<ProjectNotePrivate> localVarResponse = await PrivateProjectNoteAsyncWithHttpInfo(projectId, noteId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Project note details 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>Task of ApiResponse (ProjectNotePrivate)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectNotePrivate>> PrivateProjectNoteAsyncWithHttpInfo (long? projectId, long? noteId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectNote");
            // verify the required parameter 'noteId' is set
            if (noteId == null)
                throw new ApiException(400, "Missing required parameter 'noteId' when calling ProjectsApi->PrivateProjectNote");

            var localVarPath = "/account/projects/{project_id}/notes/{note_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (noteId != null) localVarPathParams.Add("note_id", this.Configuration.ApiClient.ParameterToString(noteId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectNote", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectNotePrivate>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectNotePrivate) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectNotePrivate)));
        }

        /// <summary>
        /// Delete project note 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns></returns>
        public void PrivateProjectNoteDelete (long? projectId, long? noteId)
        {
             PrivateProjectNoteDeleteWithHttpInfo(projectId, noteId);
        }

        /// <summary>
        /// Delete project note 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PrivateProjectNoteDeleteWithHttpInfo (long? projectId, long? noteId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectNoteDelete");
            // verify the required parameter 'noteId' is set
            if (noteId == null)
                throw new ApiException(400, "Missing required parameter 'noteId' when calling ProjectsApi->PrivateProjectNoteDelete");

            var localVarPath = "/account/projects/{project_id}/notes/{note_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (noteId != null) localVarPathParams.Add("note_id", this.Configuration.ApiClient.ParameterToString(noteId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectNoteDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete project note 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PrivateProjectNoteDeleteAsync (long? projectId, long? noteId)
        {
             await PrivateProjectNoteDeleteAsyncWithHttpInfo(projectId, noteId);

        }

        /// <summary>
        /// Delete project note 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectNoteDeleteAsyncWithHttpInfo (long? projectId, long? noteId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectNoteDelete");
            // verify the required parameter 'noteId' is set
            if (noteId == null)
                throw new ApiException(400, "Missing required parameter 'noteId' when calling ProjectsApi->PrivateProjectNoteDelete");

            var localVarPath = "/account/projects/{project_id}/notes/{note_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (noteId != null) localVarPathParams.Add("note_id", this.Configuration.ApiClient.ParameterToString(noteId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectNoteDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Update project note 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns></returns>
        public void PrivateProjectNoteUpdate (long? projectId, long? noteId, ProjectNoteCreate note)
        {
             PrivateProjectNoteUpdateWithHttpInfo(projectId, noteId, note);
        }

        /// <summary>
        /// Update project note 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PrivateProjectNoteUpdateWithHttpInfo (long? projectId, long? noteId, ProjectNoteCreate note)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectNoteUpdate");
            // verify the required parameter 'noteId' is set
            if (noteId == null)
                throw new ApiException(400, "Missing required parameter 'noteId' when calling ProjectsApi->PrivateProjectNoteUpdate");
            // verify the required parameter 'note' is set
            if (note == null)
                throw new ApiException(400, "Missing required parameter 'note' when calling ProjectsApi->PrivateProjectNoteUpdate");

            var localVarPath = "/account/projects/{project_id}/notes/{note_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (noteId != null) localVarPathParams.Add("note_id", this.Configuration.ApiClient.ParameterToString(noteId)); // path parameter
            if (note != null && note.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(note); // http body (model) parameter
            }
            else
            {
                localVarPostBody = note; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectNoteUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Update project note 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PrivateProjectNoteUpdateAsync (long? projectId, long? noteId, ProjectNoteCreate note)
        {
             await PrivateProjectNoteUpdateAsyncWithHttpInfo(projectId, noteId, note);

        }

        /// <summary>
        /// Update project note 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="noteId">Note unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectNoteUpdateAsyncWithHttpInfo (long? projectId, long? noteId, ProjectNoteCreate note)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectNoteUpdate");
            // verify the required parameter 'noteId' is set
            if (noteId == null)
                throw new ApiException(400, "Missing required parameter 'noteId' when calling ProjectsApi->PrivateProjectNoteUpdate");
            // verify the required parameter 'note' is set
            if (note == null)
                throw new ApiException(400, "Missing required parameter 'note' when calling ProjectsApi->PrivateProjectNoteUpdate");

            var localVarPath = "/account/projects/{project_id}/notes/{note_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (noteId != null) localVarPathParams.Add("note_id", this.Configuration.ApiClient.ParameterToString(noteId)); // path parameter
            if (note != null && note.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(note); // http body (model) parameter
            }
            else
            {
                localVarPostBody = note; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectNoteUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Create project note Create a new project note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>Location</returns>
        public Location PrivateProjectNotesCreate (long? projectId, ProjectNoteCreate note)
        {
             ApiResponse<Location> localVarResponse = PrivateProjectNotesCreateWithHttpInfo(projectId, note);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create project note Create a new project note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>ApiResponse of Location</returns>
        public ApiResponse< Location > PrivateProjectNotesCreateWithHttpInfo (long? projectId, ProjectNoteCreate note)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectNotesCreate");
            // verify the required parameter 'note' is set
            if (note == null)
                throw new ApiException(400, "Missing required parameter 'note' when calling ProjectsApi->PrivateProjectNotesCreate");

            var localVarPath = "/account/projects/{project_id}/notes";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (note != null && note.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(note); // http body (model) parameter
            }
            else
            {
                localVarPostBody = note; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectNotesCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Location>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Location) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Location)));
        }

        /// <summary>
        /// Create project note Create a new project note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>Task of Location</returns>
        public async System.Threading.Tasks.Task<Location> PrivateProjectNotesCreateAsync (long? projectId, ProjectNoteCreate note)
        {
             ApiResponse<Location> localVarResponse = await PrivateProjectNotesCreateAsyncWithHttpInfo(projectId, note);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create project note Create a new project note
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="note">Note message</param>
        /// <returns>Task of ApiResponse (Location)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Location>> PrivateProjectNotesCreateAsyncWithHttpInfo (long? projectId, ProjectNoteCreate note)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectNotesCreate");
            // verify the required parameter 'note' is set
            if (note == null)
                throw new ApiException(400, "Missing required parameter 'note' when calling ProjectsApi->PrivateProjectNotesCreate");

            var localVarPath = "/account/projects/{project_id}/notes";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (note != null && note.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(note); // http body (model) parameter
            }
            else
            {
                localVarPostBody = note; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectNotesCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Location>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Location) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Location)));
        }

        /// <summary>
        /// List project notes List project notes
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>List&lt;ProjectNote&gt;</returns>
        public List<ProjectNote> PrivateProjectNotesList (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null)
        {
             ApiResponse<List<ProjectNote>> localVarResponse = PrivateProjectNotesListWithHttpInfo(projectId, page, pageSize, limit, offset);
             return localVarResponse.Data;
        }

        /// <summary>
        /// List project notes List project notes
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>ApiResponse of List&lt;ProjectNote&gt;</returns>
        public ApiResponse< List<ProjectNote> > PrivateProjectNotesListWithHttpInfo (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectNotesList");

            var localVarPath = "/account/projects/{project_id}/notes";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectNotesList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ProjectNote>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ProjectNote>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ProjectNote>)));
        }

        /// <summary>
        /// List project notes List project notes
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of List&lt;ProjectNote&gt;</returns>
        public async System.Threading.Tasks.Task<List<ProjectNote>> PrivateProjectNotesListAsync (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null)
        {
             ApiResponse<List<ProjectNote>> localVarResponse = await PrivateProjectNotesListAsyncWithHttpInfo(projectId, page, pageSize, limit, offset);
             return localVarResponse.Data;

        }

        /// <summary>
        /// List project notes List project notes
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ProjectNote&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<ProjectNote>>> PrivateProjectNotesListAsyncWithHttpInfo (long? projectId, long? page = null, long? pageSize = null, long? limit = null, long? offset = null)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectNotesList");

            var localVarPath = "/account/projects/{project_id}/notes";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectNotesList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ProjectNote>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ProjectNote>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ProjectNote>)));
        }

        /// <summary>
        /// Private Project Publish Publish a project. Possible after all items inside it are public
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ResponseMessage</returns>
        public ResponseMessage PrivateProjectPublish (long? projectId)
        {
             ApiResponse<ResponseMessage> localVarResponse = PrivateProjectPublishWithHttpInfo(projectId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Project Publish Publish a project. Possible after all items inside it are public
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>ApiResponse of ResponseMessage</returns>
        public ApiResponse< ResponseMessage > PrivateProjectPublishWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectPublish");

            var localVarPath = "/account/projects/{project_id}/publish";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectPublish", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseMessage>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ResponseMessage) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseMessage)));
        }

        /// <summary>
        /// Private Project Publish Publish a project. Possible after all items inside it are public
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ResponseMessage</returns>
        public async System.Threading.Tasks.Task<ResponseMessage> PrivateProjectPublishAsync (long? projectId)
        {
             ApiResponse<ResponseMessage> localVarResponse = await PrivateProjectPublishAsyncWithHttpInfo(projectId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Project Publish Publish a project. Possible after all items inside it are public
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <returns>Task of ApiResponse (ResponseMessage)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseMessage>> PrivateProjectPublishAsyncWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectPublish");

            var localVarPath = "/account/projects/{project_id}/publish";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectPublish", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseMessage>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ResponseMessage) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseMessage)));
        }

        /// <summary>
        /// Update project Updating an project by passing body parameters; request can also be made with the PATCH method.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="project">Project description</param>
        /// <returns></returns>
        public void PrivateProjectUpdate (long? projectId, ProjectUpdate project)
        {
             PrivateProjectUpdateWithHttpInfo(projectId, project);
        }

        /// <summary>
        /// Update project Updating an project by passing body parameters; request can also be made with the PATCH method.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="project">Project description</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PrivateProjectUpdateWithHttpInfo (long? projectId, ProjectUpdate project)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectUpdate");
            // verify the required parameter 'project' is set
            if (project == null)
                throw new ApiException(400, "Missing required parameter 'project' when calling ProjectsApi->PrivateProjectUpdate");

            var localVarPath = "/account/projects/{project_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (project != null && project.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(project); // http body (model) parameter
            }
            else
            {
                localVarPostBody = project; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Update project Updating an project by passing body parameters; request can also be made with the PATCH method.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="project">Project description</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PrivateProjectUpdateAsync (long? projectId, ProjectUpdate project)
        {
             await PrivateProjectUpdateAsyncWithHttpInfo(projectId, project);

        }

        /// <summary>
        /// Update project Updating an project by passing body parameters; request can also be made with the PATCH method.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project unique identifier</param>
        /// <param name="project">Project description</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PrivateProjectUpdateAsyncWithHttpInfo (long? projectId, ProjectUpdate project)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->PrivateProjectUpdate");
            // verify the required parameter 'project' is set
            if (project == null)
                throw new ApiException(400, "Missing required parameter 'project' when calling ProjectsApi->PrivateProjectUpdate");

            var localVarPath = "/account/projects/{project_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter
            if (project != null && project.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(project); // http body (model) parameter
            }
            else
            {
                localVarPostBody = project; // byte array
            }

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Private Projects List private projects
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="storage">only return collections from this institution (optional)</param>
        /// <param name="roles">Any combination of owner, collaborator, viewer separated by comma. Examples: \&quot;owner\&quot; or \&quot;owner,collaborator\&quot;. (optional)</param>
        /// <returns>List&lt;ProjectPrivate&gt;</returns>
        public List<ProjectPrivate> PrivateProjectsList (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string storage = null, string roles = null)
        {
             ApiResponse<List<ProjectPrivate>> localVarResponse = PrivateProjectsListWithHttpInfo(page, pageSize, limit, offset, order, orderDirection, storage, roles);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Projects List private projects
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="storage">only return collections from this institution (optional)</param>
        /// <param name="roles">Any combination of owner, collaborator, viewer separated by comma. Examples: \&quot;owner\&quot; or \&quot;owner,collaborator\&quot;. (optional)</param>
        /// <returns>ApiResponse of List&lt;ProjectPrivate&gt;</returns>
        public ApiResponse< List<ProjectPrivate> > PrivateProjectsListWithHttpInfo (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string storage = null, string roles = null)
        {

            var localVarPath = "/account/projects";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (order != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "order", order)); // query parameter
            if (orderDirection != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "order_direction", orderDirection)); // query parameter
            if (storage != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "storage", storage)); // query parameter
            if (roles != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "roles", roles)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectsList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ProjectPrivate>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ProjectPrivate>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ProjectPrivate>)));
        }

        /// <summary>
        /// Private Projects List private projects
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="storage">only return collections from this institution (optional)</param>
        /// <param name="roles">Any combination of owner, collaborator, viewer separated by comma. Examples: \&quot;owner\&quot; or \&quot;owner,collaborator\&quot;. (optional)</param>
        /// <returns>Task of List&lt;ProjectPrivate&gt;</returns>
        public async System.Threading.Tasks.Task<List<ProjectPrivate>> PrivateProjectsListAsync (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string storage = null, string roles = null)
        {
             ApiResponse<List<ProjectPrivate>> localVarResponse = await PrivateProjectsListAsyncWithHttpInfo(page, pageSize, limit, offset, order, orderDirection, storage, roles);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Projects List private projects
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="storage">only return collections from this institution (optional)</param>
        /// <param name="roles">Any combination of owner, collaborator, viewer separated by comma. Examples: \&quot;owner\&quot; or \&quot;owner,collaborator\&quot;. (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ProjectPrivate&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<ProjectPrivate>>> PrivateProjectsListAsyncWithHttpInfo (long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, string storage = null, string roles = null)
        {

            var localVarPath = "/account/projects";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (order != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "order", order)); // query parameter
            if (orderDirection != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "order_direction", orderDirection)); // query parameter
            if (storage != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "storage", storage)); // query parameter
            if (roles != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "roles", roles)); // query parameter

            // authentication (OAuth2) required
            // oauth required
            if (!String.IsNullOrEmpty(this.Configuration.AccessToken))
            {
                localVarHeaderParams["Authorization"] = "Bearer " + this.Configuration.AccessToken;
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectsList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ProjectPrivate>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ProjectPrivate>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ProjectPrivate>)));
        }

        /// <summary>
        /// Private Projects search Search inside the private projects
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>List&lt;ProjectPrivate&gt;</returns>
        public List<ProjectPrivate> PrivateProjectsSearch (ProjectsSearch search = null)
        {
             ApiResponse<List<ProjectPrivate>> localVarResponse = PrivateProjectsSearchWithHttpInfo(search);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Private Projects search Search inside the private projects
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>ApiResponse of List&lt;ProjectPrivate&gt;</returns>
        public ApiResponse< List<ProjectPrivate> > PrivateProjectsSearchWithHttpInfo (ProjectsSearch search = null)
        {

            var localVarPath = "/account/projects/search";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (search != null && search.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(search); // http body (model) parameter
            }
            else
            {
                localVarPostBody = search; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectsSearch", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ProjectPrivate>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ProjectPrivate>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ProjectPrivate>)));
        }

        /// <summary>
        /// Private Projects search Search inside the private projects
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>Task of List&lt;ProjectPrivate&gt;</returns>
        public async System.Threading.Tasks.Task<List<ProjectPrivate>> PrivateProjectsSearchAsync (ProjectsSearch search = null)
        {
             ApiResponse<List<ProjectPrivate>> localVarResponse = await PrivateProjectsSearchAsyncWithHttpInfo(search);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Private Projects search Search inside the private projects
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ProjectPrivate&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<ProjectPrivate>>> PrivateProjectsSearchAsyncWithHttpInfo (ProjectsSearch search = null)
        {

            var localVarPath = "/account/projects/search";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (search != null && search.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(search); // http body (model) parameter
            }
            else
            {
                localVarPostBody = search; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PrivateProjectsSearch", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ProjectPrivate>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ProjectPrivate>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ProjectPrivate>)));
        }

        /// <summary>
        /// Public Project Articles List articles in project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>List&lt;Article&gt;</returns>
        public List<Article> ProjectArticles (long? projectId)
        {
             ApiResponse<List<Article>> localVarResponse = ProjectArticlesWithHttpInfo(projectId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Public Project Articles List articles in project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>ApiResponse of List&lt;Article&gt;</returns>
        public ApiResponse< List<Article> > ProjectArticlesWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->ProjectArticles");

            var localVarPath = "/projects/{project_id}/articles";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ProjectArticles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Article>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Article>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Article>)));
        }

        /// <summary>
        /// Public Project Articles List articles in project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>Task of List&lt;Article&gt;</returns>
        public async System.Threading.Tasks.Task<List<Article>> ProjectArticlesAsync (long? projectId)
        {
             ApiResponse<List<Article>> localVarResponse = await ProjectArticlesAsyncWithHttpInfo(projectId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Public Project Articles List articles in project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>Task of ApiResponse (List&lt;Article&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Article>>> ProjectArticlesAsyncWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->ProjectArticles");

            var localVarPath = "/projects/{project_id}/articles";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ProjectArticles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Article>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Article>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Article>)));
        }

        /// <summary>
        /// Public Project View a project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>ProjectComplete</returns>
        public ProjectComplete ProjectDetails (long? projectId)
        {
             ApiResponse<ProjectComplete> localVarResponse = ProjectDetailsWithHttpInfo(projectId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Public Project View a project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>ApiResponse of ProjectComplete</returns>
        public ApiResponse< ProjectComplete > ProjectDetailsWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->ProjectDetails");

            var localVarPath = "/projects/{project_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ProjectDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectComplete>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectComplete) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectComplete)));
        }

        /// <summary>
        /// Public Project View a project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>Task of ProjectComplete</returns>
        public async System.Threading.Tasks.Task<ProjectComplete> ProjectDetailsAsync (long? projectId)
        {
             ApiResponse<ProjectComplete> localVarResponse = await ProjectDetailsAsyncWithHttpInfo(projectId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Public Project View a project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectId">Project Unique identifier</param>
        /// <returns>Task of ApiResponse (ProjectComplete)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectComplete>> ProjectDetailsAsyncWithHttpInfo (long? projectId)
        {
            // verify the required parameter 'projectId' is set
            if (projectId == null)
                throw new ApiException(400, "Missing required parameter 'projectId' when calling ProjectsApi->ProjectDetails");

            var localVarPath = "/projects/{project_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectId != null) localVarPathParams.Add("project_id", this.Configuration.ApiClient.ParameterToString(projectId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ProjectDetails", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectComplete>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectComplete) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectComplete)));
        }

        /// <summary>
        /// Public Projects Returns a list of public projects
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="institution">only return collections from this institution (optional)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="group">only return collections from this group (optional)</param>
        /// <returns>List&lt;Project&gt;</returns>
        public List<Project> ProjectsList (Guid? xCursor = null, long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, long? institution = null, string publishedSince = null, long? group = null)
        {
             ApiResponse<List<Project>> localVarResponse = ProjectsListWithHttpInfo(xCursor, page, pageSize, limit, offset, order, orderDirection, institution, publishedSince, group);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Public Projects Returns a list of public projects
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="institution">only return collections from this institution (optional)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="group">only return collections from this group (optional)</param>
        /// <returns>ApiResponse of List&lt;Project&gt;</returns>
        public ApiResponse< List<Project> > ProjectsListWithHttpInfo (Guid? xCursor = null, long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, long? institution = null, string publishedSince = null, long? group = null)
        {

            var localVarPath = "/projects";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (order != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "order", order)); // query parameter
            if (orderDirection != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "order_direction", orderDirection)); // query parameter
            if (institution != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "institution", institution)); // query parameter
            if (publishedSince != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "published_since", publishedSince)); // query parameter
            if (group != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "group", group)); // query parameter
            if (xCursor != null) localVarHeaderParams.Add("X-Cursor", this.Configuration.ApiClient.ParameterToString(xCursor)); // header parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ProjectsList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Project>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Project>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Project>)));
        }

        /// <summary>
        /// Public Projects Returns a list of public projects
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="institution">only return collections from this institution (optional)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="group">only return collections from this group (optional)</param>
        /// <returns>Task of List&lt;Project&gt;</returns>
        public async System.Threading.Tasks.Task<List<Project>> ProjectsListAsync (Guid? xCursor = null, long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, long? institution = null, string publishedSince = null, long? group = null)
        {
             ApiResponse<List<Project>> localVarResponse = await ProjectsListAsyncWithHttpInfo(xCursor, page, pageSize, limit, offset, order, orderDirection, institution, publishedSince, group);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Public Projects Returns a list of public projects
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="page">Page number. Used for pagination with page_size (optional)</param>
        /// <param name="pageSize">The number of results included on a page. Used for pagination with page (optional, default to 10)</param>
        /// <param name="limit">Number of results included on a page. Used for pagination with query (optional)</param>
        /// <param name="offset">Where to start the listing(the offset of the first result). Used for pagination with limit (optional)</param>
        /// <param name="order">The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)</param>
        /// <param name="orderDirection"> (optional, default to desc)</param>
        /// <param name="institution">only return collections from this institution (optional)</param>
        /// <param name="publishedSince">Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)</param>
        /// <param name="group">only return collections from this group (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Project&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Project>>> ProjectsListAsyncWithHttpInfo (Guid? xCursor = null, long? page = null, long? pageSize = null, long? limit = null, long? offset = null, string order = null, string orderDirection = null, long? institution = null, string publishedSince = null, long? group = null)
        {

            var localVarPath = "/projects";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (page != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (pageSize != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "page_size", pageSize)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (order != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "order", order)); // query parameter
            if (orderDirection != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "order_direction", orderDirection)); // query parameter
            if (institution != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "institution", institution)); // query parameter
            if (publishedSince != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "published_since", publishedSince)); // query parameter
            if (group != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "group", group)); // query parameter
            if (xCursor != null) localVarHeaderParams.Add("X-Cursor", this.Configuration.ApiClient.ParameterToString(xCursor)); // header parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ProjectsList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Project>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Project>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Project>)));
        }

        /// <summary>
        /// Public Projects Search Returns a list of public articles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>List&lt;Project&gt;</returns>
        public List<Project> ProjectsSearch (Guid? xCursor = null, ProjectsSearch search = null)
        {
             ApiResponse<List<Project>> localVarResponse = ProjectsSearchWithHttpInfo(xCursor, search);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Public Projects Search Returns a list of public articles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>ApiResponse of List&lt;Project&gt;</returns>
        public ApiResponse< List<Project> > ProjectsSearchWithHttpInfo (Guid? xCursor = null, ProjectsSearch search = null)
        {

            var localVarPath = "/projects/search";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (xCursor != null) localVarHeaderParams.Add("X-Cursor", this.Configuration.ApiClient.ParameterToString(xCursor)); // header parameter
            if (search != null && search.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(search); // http body (model) parameter
            }
            else
            {
                localVarPostBody = search; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ProjectsSearch", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Project>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Project>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Project>)));
        }

        /// <summary>
        /// Public Projects Search Returns a list of public articles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>Task of List&lt;Project&gt;</returns>
        public async System.Threading.Tasks.Task<List<Project>> ProjectsSearchAsync (Guid? xCursor = null, ProjectsSearch search = null)
        {
             ApiResponse<List<Project>> localVarResponse = await ProjectsSearchAsyncWithHttpInfo(xCursor, search);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Public Projects Search Returns a list of public articles
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="xCursor">Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)</param>
        /// <param name="search">Search Parameters (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;Project&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Project>>> ProjectsSearchAsyncWithHttpInfo (Guid? xCursor = null, ProjectsSearch search = null)
        {

            var localVarPath = "/projects/search";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (xCursor != null) localVarHeaderParams.Add("X-Cursor", this.Configuration.ApiClient.ParameterToString(xCursor)); // header parameter
            if (search != null && search.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(search); // http body (model) parameter
            }
            else
            {
                localVarPostBody = search; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ProjectsSearch", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Project>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Project>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Project>)));
        }

    }
}
